
C-------------------------------------------------------------------------------
C
C      Sammlung SUBROUTINES fuer Benson-Ansteuerung mit ALLPLO etc.
C                    25-SEP-1989
C
C       Sie enthaelt folgende Subroutines:
C       SCALE,VELO,NUMERO,NAXFOR,NFRAME
C       TRANS, ZEICH, TXTPLO, saemtliche Zeichensatze, sowie aus
C       der Benson-Library  die Subroutines:
C       FIN, PNUMA, IBENA, TRAA, PLUMA, BENES, DPACK, POSA, BECENA,
C       BCERCA, DELTA, PART, NUMBER, LINE.
C
c       pluma modifiziert fuer Rueckgabe der Federposition
c       M. Alflen  23-aug-1989                   
c     
c       txtplo modifiziert fuer Wahl der Feder
c       M. Alflen  25-aug-1989
c
c       line modifiziert fuer Wahl der Feder
c       M. Alflen  29-aug-1989
c
c	txtplo modifiziert fuer Umlaute
c	M. Alflen
c
c       zeich um 19 Zeichen erweitert
c       A.Vef      09-aug-1994
C-------------------------------------------------------------------------------
      SUBROUTINE TXTPLO (X0,Y0,ISTEU,ITEXT,NTEXT,
     &                   BREITE,HOEHE,COSA,SINA,X2,Y2,Z2)
C-------------------------------------------------------------------------------
C      PLOTTET EINEN TEXTSTRING  ITEXT  MIT  NTEXT  ZEICHEN IN VERSCHIEDENEN
C      SCHRIFTTYPEN  ( ROMAN, ITALIC, SCRIPT, GREEK )  MIT GROSSEN UND
C      KLEINEN BUCHSTABEN SOWIE SONDERZEICHEN
C      DIE VERWENDUNG ALS OBERER ODER UNTERER INDEX IST MOEGLICH
C      AUSSERDEM VERSCHIEDENE SYMBOLE ( SCHRIFTART 'ZEICHEN' ),
C      DIE AUCH ZENTRIERT GEZEICHNET WERDEN KOENNEN
C
C                                 EBERHARD MEISSNER  17.05.83
c
c      modifiziert fuer federwahl
c   
c                                 M. Alflen  25.8.89
c	modifiziert fuer Umlaute
c				  M. Alflen 28.2.1990
c       modifications             h.spiering 27.5.2008
c                  \y\Y   symbols included to the text
c                  $_,$^  according to Latex
c                  + 22 Zeichen called by name $\name 
c                         according to Latex
c                  9 colors called by @n  
c                  extra changes of charracter size
c                                   shift of upper and lower index
c       further in routines like addtxt.f:
c
c                  box rotates, colored area 
c                  colored frame areas
c                  colored background                
C------------------------------------------------------------------------------
C      FUER DEN BENUTZER:
C      -UMSCHALTUNG DER SCHRIFTTYPEN:
C       \R  ODER  \r   :  ROMAN  (VOREINSTELLUNG)
C       \I  ODER  \i   :  ITALIC
C       \S  ODER  \s   :  SCRIPT
C       \G  ODER  \g   :  GREEK
C       \Z  ODER  \z   :  ZEICHEN (signs)
C       \y             :  Symbol 01-33
C       \Y             :  gefuelltes Symbol 01-33

c        \,        2/5 : Leerzeichen
c        \!       -1/5 : Leerzeichen

c       \"a \"o \"u    : Umlaute
c        


C       $              :  Zurueck zum NORMALBUCHSTABEN  (VOREINSTELLUNG)
C       $^             :  OBERER INDEX
C       $_             :  UNTERER INDEX
C       $P  ODER  $p   :  POSITION FUER SPAETEREN RUECKSPRUNG
C       $B  ODER  $b   :  RUECKSPRUNG ZUR GEMERKTEN POSITION
C       $F  ODER  $f   :  SPRUNG VORWAERTS ZUM BISHERIGEN TEXTENDE
c       $H       *1.2  :  Buchstabengroesse
c       $h       /1.2  :  Buchstabengroesse
c       $U   (14+...)  :  > shift oberer Index
c       $u   (14-...)  :  < shift oberer Index
c       $D   (-7-...)  :  > shift unterer Index
c       $d   (-7+...)  :  < shift unterer Index
c       $m       m     :  multiple Zeichnung  (bold-m fach)
c       $\name         :  name of Zeichen up to 16 characters     

C      -UMSCHALTUNG Gross/Kleinschreibung und der Feder
c       @u oder @U     :  Grosschreibung
c       @l oder @L     :  Kleinschreibung
c       @c oder @C     :  case Standard

C       @n   n = 0...N :  Wahl der Feder (x11_ps_colors.txt legt N fest)
c
c
C------------------------------------------------------------------------------
C      FUER DEN PROGRAMMIERER :
C      -DIE ELEMENTE VON  CTEXT sind IM FORMAT  A1  BESCHRIEBEN 
C      -X0,Y0  SIND DIE KOORDINATEN DER LINKEN UNTEREN ECKE DES STRINGS,
C       BEI  ISTEU=2  DIE DES ZENTRUMS DES ERSTEN ZEICHEN DES STRINGS
C      -BREITE  UND  HOEHE  GELTEN FUER EINEN GROSSBUCHSTABEN WIE
C       ETWA "A"  ( UNTERLAENGEN UND SCHMALERE BUCHSTABEN KOMMEN VOR )
C      -COSA, SINA  SIND DER COSINUS UND DER SINUS DES WINKELS, DEN
C       DER TEXTSTRING MIT DER X-RICHTUNG DES PLOTTERS EINSCHLIESST
C      -X2,Y2  SIND DIE KOORDINATEN DER RECHTEN UNTEREN ECKE DES STRINGS
C       BEIM RUECKSPRUNG IN DAS RUFENDE PROGRAMM
C      -ISTEU >= 0   PLOTTEN VON  ITEXT :
C             = 1   STARTKOORDINATE LINKE UNTERE ECKE
C             = 2   STARTKOORDINATE ZENTRUM DES ERSTEN ZEICHENS
C             = 3   WIE  = 2  MIT VERBINDEN DER MITTEN DER ZEICHEN
C             < 0   BERECHNUNG VON  X2,Y2  OHNE PLOT
C------------------------------------------------------------------------------
      implicit none
      integer     NTEXT,ISTEU
      real        X0,Y0,BREITE,HOEHE,COSA,SINA,X2,Y2,Z2

      character*1 ICHAR1,ICHAR2,ICHAR3,ITEXT,IIC,
     &            ch1,sonderz*16,fsym*16
      DIMENSION   ICHAR1(26),ICHAR2(26),ICHAR3(37),ITEXT(NTEXT)
      integer    KOORD,ICHARG,ICHARN
      DIMENSION  KOORD(75),ICHARG(26),ICHARN(37),sonderz(43)


      integer ITYPE,INDEX,I6BIT,JTYPE,JNDEX,J6BIT,jumlaut,MARK,
     &        iold_pen,IC,i,j,jpm,IZEICH,IB,IX,IY,jumsiz,KC,IPEN,
     &        mult,nmult,i0,iloop,isymbol,k
      logical isymfill
      real    XB,YB,ZB,XF,YF,ZF,X1,Y1,Z1,H,B,
     &        HX,HY,X,Y,DX,DY,XSHIFT,YSHIFT,WID,HEI,YOFF,XOFF,
     &        XHALF,YHALF,XX1,XX2,YY1,YY2,XS,YS,bsize,usize,dsize,
     &        penfill,g6,g5 
      integer MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,
     &        N2MAX,ICAR,NMMAX,NCMAX
      COMMON /BENBUF/MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,
     &               N2MAX,ICAR,NMMAX,NCMAX,penfill
      integer        iIX,iIY,IBLOC 
      real                XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY    
      COMMON /BENXY/iIX,iIY,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY,IBLOC 
c     GROSSE BUCHSTABEN
      DATA ICHAR1 /'A','B','C','D','E','F','G','H','I','J','K','L','M',
     &             'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
C      KLEINE BUCHSTABEN
      DATA ICHAR2 /'a','b','c','d','e','f','g','h','i','j','k','l','m',
     &             'n','o','p','q','r','s','t','u','v','w','x','y','z'/
C      NUMERISCHE- UND SONDERZEICHEN
      character*1  ch44,IBLANK,IBSL,IAFFE,IDACH,IUMLAUT
      DATA ICHAR3 /'0','1','2','3','4','5','6','7','8','9','.',',',':',
     &             ';','!','?','<','>','&','$','/','(',')','*','-','+',
     &             '=','0','"','#','[',']','%','_','{','}','|'/
      DATA sonderz
     &        /'Int             ','Aring           ','underscore      ',
     &         'hat             ','rightarrow      ','leftarrow       ',
     &         'leftrightarrow  ','Rightarrow      ','Leftarrow       ',
     &         'Leftrightarrow  ','vert            ','uparrow         ',
     &         'downarrow       ','updownarrow     ','cdot            ',
     &         'parallel        ','neq             ','sim             ',
     &         'perp            ','approx          ','hbar            ',
     &         'at              ','backslash       ','number          ',
     &         'section         ','infty           ','int             ',
     &         'oint            ','sqrt            ','overscore       ',
     &         'frac            ','nabla           ','partial         ',
     &         'cap             ','supset          ','subset          ',
     &         'cup             ','tilde           ','propto          ',
     &         'geqq            ','leqq            ','pm              ',
     &         'mp              '/

c                  27           30           33
C      UMGEORDNETE STARTWERTE FUER GROSSE UND KLEINE GRIECH. BUCHSTABEN
      DATA ICHARG /1,2,7,4,5,21,3,22,9,0,10,11,12,
     &              13,15,16,8,17,18,19,20,0,24,14,23,6/
C      UMGEORDNETE STARTWERTE FUER ROMAN NUMERISCHE/SONDERZEICHEN
      DATA ICHARN /1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,27,28,
     &            29,30,21,22,23,20,24,25,26,17,18,37,31,32,33,34,
     &            35,36,38/

      ICHAR3(28)=char(44)
      IBLANK=' '
      IBSL=char(92)
      IAFFE=char(64)
      IDACH=char(94)
      IUMLAUT='"'
      i0=ichar('0')

c      if(ISTEU.eq.0) then
c       write(6,'(a)')'################ISTEU.eq.0'
c      else
c       write(6,'(a,i3)')'################ISTEU=',ISTEU
c      end if


c       write(6,'(a,i2,2x,80a1)')' TEXTPLO NTEXT ITEXT=',
c     &                     NTEXT,(ITEXT(i),i=1,NTEXT)
c       write(6,'(a)')'X0,Y0,ISTEU,ITEXT,NTEXT,BREITE,HOEHE,COSA,SINA'
c       write(6,'(2f10.2,i3,4g12.3)')X0,Y0,ISTEU,BREITE,HOEHE,COSA,SINA

C      VORBESETZEN VON SCHRIFTART (ROMAN) , INDEX (NORMAL), 6-BIT-ASCII (7-BIT)
      ITYPE = 1
      INDEX = 1
      I6BIT = 0
C      VORBESETZEN DER UMSCHALTINDIKATOREN
      JTYPE = 0
      JNDEX = 0
      J6BIT = 0
      jumlaut=0
C      VORBESETZUNG DER BUCHHALTER VON  @M, @B, @F
      MARK = 0
      XB = X0
      YB = Y0
      XF = X0
      YF = Y0
C
      X1 = X0
      Y1 = Y0
      Z1=HOEHE
      H = HOEHE/21.
      B = BREITE/20.
      bsize=1.
      usize=0.
      dsize=0.
      nmult=1

c     erfragen der gewaehlten Feder
c      write(6,'(a,10a3)')' ITEXT(I)=',(ITEXT(I),I=1,NTEXT)
      iold_pen=-1
      call PLUMA(iold_pen)
c      write(6,'(a,i4)')'b TXTPLO  iold_pen=',iold_pen  
C      SCHLEIFE UEBER ALLE  NTEXT  ZEICHEN
      IC=0
      DO while(  IC.lt.NTEXT)
       
       IC=IC+1
C      WAR DAS LETZTE ZEICHEN EIN UMSCHALTZEICHEN, SO DUERFEN NUR
C      BESTIMMTE ZEICHEN AUFTRETEN :   VERZWEIGUNG
      IF ( JTYPE.NE.0 ) GO TO 500
      IF ( JNDEX.NE.0 ) GO TO 600
      IF ( J6BIT.NE.0 ) GO TO 700
C      ES WURDE KEIN SCHALTZEICHEN ERWARTET
C
C      BLANK ODER UMSCHALTZEICHEN ?
   50 IF ( ITEXT(IC).EQ.IBLANK ) GO TO 800
      IF ( ITEXT(IC).EQ.IBSL )   GO TO 810
      IF ( ITEXT(IC).EQ.'$' )  GO TO 820
      IF ( ITEXT(IC).EQ.IAFFE )  GO TO 830
C      ES HANDELT SICH WEDER UM EIN BLANK NOCH UM EIN UMSCHALTZEICHEN
C
C      GROSSBUCHSTABE ?
  100 DO 110  I=1,26
      J = I
      IF ( ITEXT(IC).EQ.ICHAR1(I))GO TO 120
  110 CONTINUE
C      KEIN GROSSBUCHSTABE, WEITERSUCHEN
      GO TO 200
C      GROSSBUCHSTABE ERKANNT, VERZWEIGUNG NACH SCHRIFTTYP
C      FALLS JEDOCH  I6BIT  GESETZT IST, SOLL EIN KLEINER
C      BUCHSTABE GEZEICHNET WERDEN
  120 IF ( I6BIT.eq.2 ) GO TO 220
      GO TO (130,140,150,160,170), ITYPE
  130 CALL GROMAN (J,KOORD)
      GO TO 400
  140 CALL GITALI (J,KOORD)
      GO TO 400
  150 CALL GSCRIP (J,KOORD)
      GO TO 400
C      GRIECHISCHE BUCHSTABEN : ANDERE REIHENFOLGE DES ALPHABETS : UMORDNEN
  160 J = ICHARG(J)
C      "J" UND "V" GIBT ES NICHT : WIE BLANK BEHANDELN
      IF ( J.EQ.0 ) GO TO 800
      CALL GGREEK (J,KOORD)
      GO TO 400
C      SCHRIFTART  ZEICHEN :  BUCHSTABE ALS ZIFFER "0" INTERPRETIERT
  170 J = 0
      GO TO 360
C
C      KLEINBUCHSTABE ?
  200 DO 210  I=1,26
      J = I
      IF ( ITEXT(IC).EQ.ICHAR2(I) ) GO TO 215
  210 CONTINUE
C      KEIN KLEINBUCHSTABE, WEITERSUCHEN
      GO TO 300
C      KLEINBUCHSTABE ERKANNT, VERZWEIGUNG NACH SCHRIFTTYP
  215 IF ( I6BIT.eq.1 ) GO TO 120 

  220 GO TO (230,240,250,260,270), ITYPE
  230 continue
      CALL KROMAN (J,KOORD)
      GO TO 400
  240 CALL KITALI (J,KOORD)
      GO TO 400
  250 CALL KSCRIP (J,KOORD)
      GO TO 400
C      GRIECHISCHE BUCHSTABEN : ANDERE REIHENFOLGE DES ALPHABETS : UMORDNEN
  260 J = ICHARG(J)
C      "J" UND "V" GIBT ES NICHT : WIE BLANK BEHANDELN
      IF ( J.EQ.0 ) GO TO 800
      CALL KGREEK (J,KOORD)
      GO TO 400
C      SCHRIFTART  ZEICHEN :  BUCHSTABE ALS ZIFFER "0" INTERPRETIERT
  270 J = 0
      GO TO 360

C      NUMERISCHES- ODER SONDERZEICHEN ?
  300 continue
c     write(6,'(a,i2,a2,a1)')'3 ITEXT(',IC,')=',ITEXT(IC)
      DO 310  I=1,37
      J = I
      IF ( ITEXT(IC).EQ.ICHAR3(I) ) GO TO 320
  310 CONTINUE
C      KEIN NUMERISCHES- ODER SONDERZEICHEN
C      KANN NICHT IDENTIFIZIERT WERDEN : WIE BLANK BEHANDELN
      GO TO 800
C      NUM./SONDERZEICHEN ERKANNT, VERZWEIGUNG NACH SCHRIFTTYP
  320 GO TO (330,340,340,330,350,350), ITYPE
C      ROMAN  NUM./SONDERZEICHEN : ANDERE REIHENFOLGE : UMORDNEN
  330 J = ICHARN(J)
      CALL NROMAN (J,KOORD)
      GO TO 400
  340 if(J.eq.37)J=38 
      if(J.eq.30)J=37
      CALL NSCRIP (J,KOORD)
      GO TO 400
C      ZEICHEN: J=1,..,10  ENTSPRICHT ZIFFERN  0,..,9
  350 IF ( J.LE.10 ) J = J-1
C      J > 10 :  KEINE ZIFFER, WIE "0" BEHANDELN
      IF ( J.GT.10 ) J = 0
C
C      AUSWERTUNG FUER ZEICHEN (ITYPE=5)
C      HINTER \Z WURDE EINE ZIFFER (J=0,..,9) ODER EIN ANDERES ZEICHEN
C      GEFUNDEN (INTERPRETIERT ALS J=0). JE ZWEI SOLCHER ZEICHEN WERDEN
C      PAARWEISE ALS ZWEISTELLIGE INTEGERZAHL INTERPRETIERT.
  360 continue
      IZEICH =J
      if(IC+1.le.NTEXT)then
       J=ichar(ITEXT(IC+1))-i0
       if(J.ge.0.and.J.le.9)then
        IC=IC+1
        IZEICH=10*IZEICH+J
       end if
      end if
      J=IZEICH
      IF ( J.ge.1) GO TO 380
C      J = 0  ODER J > 32 :  FALSCHE EINGABE
C      MIT GEHOBENER FEDER NACH (X1,Y1), BEI  ISTEU = 3  GESENKTE FEDER
 370  IPEN = 0
      IF ( ISTEU.EQ.3 ) IPEN  = 1
      CALL TRAA (X1,Y1,IPEN)
      GO TO 1000
C     VORHANDENES ZEICHEN
  380 if(ITYPE.eq.5)then
        CALL ZEICH (J,KOORD)
        if(j.lt.0)goto 370
      else if(ITYPE.eq.6)then
       isymbol=J
       if(J.lt.1.or.J.gt.33) goto 370
       goto 490
      end if
      GO TO 400
C
C      DIE ZIELKOORDINATEN  KOORD  SIND VON DER RICHTIGEN SUBROUTINE UEBERNOMMEN
  400 if(J.lt.0)goto 491

      IPEN = 0
C      BREITE DES BUCHSTABENS  = IB
      IB = KOORD(1)
C      FALLS  ISTEU < 0 , SOLL NUR  X2,Y2  BERECHNET WERDEN
C      DAHER WERDEN DIE FAHRBEFEHLE UEBERSPRUNGEN
      IF ( ISTEU.LT.0 ) GO TO 900
C      FALLS  ISTEU = 3 :  VERBINDEN DER (X1,Y1)
      IF ( ISTEU.EQ.3 ) CALL TRAA (X1,Y1,1)
C      SCHLEIFE UEBER DIE FAHRBEFEHLE EINES BUCHSTABENS

      jpm=1
      do mult=1,nmult
       jpm=-jpm
       XS=X1+float(mult-1)*0.0125
       YS=Y1+float(mult-1)*0.0125   

      DO 470  J=2,75
      if(KOORD(J).lt.0) then
       IY = ( KOORD(J) - 30 ) / 100
      else
       IY = ( KOORD(J) + 30 ) / 100
      end if
      IX = KOORD(J) - 100*IY
C      IX = 50, IY = 50 :  BUCHSTABE ZU ENDE
C      IX = 50, IY =  0 :  PENUP (SONST STETS PENDOWN)
      IF ( IX.NE.50 ) GO TO 420
      IF ( IY.EQ.50 ) GO TO 480
      IF ( IY.NE. 0 ) GO TO 420
C      50, 0  GEFUNDEN :  PENUP   UND DANN NEUEN KOORDINATENPUNKT ANSTEUERN
      IPEN = 0
      GO TO 470
C      NORMALER KOORDINATENPUNKT
  420 CONTINUE
C      FALLS  ISTEU=2 : ZENTRIEREN DER ZEICHEN/BUCHSTABEN
      IF ( ISTEU.NE.2 ) GO TO 421
      IX = IX - IB/2
      IY = IY - 10
C      VERZWEIGUNG JE NACH INDEX
  421 GO TO (430,440,450), INDEX
C      NORMALES TEXTFORMAT
  430 HX = IX
      HY = IY
      GO TO 460
C      OBERER INDEX
  440 HX =  0.6*IX
      HY = (14.+usize)/bsize + 0.6*IY
      GO TO 460
C      UNTERER INDEX
  450 HX =  0.6*IX
      HY = -(7.+dsize)/bsize + 0.6*IY
C      BERECHNUNG DER ABSOLUTEN KOORDINATEN
  460 continue
       X = XS + ( HX*B*COSA - HY*H*SINA )
       Y = YS + ( HY*H*COSA + HX*B*SINA )
       CALL TRAA (X,Y,IPEN)
      IPEN = 1
  470 CONTINUE
  480 CONTINUE
c
c     Umlaute zeichnen
c
      IF (JUMLAUT .EQ. 1) THEN
       DX = 6.66 * ( B*SINA )
       DY = 6.66 * ( B*COSA )
       XSHIFT = 19.95 * (H*COSA )
       YSHIFT =-19.95 * (H*SINA )
       IF (ITYPE .EQ. 3 .AND. JUMSIZ .EQ. 0) THEN
        XSHIFT=XSHIFT*.8
        YSHIFT=YSHIFT*.8
       END IF
       IF (JUMSIZ .EQ. 1) THEN
         YSHIFT=YSHIFT*1.25
         XSHIFT=XSHIFT*1.25
       END IF
       WID=1.60*B
       HEI=1.68*H
       IF (INDEX .GT. 1) THEN
        IF (INDEX .EQ. 2) THEN
         YOFF=yshift*.33
         XOFF=xshift*.33
        END IF
        IF (INDEX .EQ. 3) THEN
         YOFF=-yshift*.8
         XOFF=-xshift*.8
        END IF
        DX=DX*.66
        DY=DY*.66
	WID=WID*.66
	HEI=HEI*.66
       ELSE
        YOFF=0.
        XOFF=0.
       END IF
       XHALF= DX/.33*IB/40
       YHALF= DY/.33*IB/40
       XX1 = YS + (XHALF-DX/2.) + (XOFF+XSHIFT)  
       XX2 = YS + (XHALF+DX/2.) + (XOFF+XSHIFT)
       YY1 = XS + (YOFF+YSHIFT) + (YHALF-DY/2.) 
       YY2 = XS + (YOFF+YSHIFT) + (YHALF+DY/2.)
c       write(6,'(a,6f10.3)')'YS,XS,YY1,XX1=',YS,XS,YY1,XX1
       CALL BECENA(YY1,XX1,0,14,WID,HEI,COSA,SINA)
       CALL BECENA(YY2,XX2,0,14,WID,HEI,COSA,SINA)
       CALL TRAA(XS,YS,0)
c       JUMLAUT=0
      END IF
      IPEN = 0
      end do    ! mult
      JUMLAUT=0

      goto 491
 490  continue
c      write(6,'(a,2i4)')' aplsub  isymfill,isymbol=',isymfill,isymbol
      YS=Y1+H*11*SINA+B*10*COSA
      XS=X1-B*10*SINA+H*11*COSA
c      write(6,'(a,i3,6f10.3)')'ISTEU,YS,XS,Y1,X1=',ISTEU,YS,XS,Y1,X1
      if(ISTEU.gt.0) then
      if(isymfill) then          
         iloop=ifix(amin1(B*14,H*16)/penfill)+1
         do k=1,iloop                    ! fill up symbol  
          g5=B*14-(k-1)*penfill
          if ( g5 .gt. 0 ) then
           g6=H*16-(k-1)*penfill
           if ( g6 .gt. 0 ) then
            if ( isymbol .ne. 33 ) then  
             call becena(XS,YS,0,isymbol,g5,g6,COSA,SINA) ! plot symbol
            else
             g5=(g5+g6)/4.                        
             CALL BCERCA (XS,YS,0,g5,90.,360.)         ! plot circle
            end if
           end if
          end if
         end do
      else
       if ( isymbol .ne. 33 ) then
        g5=B*14
        g6=H*16
        call becena(XS,YS,0,isymbol,g5,g6,COSA,SINA)
       else
        g5=(g5+g6)/4.                        
        CALL BCERCA (XS,YS,0,g5,90.,360.)         ! plot circle   
       end if
      end if
      end if
 491  continue

C      BUCHST./ZIFFER/ZEICHEN ABGEARBEITET
C      FALLS  ISTEU = 2,3 :  MIT GEHOBENER FEDER NACH (X1,Y1)
      IF ( ISTEU.EQ.2 .OR. ISTEU.EQ.3 ) CALL TRAA (X1,Y1,0)
      GO TO 900
C
C      ES WIRD EINE STEUERUNG DES SCHRIFTTYPES ERWARTET
C      ZULAESSIGE ZEICHEN SIND :
C          \R,r       ROMAN         ITYPE = 1
C          \I,i       ITALIC        ITYPE = 2
C          \S,s       SCRIPT        ITYPE = 3
C          \G,g       GREEK         ITYPE = 4
C          \Z,z       ZEICHEN       ITYPE = 5
c          \,        2/5   Leerzeichen
c          \!       -1/5   Leerzeichen

c          \"a \"o \"u      Umlaute

  500 JTYPE = 0
      ch1=ITEXT(IC)
      if( ch1.eq.'r'.or.ch1.eq.'R')then
C      SCHRIFTTYP  ROMAN  GEWUENSCHT
       ITYPE = 1
      else if( ch1.eq.'i'.or.ch1.eq.'I')then
C      SCHRIFTTYP  ITALIC  GEWUENSCHT
       ITYPE = 2
      else if( ch1.eq.'s'.or.ch1.eq.'S')then
C      SCHRIFTTYP  SCRIPT  GEWUENSCHT
       ITYPE = 3
      else if( ch1.eq.'g'.or.ch1.eq.'G')then
C      SCHRIFTTYP  GREEK  GEWUENSCHT
       ITYPE = 4
      else if( ch1.eq.'z'.or.ch1.eq.'Z')then
C      SCHRIFTART  ZEICHEN  GEWUENSCHT
       ITYPE = 5
      else if( ch1.eq.'y')then
C      SCHRIFTART  Symbol  GEWUENSCHT
       ITYPE = 6
       isymfill=.false.
      else if( ch1.eq.'Y')then
C      SCHRIFTART gefuelltes Symbol  GEWUENSCHT
       ITYPE = 6
       isymfill=.true.
      else if( ch1.eq.',')then
C      Blank der Groesse \, gefunden
       GO TO 801
      else if( ch1.eq.'!')then
C      Blank der Groesse \! gefunden (Ruecksetzung)
       GO TO 802
      else if( ch1.eq.'"')then
C      \" gefunden (UMLAUT)
       GO TO 840
      else if( ch1.eq.'$')then      
C      \$  gefunden Steuerzeichen $ wird gezeichnet
       GO TO 300
      else if( ch1.eq.IBSL)then      
C      \\  gefunden Steuerzeichen $ wird gezeichnet
       J=23
       CALL ZEICH (J,KOORD)
       GO TO 400
      else if( ch1.eq.IAFFE)then      
C      \@  gefunden Steuerzeichen $ wird gezeichnet
       J=22
       CALL ZEICH (J,KOORD)
       GO TO 400
      end if
      GO TO 1000
C
C      ES WIRD EINE STEUERUNG DES INDEX ERWARTET
C      ZULAESSIGE ZEICHEN SIND : 
c          $
C          $^         OBERER INDEX     INDEX = 2
C          $_         UNTERER INDEX    INDEX = 3
C          $P,p       POSITION X1,Y1 MERKEN
C          $B,b       ZURUECK ZUR GEMERKTEN POSITION
C          $F,f       VORWAERTS ZUR BISHER WEITESTEN POSITION
c          $H         *1.2   Buchstabengroesse
c          $h         /1.2   Buchstabengroesse
c       $U   (14+...)  :  > shift oberer Index
c       $u   (14-...)  :  < shift oberer Index
c       $D   (-7-...)  :  > shift unterer Index
c       $d   (-7+...)  :  < shift unterer Index
c          $m         m     multiple Zeichnung  (bold)
          
  600 ch1=ITEXT(IC)
      JNDEX = 0
       i=ichar(ch1)-i0
       if(i.gt.0.and.i.lt.10) ch1='m'
C      NORMALBUCHSTABE GEWUENSCHT
      if(ch1.eq.'^')then
C      OBERER INDEX GEWUENSCHT
       INDEX = 2
      else if(ch1.eq.'_')then
C      UNTERER INDEX GEWUENSCHT
       INDEX = 3
      else if( ch1.eq.'H')then
C      $H  gefunden Buchstabengroesse *1.2
       bsize=bsize*1.2
       H=H*1.2
       B=B*1.2
      else if( ch1.eq.'h')then
C      $h  gefunden Buchstabengroesse /1.2
       bsize=bsize/1.2
       H=H/1.2
       B=B/1.2
      else if( ch1.eq.'U')then
C      $h  gefunden Buchstabengroesse /1.2
       usize=usize+3
      else if( ch1.eq.'u')then
C      $h  gefunden Buchstabengroesse /1.2
       usize=usize-3
      else if( ch1.eq.'D')then
C      $h  gefunden Buchstabengroesse /1.2
       dsize=dsize+3
      else if( ch1.eq.'d')then
C      $h  gefunden Buchstabengroesse /1.2
       dsize=dsize-3
      else if( ch1.eq.'m')then
C      $m  gefunden Buchstabengroesse 
       nmult=i
      else if(ch1.eq.'p'.or.ch1.eq.'P')then
C      MERKEN DER AKTUELLEN X1,Y1 AUF XB,YB
       MARK = 1
       XB = X1
       YB = Y1
       ZB = Z1
      else if(ch1.eq.'b'.or.ch1.eq.'B')then
C      RUECKSPRUNG AUF (XB,YB),
C      MERKEN DER AKTUELLEN X1,Y1 AUF XF,YF
       IF ( MARK.EQ.0 ) GO TO 1000
C      RUECKSPRUNGSTELLE BEKANNT
       XF = X1
       YF = Y1
       ZF = Z1
       X1 = XB
       Y1 = YB
       Z1 = ZB
      else if(ch1.eq.'f'.or.ch1.eq.'F')then
C      SPRUNG AUF (XF,YF), FALLS DIESER WEITER RECHTS STEHT
C      ALS DAS AKTUELLE (X1,Y1)
       MARK = 0
       IF ( (X1-XF)*COSA.lt.0) X1 = XF
       IF ( (Y1-YF)*SINA.lt.0) Y1 = YF
       IF ( (Z1-ZF)*SINA.lt.0) Z1 = ZF
      else if(ch1.eq.' ')then
       H=H/bsize
       B=B/bsize
       nmult=1 
       INDEX=1
      else if(ch1.eq.IBSL)then
       IC=IC+1
       ch1=ITEXT(IC)
       i=1
       do while(ch1.ne.' '.and.ch1.ne.'$'.and.ch1.ne.'@'
     &           .and.ch1.ne.IBSL.and.IC.le.NTEXT)
        fsym(i:i)=ch1
c        write(6,'(i4,2a)')IC,'   fsym=',fsym(:i)
        i=i+1
        IC=IC+1
        if(IC.gt.NTEXT)then
         ch1='$'
        else
         ch1=ITEXT(IC)
        end if
       end do
       IC=IC-1 
       i=i-1
c        write(6,'(2i4,2a)')NTEXT,IC,'  # fsym=',fsym(:i)
       J=1
       do while(fsym(:i).ne.sonderz(J)(:i).and.J.le.42)
        J=J+1
       end do
       if(J.gt.0.and.J.le.43)then
        CALL ZEICH (J,KOORD)
        GO TO 400
       end if
      end if
      GO TO 1000

C      ES WIRD EINE UMSTEUERUNG GROSS-/KLEINBUCHSTABE ERWARTET
C      ZULAESSIGE ZEICHEN SIND : 
c           @
C           @U,u       Grossbuchstaben               I6BIT = 1
C           @L,l       KLEINBUCHSTABEN MIT 6-BIT     I6BIT = 2
c           @C,c       Buchstaben gross(shift)/klein I6BIT = 0
c           @n         0<=n<=9     Farbe der Feder
  700 ch1=ITEXT(IC)
      J6BIT = 0
      I6BIT = 0
      i=ichar(ch1)-i0
      if(i.ge.0.and.i.le.9)then
       k=ichar(ITEXT(IC+1))-i0
       if(k.ge.0.and.k.le.9)then
c       second number
        i=10*i+k
        IC=IC+1
       end if
      else
       i=-1
      end if       
      if( ch1.eq.'u'.or.ch1.eq.'U')then
C      7-BIT-ASCII (UMSCHALTUNG MIT 'SHIFT') GEWUENSCHT
       I6BIT = 1
      else if( ch1.eq.'l'.or.ch1.eq.'L')then
C      KLEINBUCHSTABEN BEI 6-BIT-ASCII GEWUENSCHT
       I6BIT = 2
      else if( ch1.eq.'c'.or.ch1.eq.'C')then
C      gross(shift)/klein GEWUENSCHT
       I6BIT = 0
      else if(i.ge.0)then
c      federwahl
c       write(6,'(a,i4)')'federwahl  TXTPLO  ipen=',i 
       call PLUMA(i)
      else
       i=iold_pen
       call PLUMA(i)       
       goto 50
      end if
      GO TO 1000 

C     BLANK GEFUNDEN
 800  IB = 20
      goto 803
 801  IB=8
      goto 803
 802  IB=-4
 
 803   GO TO 900
C      BACKSLASH  "\"  GEFUNDEN
  810 JTYPE = 1
      GO TO 1000
C     Dollar  "$"  GEFUNDEN
  820 JNDEX = 1
      GO TO 1000
C      KLAMMERAFFE "@"  GEFUNDEN
  830 J6BIT = 1
      GO TO 1000

  840 IF (JUMLAUT .NE. 1) THEN
       KC=IC
       IF (KC .LE. NTEXT .AND. ITYPE .LE. 3) THEN
        IIC=ITEXT(KC)
        IF (IIC .EQ. ICHAR1(1) .OR. IIC .EQ. ICHAR1(15) .OR.
     &      IIC .EQ. ICHAR1(21) ) THEN
         JUMLAUT=1
         JUMSIZ=1
        ELSE IF(  IIC .EQ. IUMLAUT .OR.
     &            IIC .EQ. ICHAR2(1) .OR. IIC .EQ. ICHAR2(15) .OR.
     &            IIC .EQ. ICHAR2(21) ) THEN
         JUMLAUT=1
         JUMSIZ=0
        else
         jumlaut=0
	END IF
       END IF
       GO TO 1000
      ELSE				! doppeltes "
       JUMLAUT=0
       GO TO 100
      END IF
C
C      BUCHSTABE IST FERTIG, X1,Y1 WERDEN UM DIE BUCHSTABENBREITE ERHOEHT
C      DIESE IST   =IB        ,  FALLS  INDEX = 1        (NORMALBUCHSTABE)
C                  =0.6*IB    ,  FALLS  INDEX = 2, 3     (OBERER, UNTERER INDEX)
  900 CONTINUE
      IF ( INDEX.GT.1 ) GO TO 910
C      INDEX = 1
      X1 = X1 + IB*B*COSA
      Y1 = Y1 + IB*B*SINA
      if(Z1.lt.H*21) Z1=H*21 
C      BUCHSTABE FERTIG
      GO TO 1000
C      INDEX = 2, 3
  910 X1 = X1 + 0.6*IB*B*COSA
      Y1 = Y1 + 0.6*IB*B*SINA
      if(Z1.lt.H*21) Z1=H*21 
C      BUCHSTABE FERTIG
 1000 CONTINUE
      end do
C      ITEXT  IST ABGEARBEITET
C      DIE LAGE DER RECHTEN UNTEREN ECKE DER TEXTZEICHNUNG
C      WIRD AN DAS RUFENDE PROGRAMM ZURUECKUEBERGEBEN
      X2 = X1
      Y2 = Y1
      Z2 = Z1
c     wahl der startfeder
c
      call PLUMA(iold_pen)
c
      RETURN
      END
C-------------------------------------------------------------------------------
C*******************************************************************************
C
C     BENSON-LIBRARY         
C
C*******************************************************************************
C
      SUBROUTINE FIN (NTAPE)
      CLOSE (UNIT=NTAPE)
      RETURN
      END
C
      SUBROUTINE PNUMA(X1,Y1,NBLC,X2,Y2)
      COMMON /BENXY/ IX,IY,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY,IBLOC 
      COMMON /BENBUF/MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,
     &               N2MAX,ICAR,NMMAX,NCMAX,dum 
      dimension LB(1)

      CALL TRAA(X1,Y1,0)
      CALL TRAA(X1,Y1,1)
      XP=X2 
      YP=Y2 
      XV=XP 
      YV=YP 
      IF(XP.lt.0) then
       D=-0.5
       GO TO 4
      else if(XP.eq.0) then 
       IX=0
       GO TO 5
      else if(XP.gt.0) then  
       D=0.5
      end if 
4     D=PASX*XP + D 
      IX=IFIX(D)

 5    IF(YP.lt.0) then
       D=-0.5
       GO TO 9 
      else if(YP.eq.0) then 
       IY=0
       GO TO 10
      else if(YP.gt.0) then
       D=0.5 
      end if
9     D=PASY*YP + D 
      IY=IFIX(D)

10    IF(NBLC.ge.0)then
       IF(NBLC-IBLOC.lt.0)then
        NBLC=IBLOC
        GO TO 14
       else IF(NBLC-IBLOC.eq.0)then
        goto 14
       else IF(NBLC-IBLOC.gt.0)then 
        IBLOC=NBLC
       end if
      ELSE
       goto 100
      end if
c      Write(6,'(a,i8)')'NBLC=',NBLC 
      LB(1)=NBLC
14    CALL BENES(NBLC,LB,1,2) 
C.....LEEREN DES BUFFERS
C.....SCHREIBEN EINER BLOCKNUMMER 
      NBLC=NBLC+1 
100   RETURN
      END 
C
      SUBROUTINE IBENA(JBUF,LBUF,NTAPE) 
      implicit none
      integer JBUF,LBUF,NTAPE,IX,IY,IBLOC,LB
      real    XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY
      COMMON /BENXY/IX,IY,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY,IBLOC 
      dimension LB(1)
  
      XP=0. 
      YP=0. 
      XV=0. 
      YV=0. 
      EX=1. 
      EY=1. 
      XO=0. 
      YO=0. 
      IX=0
      IY=0
      LB(1)=0
      CALL BENES(NTAPE,LB,1,1) 
      RETURN
      END 
C
      SUBROUTINE TRAA(X,Y,J)
      implicit none
      integer J,IX,IY,IBLOC,N2MAX,ICAR,NMMAX,NCMAX,IPL,
     &        MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,idum 
      real    X,Y,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY

      COMMON /BENXY/IX,IY,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY,IBLOC 
      COMMON /BENBUF/MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,
     &               N2MAX,ICAR,NMMAX,NCMAX,idum 
      DIMENSION IPL(3)

      integer JJ,IXN,NJX,NJY,INEND,NTX,NTY,IK,IYN
      real    XX,YY,D
c      write(6,'(i3,a,4f10.3)')J,'=j  TRAA x,y=',X,Y        
c      write(6,'(a,2f10.2,i2)')' traa x,y,j=',X,Y,J
C 
C ... (XP,YP)  :  WIRKLICHE FEDERPOSITION 
C 
C ... (XV,YV)  :  VIRTUELLE FEDERPOSITION 
C 
C ... (XX,YY)  :  VIRTUELLE FEDERPOSITION NACH DER ZUWEISUNG
C 
      JJ=J
      IF(JJ-2.ge.0)then
       XX=XV+X 
       YY=YV+Y 
       JJ=JJ-2 
       GO TO 3 
      end if
      XX=X
      YY=Y
3     IF(JJ.eq.0)then
       XV=XX 
       YV=YY 
       JUP=1 
       GO TO 100
      end if 
5     IF(JUP.eq.0)then
       IPL(3)=1
       XP=XX 
       YP=YY 
       XV=XP 
       YV=YP 
       GO TO 10
      end if
      IPL(3)=0
      XP=XV 
      YP=YV 
10    IF(XP.lt.0)then
       D=-0.5
       GO TO 14
      else IF(XP.eq.0)then
       IXN=0 
       GO TO 15
      else IF(XP.gt.0)then
       D=0.5
      end if 
14    D=PASX*XP + D 
      IXN=IFIX(D) 
15    NJX=IXN - IX
      IX=IXN
      IF(NJX.lt.0)then
       IXN=-1
       NJX=-NJX
       GO TO 20
      end if
      IXN=1 
20    IF(YP.lt.0)then
       D=-0.5
       GO TO 24
      else IF(YP.eq.0)then
       IYN=0 
       GO TO 25
      else IF(YP.gt.0)then
       D=0.5
      end if
 
24    D=PASY*YP + D 
      IYN=IFIX(D) 
25    NJY=IYN - IY
      IY=IYN

      IF(NJY.lt.0)then 
       IYN=-1
       NJY=-NJY
       GO TO 30
      end if
      IYN=1 
30    INEND=1 
      JJ=1

      IF(NJX-NJY.lt.0)then
       JJ=NJX
       NJX=NJY 
       NJY=JJ
       JJ=-1 
      end if
      IF(NJX.le.0) goto 60
      IF(NJX-N2MAX.le.0)goto 50
      NTX=NJX 
      NTY=NJY 
      NJX=N2MAX 

35    IF(NTX-NTY.eq.0)then
       NJY=N2MAX 
       GO TO 42
      end if
      IF(NTY.le.0)then
       NJY=0 
       GO TO 42
      end if
      IK=NTX/N2MAX
      INEND=NTX - IK*N2MAX

      IF(INEND.gt.0)IK=IK+1
      NJX=NTX/IK
      NJY=NTY/IK
42    INEND=0 
      NTX=NTX-NJX 
      NTY=NTY-NJY 

50    IF(JJ.lt.0)then
       IK=NJY
       NJY=NJX 
       NJX=IK
      end if
52    IPL(1)=NJX*IXN
      IPL(2)=NJY*IYN
      CALL BENES(18,IPL,3,3)

      IF(INEND.eq.0)then
       IF(NTX-N2MAX.gt.0)then
        NJX=N2MAX 
        GO TO 35
       else
        goto 56
       end if
      else
       goto 60
      end if

56    NJX=NTX 
      NJY=NTY 
      INEND=1 
      IF(JJ.lt.0)then
       IK=NJY
       NJY=NJX 
       NJX=IK
      end if
      goto 52
      
60    IF(JUP.eq.0) goto 100
      JUP=0 
      IPL(3)=1
      XP=XX 
      YP=YY 
      XV=XP 
      YV=YP 
      GO TO 10
100   RETURN
      END 
C
      SUBROUTINE PLUMA(LPL) 
      integer LPL,IP
c     modifiziert fuer Rueckgabe der gewaehlten Feder
c     und Feder 0...7
c
c     M. Alflen  23.8.89
      COMMON /BENBUF/MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,
     &               N2MAX,ICAR,NMMAX,NCMAX,dum 

      DIMENSION IPN(1)
c     IF (LPL-IP.eq.0.or.LPL.lt.0.or.LPL-9.gt.0)goto 100
      IF (LPL-IP.eq.0.or.LPL.lt.0.)goto 100
      IPN(1)=LPL
      CALL BENES(5,IPN,1,4)
      IP=LPL
      RETURN
100   LPL=IP
      RETURN
      END 

      SUBROUTINE PFUMA(LPL) 
      integer LPL,IP
c     modifiziert fuer Rueckgabe der gewaehlten Feder
      DIMENSION IPN(1)

      IPN(1)=LPL
      CALL BENES(5,IPN,1,8)
      RETURN
      END 
C
      SUBROUTINE BENES(LA,LB,lbd,IPEN)
      implicit none
      integer LA,LB,lbd,IPEN,IX,IY,IBLOC,N2MAX,ICAR,NMMAX,NCMAX,
     &        MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,idum

      real                 XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY
      COMMON /BENXY/ IX,IY,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY,IBLOC 
      COMMON /BENBUF/MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,
     &               N2MAX,ICAR,NMMAX,NCMAX,idum 
      integer     ICH,ICOD,ICS,IMN,INOP,I7,I6,IES
      DIMENSION   IES(128)
      integer     NPAR,NA 
      DIMENSION   ICH(64),ICOD(12),LB(lbd),ICS(10),NPAR(6),NA(10) 
      EQUIVALENCE (ICH(17),ICS(1)),(ICH(14),IMN),(ICH(1),INOP)


      integer INBUF,MOT,IC,
     &        IBIT,IDI,I,I2N,MBIT,K,IR,IDV,IM,IQ,
     &        IK,JC,LT,J,IXV,IZS,LPAD,IFI,junit

      SAVE IDI,MBIT,IES
      DATA INBUF/1/,MOT/16/,NPAR/3,1,4,2,1,1/ 
c      DATA ICOD/'P','L','N','P','S','Z','N','T','T','X'/
C.....I7 UND I6 DIE BINAERE DARSTELLUNG DER WERTE 7 UND 6 IN DEN
C     NIEDERWERTIGSTEN 3 BITS 
c      DATA I7/'7'/,I6/'6'/
c      DATA ICH/' ','!','"','#','$','%','&','\'','(',')','*','+',',', 
c     1 '-','.','/','0','1','2','3','4','5','6','7','8','9',
c     2 ':',';','<','=','>','?','@','A','B','C','D','E','F','G','H','I',
c     3 'J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y',
c     4 'Z',' ',' ',' ',' ',' '/
      ICOD(1)=ichar('P')
      ICOD(2)=ichar('L')
      ICOD(3)=ichar('P')
      ICOD(4)=ichar('N')
      ICOD(5)=ichar('S')
      ICOD(6)=ichar('Z')
      ICOD(7)=ichar('N')
      ICOD(8)=ichar('T')
      ICOD(9)=ichar('T')
      ICOD(10)=ichar('X')
      ICOD(11)=ichar('P')
      ICOD(12)=ichar('F')

      I6=ichar('6')
      I7=ichar('7')

      do I=1,59
       ICH(I)=I+31
      end do
      do I=60,64
       ICH(I)=32
      end do
    
      junit=9
c      write(junit,'(a,5i6)')'BENES(LA,LB,IPEN):',LA,LB,IPEN,MBUF 
c      if(MBUF.eq.107) then
c       write(6,'(a,5i6)')'BENES(LA,LB,IPEN):',LA,LB,IPEN,MBUF
c      end if
      IC=IPEN 
      IF(IC-2.lt.0)then
C..... INITIALISIERUNG 
       IBUF=126 
       LGMIN=16
       ICAR=2
       ICR=13
       ILF=10
       IBIT=MOT/ICAR 
       N2MAX=16383 
       PASX=200. 
       PASY=200. 
       IBLOC=1 
       NTAPE=LA
       IDI=1 
       DO I=5,8
        IES(I)=0
       end do
       I2N=(ICAR-1)*IBIT 
       I2N=2**I2N
       MBIT=MOT-IBIT 
       ICR=ICR*I2N 
       ILF=ILF*I2N 
C 
C..... K - MAX. LAENGE DER CHARACTERKETTE
C      K <= MIN(255,IBUF-6)
       K=255 
       IF (IBUF .LT. 249) K=IBUF-6 
       NMMAX=K/ICAR
       NCMAX=NMMAX*ICAR
       GO TO 45
      else IF(IC-2.eq.0)then
       IDI=0 
      else IF(IC-2.gt.0)then
       goto 200
      end if

C.....LEEREN DES BUFFERS
      IF(MBUF-INBUF.le.0)goto 30

      IF(MBUF-LGMIN.le.0)then
       DO I=MBUF,LGMIN
        IES(I)=INOP
       end do 
       MBUF=LGMIN+1
      end if
      IR=MBUF+1 
      IES(MBUF)=ICR 
      IES(MBUF+1)=ILF 
c      write(junit,'(a,5i6)')'1BENES   NTAPE=',NTAPE,MBUF 
      WRITE(NTAPE,1000)(char(IES(I)),I=1,IR)
c       WRITE(6,1000)(char(IES(I)),I=1,IR)
 1000 FORMAT(1H ,4(250A1))
      
   30 IDV=1000
      IM=LA 
      DO I=5,8 
       IQ=IM/IDV 
       IES(I)=IQ 
       IM=IM-IQ*IDV
       IDV=IDV/10
      end do

   45 CONTINUE
      IF(IDI.eq.0)goto 100
      IDI=0 
C.....DEFINITION DES 1. DATENSATZES 
      IES(1)=I7 
      IES(2)=I6 
      DO I=1,64
       IES(I+2)=ICH(I) 
      end do
      IES(67)=ICR 
      IES(68)=ILF 
c      write(junit,'(a,5i6)')'2BENES   NTAPE=',NTAPE ,MBUF
      WRITE(NTAPE,1000)(char(IES(I)),I=1,68)
C.....DEFINITION DES 2. DATENSATZES 
      IES(1)=I7 
      IES(2)=I6 
      DO I=1,64
       IES(I+2)=ICH(1) 
      end do
      IES(67)=ICR 
      IES(68)=ILF 
c      write(junit,'(a,5i6)')'3BENES   NTAPE=',NTAPE,MBUF 
      WRITE(NTAPE,1000)(char(IES(I)),I=1,68)
  100 MBUF=INBUF
      IK=LB(1)
      IF(IK-9999.lt.0)goto 150
c     write(junit,'(a,5i6)')'4BENES   NTAPE=',NTAPE,MBUF  
      write(ntape,111)
  111 format(1H )
c      CALL FIN(NTAPE) 
150   RETURN

200   IF(IC-50.eq.0)then
       goto 400
      else IF(IC-50.gt.0)then
       goto 500
      end if
      IC=IC-2 
      JC=IC+IC-1
      LT=MBUF+LA-1
      IF(LT-IBUF.le.0)goto 220
      IR=MBUF+1 
      IES(MBUF)=ICR 
      IES(MBUF+1)=ILF
c      write(junit,'(a,5i6)')'5BENES   NTAPE=',NTAPE,MBUF 
      WRITE(NTAPE,1000)(char(IES(I)),I=1,IR)
      MBUF=INBUF
  220 IES(MBUF)=ICOD(JC)
      IES(MBUF+1)=ICOD(JC+1)
      MBUF=MBUF+2 
      IK=NPAR(IC) 
      DO J=1,IK 
       IXV=LB(J)
       IZS=0 
       IF(IXV.eq.0) then
        IES(MBUF)=ICS(1)
        MBUF=MBUF+1 
        GO TO 300 
       else IF(IXV.gt.0) then
        goto 240
       end if
       IXV=-IXV
       IES(MBUF)=IMN 
       MBUF=MBUF+1 
  240  IDV=10000 
       DO I=1,5
        IQ=IXV/IDV
        IF(IQ.ne.0)goto 260
        IF(IZS.gt.0)then
         goto 270
        else
         goto 280
        end if
  260   IZS=1
        IXV=IXV-IDV*IQ
  270   IES(MBUF)=ICS(IQ+1) 
        MBUF=MBUF+1 
  280   IDV=IDV/10
       end do
  300  IES(MBUF)=INOP
       MBUF=MBUF+1 
      end do
      RETURN
400   LPAD=LA-(LA/ICAR)*ICAR
      RETURN
500   IF(IC-1000.ge.0)goto 800
      IFI=IC-100
      DO I=LA,IFI 
       IM=LB(I)
C..... ISOLIEREN DER ZEICHEN DES WORTES IM LINKSBUENDIG IN DIE 
C      WORTE DER TABELLE NA ( FORMAT A1 )
       CALL DPACK(IM,NA,MBIT)
       IF(I-IFI.lt.0.or.LPAD.eq.0)goto 540
       LPAD=LPAD+1 
       DO  J=LPAD,ICAR
        NA(J)=INOP
       end do
540    DO J=1,ICAR 
        IES(MBUF)=NA(J) 
        MBUF=MBUF+1
       end do 
      end do
      RETURN
800   IFI=IC-1000 
      DO I=1,IFI 
       IES(MBUF)=LB(I) 
       MBUF=MBUF+1 
      end do
      RETURN 
      END 
C
      SUBROUTINE DPACK (LAD,NA,IBIT)
      DIMENSION NA(2),NB(2)
      LOGICAL*1 M1(4),M2(2)
      EQUIVALENCE (NB(1),M1(1)),(LBD,M2(1))
C
      SAVE
c      write(6,'(a,8i4)')'DPACK:',LAD,NA,IBIT
      LBD=LAD
      M1(1)=M2(1) 
      M1(2)=M2(1)
      M1(3)=M2(2)
      M1(4)=M2(2)
      NA(1)=NB(1)
      NA(2)=NB(2)
c      write(6,'(a,8i4)')'DPACK:',LAD,NA,IBIT,M1,M2
      RETURN
      END

      SUBROUTINE POSA(X,Y)
      COMMON /BENXY/ IX,IY,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY,IBLOC
      save 
      X=XV
      Y=YV
      RETURN
      END 

      SUBROUTINE  BECENA(X,Y,J,ICA,HX,HY,COSA,SINA) 
C X Y COORDONNEES DU CENTRE DU SYMBOLE DEFINI DANS UN CARRE 
C         4 * 4 
C     J   MEME DEFINITION QUE DANS TRAA 
C     ICA RANG DU CARACTERE DANS LA TABLE 
C    HX,HY  DIMENSIONS DU CARACTERE EN CENTIMETRES 
C 
C 
      DIMENSION AT(5),IOC(32),IDC(121)
      SAVE 
      AT(1)=0. 
      AT(2)=0.25 
      AT(3)=0.50 
      AT(4)=0.75 
      AT(5)=1.0 
      IOC( 1)=11 
      IOC( 2)=15 
      IOC( 3)=7 
      IOC( 4)=3 
      IOC( 5)=1 
      IOC( 6)=5 
      IOC( 7)=9 
      IOC( 8)=13 
      IOC( 9)=17 
      IOC(10)=22 
      IOC(11)=66            
      IOC(12)=71            
      IOC(13)=27            
      IOC(14)=28            
      IOC(15)=34            
      IOC(16)=35            
      IOC(17)=42            
      IOC(18)=43            
      IOC(19)=48            
      IOC(20)=49            
      IOC(21)=54            
      IOC(22)=55            
      IOC(23)=60            
      IOC(24)=61            
      IOC(25)=76            
      IOC(26)=81            
      IOC(27)=86            
      IOC(28)=92            
      IOC(29)=98            
      IOC(30)=104           
      IOC(31)=110           
      IOC(32)=111           
      IDC(  1)=124 
      IDC(  2)=122 
      IDC(  3)=142 
      IDC(  4)=-122 
      IDC(  5)=142 
      IDC(  6)=122 
      IDC(  7)=120 
      IDC(  8)=-122 
      IDC(  9)=102 
      IDC( 10)=122 
      IDC( 11)=124 
      IDC( 12)=-122 
      IDC( 13)=120 
      IDC( 14)=122 
      IDC( 15)=102 
      IDC( 16)=-122 
      IDC( 17)=124 
      IDC( 18)=120 
      IDC( 19)=2 
      IDC( 20)=142 
      IDC( 21)=-122 
      IDC( 22)=104 
      IDC( 23)=140 
      IDC( 24)=0 
      IDC( 25)=144 
      IDC( 26)=-122 
      IDC( 27)=124 
      IDC( 28)=24 
      IDC( 29)=102 
      IDC( 30)=120 
      IDC( 31)=142 
      IDC( 32)=124 
      IDC( 33)=-22 
      IDC( 34)=124 
      IDC( 35)=24 
      IDC( 36)=104 
      IDC( 37)=100 
      IDC( 38)=140 
      IDC( 39)=144 
      IDC( 40)=124 
      IDC( 41)=-22 
      IDC( 42)=124 
      IDC( 43)=24 
      IDC( 44)=100 
      IDC( 45)=140 
      IDC( 46)=124 
      IDC( 47)=-22 
      IDC( 48)=120 
      IDC( 49)=20 
      IDC( 50)=104 
      IDC( 51)=144 
      IDC( 52)=120 
      IDC( 53)=-22 
      IDC( 54)=102 
      IDC( 55)=2 
      IDC( 56)=140 
      IDC( 57)=144 
      IDC( 58)=102 
      IDC( 59)=-22 
      IDC( 60)=142 
      IDC( 61)=42 
      IDC( 62)=104 
      IDC( 63)=100 
      IDC( 64)=142 
      IDC( 65)=-22 
      IDC( 66)=4 
      IDC( 67)=122 
      IDC( 68)=120 
      IDC( 69)=44 
      IDC( 70)=-122 
      IDC( 71)=0 
      IDC( 72)=122 
      IDC( 73)=124 
      IDC( 74)=40 
      IDC( 75)=-122 
      IDC( 76)=104 
      IDC( 77)=144 
      IDC( 78)=100 
      IDC( 79)=140 
      IDC( 80)=-122 
      IDC( 81)=104 
      IDC( 82)=100 
      IDC( 83)=144 
      IDC( 84)=140 
      IDC( 85)=-122 
      IDC( 86)=112 
      IDC( 87)=124 
      IDC( 88)=132 
      IDC( 89)=122 
      IDC( 90)=120 
      IDC( 91)=-122 
      IDC( 92)=123 
      IDC( 93)=102 
      IDC( 94)=121 
      IDC( 95)=122 
      IDC( 96)=142 
      IDC( 97)=-122 
      IDC( 98)=112 
      IDC( 99)=120 
      IDC(100)=132 
      IDC(101)=122 
      IDC(102)=124 
      IDC(103)=-122 
      IDC(104)=123 
      IDC(105)=142 
      IDC(106)=121 
      IDC(107)=122 
      IDC(108)=102 
      IDC(109)=-122 
      IDC(110)=124 
      IDC(111)=24 
      IDC(112)=114 
      IDC(113)=103 
      IDC(114)=101 
      IDC(115)=110 
      IDC(116)=130 
      IDC(117)=141 
      IDC(118)=143 
      IDC(119)=134 
      IDC(120)=124 
      IDC(121)=-22 
      CALL TRAA(X,Y,J) 
      IF(ICA.le.0.or.ICA-32.gt.0)goto 10
      IFIN=1 
      CALL POSA(XA,YA) 
      XA=XA-(HX*COSA-HY*SINA)*0.5 
      YA=YA-(HX*SINA+HY*COSA)*0.5 
      IND=IOC(ICA)
  3   ID=IDC(IND) 
      IF(ID.ge.0)goto 5 
      IFIN=2 
      ID=-ID 
   5  JP=ID/100 
      KX=(ID-JP*100)/10 
      KY=ID-JP*100-KX*10+1 
      KX=KX+1 
      TX=HX*AT(KX) 
      TY=HY*AT(KY) 
      DX=XA+TX*COSA-TY*SINA 
      DY=YA+TX*SINA+TY*COSA 
      CALL TRAA(DX,DY,JP) 
      GO TO (6,10),IFIN 
   6  IND=IND+1 
      GO TO 3 
 10   RETURN 
      END 

      SUBROUTINE BCERCA(X,Y,J,R,ANG,DANG)
      SAVE 
      A=0.5 
      EPS=0.02 
      RAD=0.01745329 
      I=J-2 
      IF(I.ge.0)goto 2 
      JJ=J 
      XP=X 
      YP=Y 
      GO TO 3 
2     JJ=I 
      CALL POSA(XP,YP) 
      XP=XP+X 
      YP=YP+Y 
3     IF(R.gt.0) goto 5 
      CALL TRAA(XP,YP,JJ) 
      GO TO 100 
5     ALF=ANG*RAD 
      XX=XP + R*COS(ALF) 
      YY=YP + R*SIN(ALF) 
      CALL TRAA(XX,YY,JJ) 
      PHI=SQRT(EPS/(A+R)) 
      IF(DANG.eq.0)goto 100 
      IF(DANG.lt.0)PHI=-PHI 
      DELTA=RAD*DANG 
      JJ=DELTA/PHI 
      DELTA=ALF+DELTA 
      IF(JJ.le.0) goto 11
      DO I=1,JJ 
       ALF=ALF+PHI 
       XX=XP + R*COS(ALF) 
       YY=YP + R*SIN(ALF) 
       CALL TRAA(XX,YY,1) 
      end do
11    XX=XP + R*COS(DELTA) 
      YY=YP + R*SIN(DELTA) 
      CALL TRAA(XX,YY,1) 
100   RETURN 
      END


C****************************************************
      FUNCTION NA(ANF,END,STEP)
      NA=-2
      G1=ABS(ANF)
      G2=ABS(END)
      G3=AMAX1 (G1,G2)
      G1=ALOG10(ABS(STEP))
      G2=ALOG10(G3)
      G1=ABS(G1)+1.
      G2=ABS(G2)+1.
      K1=IFIX(G1)
      K2=IFIX(G2)
      NA=K1
      IF (NA.GT.6) NA=-2
      IF (ABS(STEP).GE.1.) NA=-1
      IF (ABS(STEP).LT.1.) K2=K2+K1
      IF (K2.GT.7) NA=-2
      RETURN
      END
C*********************************


      SUBROUTINE PART (E,AANF,AEND,ASTEP,IAF)
C
      DIMENSION SCALE(4)
      SAVE
C
      DATA SCALE/20.,50.,100.,200./
      ASTEP=0.
      IAF=1
      ISCAL=0
      ISTEP=0
      AMG=1.E-6
      BMG=1.E+9
      DO 5 I=1,15
      BMG=BMG/10.
      IF ((E-BMG).LT.0.) AMG=10.*AMG
    5 CONTINUE
      E=E*AMG
      G3=1000.
      DO 20 K=3,10
      DO 10 L=1,4
      G2=K*SCALE(L)
      IF (G2.GT.E) GOTO 20
      G1=E-G2
      IF (G1.GT.G3) GOTO 10
      G3=G1
      ISCAL=L
      ISTEP=K+1
   10 CONTINUE
   20 CONTINUE
      ASTEP=SCALE(ISCAL)/AMG
      IAF=IFIX(SCALE(ISCAL)/10.)
C
      G1=-11.
      IF (AEND.NE.0.) G1=ALOG10 (ABS(AEND))
      IF (G1.LT.0.) G1=G1-1.
      K1=IFIX(G1)
      G2=10.**K1
      K2=IFIX(AEND/G2)
      G3=FLOAT(K2)*G2
      IF (AANF.LT.0..AND.AEND.GT.0.) G3=0.
      G4=ASTEP
      G5=G3
   30 G5=G5+G4
      IF (G5.LT.AEND) GOTO 30
      AEND=G5
      G5=G3
   40 G5=G5-G4
      IF (G5.GT.AANF) GOTO 40
      AANF=G5
      RETURN
      END
C*******
      SUBROUTINE NUMBER (X0,Y0,J,FNP,NC,HX,HY,COSA,SINA,X1,Y1)
      implicit none
      real X0,Y0,FNP,HX,HY,COSA,SINA,X1,Y1,Z1
      integer J,NC,ISL,IPEN,N,MAX,I,ILP,K,L
 
      real A10,FPV,Z,U,V,W

      character*1 ILIS,NBL,NBS,NSR,NSZ,MOINS,POINT,EA,IDA,ICR
      DIMENSION IDA(10),ILIS(80)
      DATA NBL/' '/,NSR/'R'/,NSZ/'Z'/
      DATA MOINS/'-'/,POINT/'.'/,EA/'E'/
      DATA IDA/'0','1','2','3','4','5','6','7','8','9'/ 
C
C     X0,Y0 KOORDINATEN DES STARTPUNKTES (J < 2)
C           KOORDINATEN DES ZENTRUMS (J = 2,3)
C     J=2,3 ZEICHNEN EINES ZENTRIERTEN SYMBOLS
C     J=0,1 PLOTTEN DER ZAHL FNP IM FORMAT NC
C     J < 0 BERECHNEN DES ENDPUNKTES X1,Y1 OHNE PLOT
C     FNP   MASCHINENINTERNE GLEITKOMMADARSTELLUNG DER SYMBOLNUMMER (J = 2,3)
C           BZW. DER ZU ZEICHNENDEN ZAHL (J < 2)
C     NC    FORMAT
C     NC>-1 FESTKOMMADARSTELLUNG 
C     NC=-1 INTEGERDARSTELLUNG (IMMER BEI J=2,3 UNABHAENGIG VON EINGABE)
C     NC<-1 GLEITKOMMADARSTELLUNG
C     HX,HY BREITE UND HOEHE DER ZAHL BZW. DES SYMBOLS
C     COSA  COSINUS DES WINKELS ZWISCHEN ZAHL BZW. SYMBOL UND
C           POSITIVER PLOTTER-X-ACHSE
C     SINA  SINUS DES WINKELS ZWISCHEN ZAHL BZW. SYMBOL UND
C           POSITIVER PLOTTER-X-ACHSE
C     X1,Y1 KOORDINATEN DES ENDPUNKTES (AUSGABEGROESSEN)
      NBS=char(92)



      ILIS(1)=NBS
C     ROMAN NUMBERS (FOR SCRIPT NUMBERS  SET ILIS(2)=NSS)
      ILIS(2)=NSR
      ISL=2
      IF (J.LT.2) GOTO 5
      NC=-1
      ILIS(2)=NSZ
      IF (FNP.GE.10.) GOTO 5
      ILIS(3)=NBL
      ISL=3
  5   A10=1./ALOG(10.)

      IPEN=J
      FPV=ABS(FNP)
      N=NC
      MAX=9 
      IF(N-MAX.gt.0)N=MAX 
      IF(N+MAX.lt.0)N=-MAX
      IF(FNP.eq.0)then
       ICR=IDA(1)
       ISL=ISL+1 
       ILIS(ISL)=ICR 
       goto 101
      else IF(FNP.lt.0)then
       ICR=MOINS 
       ISL=ISL+1 
       ILIS(ISL)=ICR 
      end if     
      GOTO 6 
       
 101  IF(N+1.ne.0)then
       ICR=POINT 
       ISL=ISL+1 
       ILIS(ISL)=ICR 
      end if     
      GO TO 900

 6    IF(N+1.eq.0)then
       Z=0.5 
       GO TO 53
      else IF(N+1.lt.0)then
       ICR=IDA(1)
       ISL=ISL+1 
       ILIS(ISL)=ICR 
       goto 104
      else IF(N+1.gt.0)then 
       Z=0.5*10.**(-N) 
      end if           

  53  FPV=FPV+Z 
      Z=ALOG(FPV)*A10 
      I=Z+1.

      IF(I.le.0)I=1
      ILP=I+N 
      if(N.lt.0)ILP=ILP+1
      DO  K=1,ILP
       U=10.**(I-K)
       L=FPV/U 
       IF(L-9.gt.0) L=9
       ICR=IDA(L+1)
       ISL=ISL+1 
       ILIS(ISL)=ICR 

       FPV=FPV-FLOAT(L)*U
 
       IF(K-I.ne.0.or.N.lt.0)goto 10
       ICR=POINT 
       ISL=ISL+1 
       ILIS(ISL)=ICR 
 10    CONTINUE
      end do
 900  CALL TXTPLO(X0,Y0,IPEN,ILIS,ISL,HX,HY,COSA,SINA,X1,Y1,Z1)
      RETURN

 104  ICR=POINT
      ISL=ISL+1 
      ILIS(ISL)=ICR 
      N=-N
      V=ALOG(FPV)*A10 
      L=V+1.
      IF(V+1.0.lt.0.0)L=L-1
      W=FPV+0.5*10.**(L-N)
      Z=ALOG(W)*A10 
      I=L 
      L=Z+1.
      IF(Z+1.0.lt.0.)L=L-1 
      IF(I-L.eq.0)FPV=W

      DO K=1,N 
       U=10.**(I-K)
       L=FPV/U 
       IF(L-9.gt.0) L=9 
       ICR=IDA(L+1)
       ISL=ISL+1 
       ILIS(ISL)=ICR 
       FPV=FPV-FLOAT(L)*U
      end do
      ICR=EA
      ISL=ISL+1 
      ILIS(ISL)=ICR 
      IF(I.lt.0)then
       ICR=MOINS
       ISL=ISL+1 
       ILIS(ISL)=ICR
      end if
      L=IABS(I)/10
      ICR=IDA(L+1)
      ISL=ISL+1 
      ILIS(ISL)=ICR 
      L=IABS(I)-L*10

      ICR=IDA(L+1)
      ISL=ISL+1 
      ILIS(ISL)=ICR 
      GO TO 900
      END 
C*******************************************************************

C--------------------------------------------------------------------------
C     call numero(ystep,ny,iystep,nystep,0)
      SUBROUTINE NUMERO(FNP_T,NC,INUM,NCHA,MODE,iscfactor) 
c
c     konvertiert Zahl zu ASCII-String
c
c     M. Alflen  13.9.89
c
c     fnp  Eingabezahl
c     nc   > 0  : f-Format mit nc Nachkommastellen  ( nc <= 5 )
c          =0   : i-Format
c          <0   : e-Format mit nc  Nachkommastellen    ( nc<=2 )
c     mode =  0  : e-Format = x.yzE+nn
c             1  : e-Formay = x.yz*10-n
c
c     num  =   Ausgabestring  ( Integer )
c     ncha =   Zahl der signifikanten Character

      character*1 ie1,ie2,inum(24),form*7

      do i=1,24
       inum(i)=' '
      end do
      ie2=' '
      fnp=FNP_T/10**iscfactor
c     write(6,'(a,f15.5,a,i2,a,i2)') 
c     &            ' fnp=',fnp,' MODE=',MODE,'  NC=',NC
      if ( nc .ge. 0) then           ! f - oder i-Format
       if ( nc .gt. 5 ) nc=5 
       form='f15.5'
       call xencode(fnp,form,inum)        
c      write(6,'(a,f15.5,a,15a1)') ' fnp=',fnp,'    inum=',inum
       if (nc .eq. 0) then
        ncha=10-1
       else
        ncha=10+nc
       end if                
       if ( nc .lt. 5 ) then        ! ueberfluessige Nachkommastellen entfernen
        k=ncha+1
        do while ( k .le. 15 )    
         inum(k)=' '
         k=k+1
        end do
       end if
      else if ( nc .le. -1 ) then   ! e-Format
       dum=fnp
       if(nc.eq.-1) form='e10.1'
       if(nc.eq.-2) form='e10.2'    
       if(nc.eq.-3) form='e10.3'
       if(nc.le.-4) form='e10.4'    
       call xencode(dum,form,inum)
c      write(6,'(a,15a1,a,15a1,/)') ' a inum=',inum

       if ( mode .eq. 0 ) then      ! normales e-Format
        inum(2)=inum(4)             ! Divison/10. ausgleichen
        do i=4,9
         inum(i)=inum(i+1)
        end do

        do i=10,24                   ! Blanks einfuegen
         inum(i)=' '
        end do
        ncha=10
       else                          ! spezielles e-Format
        i=4
        do while(i.lt.24.and.inum(i).ne.'e')
         i=i+1
        end do
         ie1=inum(i+1)
         ie2=inum(i+2)
c        write(6,'(i2,2x,2a1,a,24a1,/)') i,ie1,ie2,'- inum=',inum
c                              inum=   -1.0e-4
c                              inum= -1.050e-4 
c                              inum=-1.0500e-4 
          inum(i  )=char(92)
          inum(i+1)='Z'
          inum(i+2)='1'
          inum(i+3)='5'
          inum(i+4)=char(92)
          inum(i+5)='r'
          inum(i+6)='1'
          inum(i+7)='0'
          inum(i+8)='$'
          inum(i+9)='^'
          inum(i+10)=ie1
          inum(i+11)=ie2
          inum(i+12)='$'
          inum(i+13)=' '
          ncha=i+13
       end if         
      end if
c      write(6,'(i2,a,24a1,/)') i,'- inum=',inum

      i=1                            ! fuehrende Blanks beseitigen
      do while ( i.le. 24 .and. inum(i) .eq. ' ')
       i=i+1
      end do
      i=i-1
      ncha=ncha-i
      if ( i .gt. 0) then
       do k=1,ncha
        l=k+i
        inum(k)=inum(l)
        inum(l)=' '
       end do
      end if

c     write(6,'(i2,a,24a1,/)') i,'- inum=',inum
      return
      end

C--------------------------------------------------------------------------

      subroutine xencode(rn,form,inum)
       character*1 inum(24),form*7,chr*24,chl*24
       call trlnu(form,rn,chr,nr,chl,nl)
       do k=1,nr
        inum(k)=chr(k:k)
       end do
      return
      end
            
c-----------------------------------------------------------------------
C-------------------------------------------------------------------------
      function naxfor(anf,end,step)
c
c     naxfor analysiert Eingabegroessen und
c     bestimmt Skalierungs-Format fuer BATPLO
c
c     nform <0  : e-Format
c           =0  : i-Format
c           >0  : f-Format ( nform Nachkommastellen )
c
c     anf       : Anfangswert Skala
c     end       : Endwert Skala
c     step      : Abschnitt
c
c
c     M. Alflen   15.9.89
c
c 
      implicit none
c
      real anf,end,step,aanf,aend,astep,delta
      integer naxfor,k,mult
c
      aanf=abs(anf)
      aend=abs(end)
      astep=abs(step)
c
      if (astep .ge. 1.e6 .or. astep .le. 1.e-4) then
       mult=ifix( amax1(aend,aanf)/astep )
       if ( mult .ge. 10) then
        naxfor=-2                                     ! e-Format
       else
        naxfor=-1
       end if
      else   
       delta=abs( astep-float( ifix( astep ) ) )
       if ( delta .le. 1.e-4 ) then
        naxfor=0                                      ! i-Format
       else
        k=0
        do while (delta .gt. 1.e-4 .and. k .le. 5)
         k=k+1
         delta=delta*10.
         delta=abs( delta-float( ifix( delta ) ) )
        end do
        naxfor=min(k,5)
       end if
      end if
c
      return
c
      end
