      real function arcos(h)

      pi2=2.0*atan(1.0)
      hh=h*h
      if(hh.ge.1) then
       arcos=0.0
       if(h.lt.0.0) arcos=2.0*pi2
      else
       s=sqrt(1.0-hh)
       if(abs(h).lt.0.0001) then
        arcos=pi2
       else
        arcos=atan(s/h)
        if(h.lt.0) arcos=2.0*pi2+arcos
       end if
      end if
      return
      end

      subroutine uvector(cp132,uvec)

      character cp132*132
      dimension uvec(3),out(32)

       call stringlength(cp132,il)
       do k=2,il-1
        if(cp132(k:k).eq.' ') then
         do i=k,il-1
          cp132(i:i)=cp132(i+1:i+1)
         end do
        end if
       end do

       ist=index(cp132,',*,')
       if(ist.gt.0) then
        cp132(ist:ist+2)='   '
        call trlch(il,cp132,nn,out)
        if(nn.lt.2) then
         write(nwr,'(a)') 'less than 2 components found for eax'
         info=1
         return
        end if
        h=out(1)**2+out(2)**2
        if(h.gt.1) then
         h=sqrt(h)
         out(1)=out(1)/h
         out(2)=out(2)/h
         out(3)=0.0
        else
         out(3)=sqrt(1.0-h)
        end if
        uvec(1)=out(1)
        uvec(2)=out(3)
        uvec(3)=out(2)
        goto 100
       end if

       ist=index(cp132,'*,')
       if(ist.gt.0) then
        cp132(ist:ist+1)='   '
        call trlch(il,cp132,nn,out)
        if(nn.lt.2) then
         write(nwr,'(a)') 'less than 2 components found for eax'
         info=1
         return
        end if
        h=out(1)**2+out(2)**2
        if(h.gt.1) then
         h=sqrt(h)
         out(1)=out(1)/h
         out(2)=out(2)/h
         out(3)=0.0
        else
         out(3)=sqrt(1.0-h)
        end if
        uvec(1)=out(3)
        uvec(2)=out(1)
        uvec(3)=out(2)
        goto 100
       end if

       ist=index(cp132,',*')
       if(ist.gt.0) then
        cp132(ist:ist+1)='   '
        call trlch(il,cp132,nn,out)
        if(nn.lt.2) then
         write(nwr,'(a)') 'less than 2 components found for eax'
         info=1
         return
        end if
        h=out(1)**2+out(2)**2
        if(h.gt.1) then
         h=sqrt(h)
         out(1)=out(1)/h
         out(2)=out(2)/h
         out(3)=0.0
        else
         out(3)=sqrt(1.0-h)
        end if
        uvec(1)=out(1)
        uvec(2)=out(2)
        uvec(3)=out(3)
        goto 100
       end if

       call trlch(il,cp132,nn,out)
       uvec(1)=out(1)
       uvec(2)=out(2)
       uvec(3)=out(3)

 100  continue
      return
      end

      subroutine crospr(uvec1,uvec2,uvec3)
      dimension uvec1(3),uvec2(3),uvec3(3)

      uvec3(1)= uvec1(2)*uvec2(3)-uvec1(3)*uvec2(2)
      uvec3(2)=-uvec1(1)*uvec2(3)+uvec1(3)*uvec2(1)
      uvec3(3)= uvec1(1)*uvec2(2)-uvec1(2)*uvec2(1)
      h=0.0
      do k=1,3
       h=h+ uvec3(k)**2
      end do
      h=sqrt(h)
      do k=1,3
       uvec3(k)=uvec3(k)/h
      end do
c      write(6,'(3f12.3)')(uvec1(k),k=1,3)
c      write(6,'(3f12.3)')(uvec2(k),k=1,3)
c      write(6,'(3f12.3)')(uvec3(k),k=1,3)
      return
      end

       subroutine euler_omega(ax_theta,ax_phi,omega,oalpha,obeta,ogamma,
     &                        alpha,beta,gamma,thickness,case,info)
       include 'comglb.for'
       integer case
       real ax_theta,ax_phi,omega,oalpha,obeta,ogamma,alpha,beta,gamma,
     &      thickness
       real uveca(3,3),uvecb(3,3),dj(-4:4,-4:4),uvec(3,3)
       complex drt(-1:1,-1:1)      
       parameter (pi=3.141592654,rad=0.017453293)
       character*6 eai(3),ebi(3),text(3)*8
       logical b_error

c       write(6,'(a,3f10.1)')' alpha,beta,gamma=',oalpha,obeta,ogamma 
c      oalpha,obeta,ogamma is the transformation of the crystal system to the 
c      absorber system. 
c      omega rotation around the axis ax_theta,ax_phi in the absorbersystem

c      inverse matrix uveca
       call dewigner(1,obeta*rad,dj)
       do m=-1,1
        do n=-1,1
         fm=float(m)*oalpha*rad
         fn=float(n)*ogamma*rad
         drt(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)        
        end do
       end do

       uveca(1,1)=0.5*real(drt(1,1)-drt(-1,1)-drt(1,-1)+drt(-1,-1))
       uveca(1,2)=-0.5*aimag(drt(1,1)+drt(-1,1)-drt(1,-1)-drt(-1,-1))
       uveca(1,3)=-1./sqrt(2.)*real(drt(0,1)-drt(0,-1))

       uveca(2,1)=0.5*aimag(drt(1,1)-drt(-1,1)+drt(1,-1)-drt(-1,-1))
       uveca(2,2)=0.5*real(drt(1,1)+drt(-1,1)+drt(1,-1)+drt(-1,-1))
       uveca(2,3)=-1./sqrt(2.)*aimag(drt(0,1)+drt(0,-1))

       uveca(3,1)=-1./sqrt(2.)*real(drt(1,0)-drt(-1,0))
       uveca(3,2)=1./sqrt(2.)*aimag(drt(1,0)+drt(-1,0))
       uveca(3,3)=real(drt(0,0))


       xalpha=ax_phi*rad
       xbeta=ax_theta*rad
       xgamma=omega*rad

       cosa=cos(xalpha)
       sina=sin(xalpha)
       cosb=cos(xbeta)
       sinb=sin(xbeta)

       cosg=cos(xgamma)
       sing=sin(xgamma)
       omcosg=1.0-cosg
       
       dx=sinb*cosa
       dy=sinb*sina
       dz=cosb
        

       uvecb(1,1)=dx**2*omcosg +cosg
       uvecb(1,2)=dx*dy*omcosg+dz*sing
       uvecb(1,3)=dx*dz*omcosg-dy*sing

       uvecb(2,1)=dx*dy*omcosg-dz*sing
       uvecb(2,2)=dy**2*omcosg+cosg
       uvecb(2,3)=dz*dy*omcosg+dx*sing

       uvecb(3,1)=dx*dz*omcosg+dy*sing
       uvecb(3,2)=dy*dz*omcosg-dx*sing
       uvecb(3,3)=dz**2*omcosg+cosg



       do l=1,3
       do m=1,3
        h=0.
        do i=1,3
         h=h+uveca(l,i)*uvecb(i,m)
        end do
        uvec(l,m)=h
       end do
       end do
       do l=1,3
       do m=1,3
        uvecb(l,m)=uvec(l,m)
        uveca(l,m)=0.
       end do
         uveca(l,l)=1.
       end do

       b_error=.false.
       if(case.eq.3)then
c       1. case: Rotation axis (defined with respect to the lab. system - z axis
c               is the g-direction) is normal to the surface of the sample.
c               The thickness of the sample increases by the factor 1/cos(ax_theta) 
c       2. case: rotation axis lies in the sample plane (ax_theta=90°) 
c               The sample is rotated out of the position orthonormal to the
c               g-direction by the rotation angle omega. The thickness of the 
c               sample increases by the factor 1/cos(omega) 
c       Which case is decided by theta<90°.
        b_error=.true.
        if(abs(ax_theta-90).lt.0.01) then
         if(cosg.gt.0.05)then
          thickness=1./cosg   
          b_error=.false.
         end if
        else
         if(cosb.gt.0.05)then
          thickness=1./cosb   
          b_error=.false.
         end if        
        end if
        if(b_error)then
         info=1
         infotext(1)='<euler>/sample/rotation/axis'
         infotext(2)(1:17)=' Rotation axis is ill defined'
         infotext(3)=' '
         goto 10
        end if
       end if         

c      vectors uveca and uvecb are known
c      calculation of Euler angle alpha,beta,gamma

       h=0.0
       do k=1,3
        h=h+uveca(3,k)*uvecb(3,k)
       end do
       beta=arcos(h)
       st=sin(beta)
       if(beta.lt.0.001) then
        beta=0.0
        beta=beta/rad
        h=0.0
        do k=1,3
         h=h+uveca(1,k)*uvecb(1,k)
        end do
        alpha=arcos(h)
        h=0.0
        do k=1,3
         h=h+uveca(1,k)*uvecb(2,k)
        end do
        if(h.gt.0.0) alpha=2.0*pi-alpha
        gamma=0.0
       else  ! beta=0
        if(abs(st).lt.0.001) then  ! sin(beta)=0
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(1,k)
         end do
         gamma=0.0
         alpha=arcos(-h)
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(2,k)
         end do
         if(h.gt.0.0) alpha=2.0*pi-alpha
        else
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(3,k)
         end do
         alpha=arcos(h/st)
         h=0.0
         do k=1,3
          h=h+uveca(2,k)*uvecb(3,k)
         end do
         if(h.lt.0.0) alpha=2.0*pi-alpha

         h=0.0
         do k=1,3
          h=h+uveca(3,k)*uvecb(1,k)
         end do
         gamma=arcos(-h/st)
         h=0.0
         do k=1,3
          h=h+uveca(3,k)*uvecb(2,k)
         end do
        if(h.lt.0.0) gamma=2.0*pi-gamma
       end if  ! sin(beta)#0
       end if  ! beta=0
       beta=beta/rad
       alpha=alpha/rad
       gamma=gamma/rad

c       write(nwr,'(/,a)') 'unit vectors of system Sb in system S'
c      caution! vector a is the transpose matrix in order to print the 
c      unit vectors of the rotatet system in the original system.

 10   if(enwr(7).eq.'eulr'.or.b_error) then       
       write(nwr,'(/,a,/,3(a,f10.2),/)') 
     &              ' unit vectors of system Sa and system Sb',
     & ' ax_theta=',ax_theta,' ax_phi=',ax_phi,' omega=',omega

       eai(1)='      x'
       eai(2)='e_C = y'
       eai(3)='      z'
       ebi(1)='      x'
       ebi(2)='r_ax= y'
       ebi(3)='      z'
       text(1)=' in the  '
       text(2)=' Lab.    '
       text(3)=' system  '

        do k=1,3
         write(nwr,'(a12,x,2(a6,a3,3(f7.3,a1),3x))') text(k),
     &   eai(k),' ( ',uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'
        end do

        write(nwr,'(/,20x,a,/,a,3(f6.1,a),/)')
     &  'Euler angles alpha,beta,gamma',
     &  ' eb(n)=Sum;m ea(m) D1,mn(alpha=',
     &    alpha,',beta=',beta,',gamma=',gamma,')'
        if(b_error) return
       end if
       return 
       end

       subroutine  euler_dir(x_theta,x_phi,z_theta,z_phi,
     &                        alpha,beta,gamma,thickness,info)
       include 'comglb.for'

       real uveca(3,3),uvecb(3,3),uvec1(3),uvec2(3),uvec3(3)
  
       parameter (pi=3.141592654,rad=0.017453293)
       character*3 eai(3),ebi(3)
       logical b_error

         st=sin(x_theta*rad)
         uvecb(1,1)=st*cos(x_phi*rad)
         uvecb(1,2)=st*sin(x_phi*rad)
         uvecb(1,3)=cos(x_theta*rad)


         st=sin(z_theta*rad)
         uvecb(3,1)=st*cos(z_phi*rad)
         uvecb(3,2)=st*sin(z_phi*rad)
         uvecb(3,3)=cos(z_theta*rad)

c       zeta=arcos(uvecb(3,3)) is the angle between old and new z-axes
c       1/ uvecb(3,3)> 1 is the increase of the thickness of the 
c       absorber with respect to the  g-direction parallel to the old z-axis 
       b_error=.false.
       thickness=1./abs(uvecb(3,3)) 
       if(thickness.gt.100) then
        write(nwr,'(a)')' orientation of the scatterer is such that',
     &  ' the z-axis lies in the plan of the scatterer'
        b_error=.true.
       end if          

         do k=1,3
          uvec1(k)=uvecb(3,k)
          uvec2(k)=uvecb(1,k)
         end do
         call crospr(uvec1,uvec2,uvec3)
         do k=1,3
          uvecb(2,k)=uvec3(k)
         end do

c      calculation of Euler angle alpha,beta,gamma

       beta=arcos(uvecb(3,3))
       st=sin(beta)
       if(beta.lt.0.001) then
        beta=0.0
        beta=beta/rad
        alpha=arcos(uvecb(1,1))
        h=uvecb(2,1)
        if(h.gt.0.0) alpha=2.0*pi-alpha
        gamma=0.0
       else  ! beta=0
        if(abs(st).lt.0.001) then  ! sin(beta)=0
         h=uvecb(1,1)
         gamma=0.0
         alpha=arcos(-h)
         h=uvecb(2,1)
         if(h.gt.0.0) alpha=2.0*pi-alpha
        else
         h=uvecb(3,1)
         alpha=arcos(h/st)
         h=uvecb(3,2)
         if(h.lt.0.0) alpha=2.0*pi-alpha
         h=uvecb(1,3)
         gamma=arcos(-h/st)
         h=uvecb(2,3)
        if(h.lt.0.0) gamma=2.0*pi-gamma
       end if  ! sin(beta)#0
       end if  ! beta=0
       beta=beta/rad
       alpha=alpha/rad
       gamma=gamma/rad

      if(enwr(7).eq.'eulr') then       
       
 10    write(nwr,'(/,a,/,3(a,f10.2))') 
     &              ' unit vectors of system Sb in system S',
     & ' ax_theta=',ax_theta,' ax_phi=',ax_phi,' omega=',omega
       eai(1)='eax'
       eai(2)='eay'
       eai(3)='eaz'
       ebi(1)='ebx'
       ebi(2)='eby'  
       ebi(3)='ebz'
       do k=1,3
        write(nwr,'(6x,a3,a2,3(f8.3,a1))')ebi(k),'=(',
     &            uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'
       end do

       write(nwr,'(/,a)') 'unit vectors of system Sa in system S'
       do k=1,3
        write(nwr,'(6x,a3,a2,3(f8.3,a1))')eai(k),'=(',
     &            uveca(k,1),',',uveca(k,2),',',uveca(k,3),')'
       end do

       write(nwr,'(/,20x,a,/,a,3(f6.1,a),/)')
     & 'Euler angles alpha,beta,gamma',
     & 'eb(n)=Sum;m ea(m) D1,mn(alpha=',
     &    alpha,',beta=',beta,',gamma=',gamma,')'

       if(b_error) return
      end if

      return
      end


       subroutine euler_omega2(ax_theta,ax_phi,omega,
     &                         ax_theta2,ax_phi2,omega2,
     &                        alpha,beta,gamma )
       include 'comglb.for'

       real uveca(3,3),uvecb(3,3),uvec(3,3)
       parameter (pi=3.141592654,rad=0.017453293)
       character*6 eai(3),ebi(3),text(3)*8

       xalpha=ax_phi2*rad
       xbeta=ax_theta2*rad
       xgamma=omega2*rad

       cosa=cos(xalpha)
       sina=sin(xalpha)
       cosb=cos(xbeta)
       sinb=sin(xbeta)

       cosg=cos(xgamma)
       sing=sin(xgamma)
       omcosg=1.0-cosg
       
       dx=sinb*cosa
       dy=sinb*sina
       dz=cosb
        
       uveca(1,1)=dx**2*omcosg +cosg
       uveca(1,2)=dx*dy*omcosg+dz*sing
       uveca(1,3)=dx*dz*omcosg-dy*sing

       uveca(2,1)=dx*dy*omcosg-dz*sing
       uveca(2,2)=dy**2*omcosg+cosg
       uveca(2,3)=dz*dy*omcosg+dx*sing

       uveca(3,1)=dx*dz*omcosg+dy*sing
       uveca(3,2)=dy*dz*omcosg-dx*sing
       uveca(3,3)=dz**2*omcosg+cosg



       xalpha=ax_phi*rad
       xbeta=ax_theta*rad
       xgamma=omega*rad

       cosa=cos(xalpha)
       sina=sin(xalpha)
       cosb=cos(xbeta)
       sinb=sin(xbeta)

       cosg=cos(xgamma)
       sing=sin(xgamma)
       omcosg=1.0-cosg
       
       dx=sinb*cosa
       dy=sinb*sina
       dz=cosb
        
       uvecb(1,1)=dx**2*omcosg +cosg
       uvecb(1,2)=dx*dy*omcosg+dz*sing
       uvecb(1,3)=dx*dz*omcosg-dy*sing

       uvecb(2,1)=dx*dy*omcosg-dz*sing
       uvecb(2,2)=dy**2*omcosg+cosg
       uvecb(2,3)=dz*dy*omcosg+dx*sing

       uvecb(3,1)=dx*dz*omcosg+dy*sing
       uvecb(3,2)=dy*dz*omcosg-dx*sing
       uvecb(3,3)=dz**2*omcosg+cosg

       do l=1,3
       do m=1,3
        h=0.
        do i=1,3
         h=h+uvecb(l,i)*uveca(i,m)
        end do
        uvec(l,m)=h
       end do
       end do
       do l=1,3
       do m=1,3
        uvecb(l,m)=uvec(l,m)
       end do
       end do

       do l=1,3
       do m=1,3
        uvec(l,m)=uveca(l,m)
        uveca(l,m)=0.
       end do
         uveca(l,l)=1.
       end do

c      vectors uveca and uvecb are known
c      calculation of Euler angle alpha,beta,gamma

       h=0.0
       do k=1,3
        h=h+uveca(3,k)*uvecb(3,k)
       end do
       beta=arcos(h)
       st=sin(beta)
       if(beta.lt.0.001) then
        beta=0.0
        beta=beta/rad
        h=0.0
        do k=1,3
         h=h+uveca(1,k)*uvecb(1,k)
        end do
        alpha=arcos(h)
        h=0.0
        do k=1,3
         h=h+uveca(1,k)*uvecb(2,k)
        end do
        if(h.gt.0.0) alpha=2.0*pi-alpha
        gamma=0.0
       else  ! beta=0
        if(abs(st).lt.0.001) then  ! sin(beta)=0
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(1,k)
         end do
         gamma=0.0
         alpha=arcos(-h)
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(2,k)
         end do
         if(h.gt.0.0) alpha=2.0*pi-alpha
        else
         h=0.0
         do k=1,3
          h=h+uveca(1,k)*uvecb(3,k)
         end do
         alpha=arcos(h/st)
         h=0.0
         do k=1,3
          h=h+uveca(2,k)*uvecb(3,k)
         end do
         if(h.lt.0.0) alpha=2.0*pi-alpha

         h=0.0
         do k=1,3
          h=h+uveca(3,k)*uvecb(1,k)
         end do
         gamma=arcos(-h/st)
         h=0.0
         do k=1,3
          h=h+uveca(3,k)*uvecb(2,k)
         end do
        if(h.lt.0.0) gamma=2.0*pi-gamma
       end if  ! sin(beta)#0
       end if  ! beta=0
       beta=beta/rad
       alpha=alpha/rad
       gamma=gamma/rad

      eai(1)='     x'
      eai(2)='e1 = y'
      eai(3)='     z'
      ebi(1)='     x'
      ebi(2)='e21= y'
      ebi(3)='     z'
      text(1)='        '
      text(2)='        '
      text(3)='        '
c       write(nwr,'(/,a)') 'unit vectors of system Sb in system S'
c      caution! vector a is the transpose matrix in order to print the 
c      unit vectors of the rotatet system in the original system.

       do k=1,3
        write(nwr,'(a8,x,2(a6,a3,3(f7.3,a1),3x))') text(k),
     &  eai(k),' ( ',uvec(k,1),',',uvec(k,2),',',uvec(k,3),')',
     &  ebi(k),' ( ',uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'
       end do
       write(nwr,'(a)')

       write(nwr,'(/,20x,a,/,a,3(f6.1,a),/)')
     & 'Euler angles alpha,beta,gamma',
     & 'eb(n)=Sum;m ea(m) D1,mn(alpha=',
     &    alpha,',beta=',beta,',gamma=',gamma,')'

        return 
        end

      SUBROUTINE JACOBI(A,N,NP,D,V,NROT)
      PARAMETER (NMAX=5)
c     N<= NP; NP<=NMAX ;       
      DIMENSION A(NP,NP),D(NP),V(NP,NP),B(NMAX),Z(NMAX)

      DO 12 IP=1,N
        DO 11 IQ=1,N
          V(IP,IQ)=0.
11      CONTINUE
        V(IP,IP)=1.
12    CONTINUE
      DO 13 IP=1,N
        B(IP)=A(IP,IP)
        D(IP)=B(IP)
        Z(IP)=0.
13    CONTINUE
      NROT=0
      DO 24 I=1,50
        SM=0.
        DO 15 IP=1,N-1
          DO 14 IQ=IP+1,N
            SM=SM+ABS(A(IP,IQ))
14        CONTINUE
15      CONTINUE
        IF(SM.EQ.0.)RETURN
        IF(I.LT.4)THEN
          TRESH=0.2*SM/N**2
        ELSE
          TRESH=0.
        ENDIF
        DO 22 IP=1,N-1
          DO 21 IQ=IP+1,N
            G=100.*ABS(A(IP,IQ))
            IF((I.GT.4).AND.(ABS(D(IP))+G.EQ.ABS(D(IP)))
     *         .AND.(ABS(D(IQ))+G.EQ.ABS(D(IQ))))THEN
              A(IP,IQ)=0.
            ELSE IF(ABS(A(IP,IQ)).GT.TRESH)THEN
              H=D(IQ)-D(IP)
              IF(ABS(H)+G.EQ.ABS(H))THEN
                T=A(IP,IQ)/H
              ELSE
                THETA=0.5*H/A(IP,IQ)
                T=1./(ABS(THETA)+SQRT(1.+THETA**2))
                IF(THETA.LT.0.)T=-T
              ENDIF
              C=1./SQRT(1+T**2)
              S=T*C
              TAU=S/(1.+C)
              H=T*A(IP,IQ)
              Z(IP)=Z(IP)-H
              Z(IQ)=Z(IQ)+H
              D(IP)=D(IP)-H
              D(IQ)=D(IQ)+H
              A(IP,IQ)=0.
              DO 16 J=1,IP-1
                G=A(J,IP)
                H=A(J,IQ)
                A(J,IP)=G-S*(H+G*TAU)
                A(J,IQ)=H+S*(G-H*TAU)
16            CONTINUE
              DO 17 J=IP+1,IQ-1
                G=A(IP,J)
                H=A(J,IQ)
                A(IP,J)=G-S*(H+G*TAU)
                A(J,IQ)=H+S*(G-H*TAU)
17            CONTINUE
              DO 18 J=IQ+1,N
                G=A(IP,J)
                H=A(IQ,J)
                A(IP,J)=G-S*(H+G*TAU)
                A(IQ,J)=H+S*(G-H*TAU)
18            CONTINUE
              DO 19 J=1,N
                G=V(J,IP)
                H=V(J,IQ)
                V(J,IP)=G-S*(H+G*TAU)
                V(J,IQ)=H+S*(G-H*TAU)
19            CONTINUE
              NROT=NROT+1
            ENDIF
21        CONTINUE
22      CONTINUE
        DO 23 IP=1,N
          B(IP)=B(IP)+Z(IP)
          D(IP)=B(IP)
          Z(IP)=0.
23      CONTINUE
24    CONTINUE
      RETURN
      END

      subroutine exyz(phi,theta,psi,invers,nwr)
      implicit none
      integer invers,m,n,nwr
      real    phi,theta,psi,dj(-4:4,4:4),hx,hy,hz,fn,fm
      complex djv(-1:1,-1:1),ev(-1:1),evt(-1:1),hc1

       if(invers.eq.-1) then
        call dewigner(1,-theta,dj)
        do m=-1,1
         do n=-1,1
          fm=-float(n)*phi
          fn=-float(m)*psi
          djv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)        
         end do
        end do 
       else
        call dewigner(1,theta,dj)
        do m=-1,1
         do n=-1,1
          fm=float(m)*phi
          fn=float(n)*psi
          djv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)        
         end do
        end do 
       end if

       ev(1)=-cmplx(1,0)/sqrt(2.)
       ev(0)=(0.,0.)
       ev(-1)=-conjg(ev(1))
       do n=-1,1
        hc1=(0.,0.)
        do m=-1,1
         hc1=hc1+ev(m)*djv(m,n)
        end do
        evt(n)=hc1
       end do
       hx=-real(evt(1)-evt(-1))/sqrt(2.0)
       hy= real((evt(1)+evt(-1))*cmplx(0.,1.))/sqrt(2.0)
       hz= real(evt(0))
       write(nwr,'(a,3f8.3,a1)') ' ex= (',hx,hy,hz,')'

       ev(1)=-cmplx(0,1)/sqrt(2.)
       ev(0)=(0.,0.)
       ev(-1)=-conjg(ev(1))
       do n=-1,1
        hc1=(0.,0.)
        do m=-1,1
         hc1=hc1+ev(m)*djv(m,n)
        end do
        evt(n)=hc1
       end do
       hx=-real(evt(1)-evt(-1))/sqrt(2.0)
       hy= real((evt(1)+evt(-1))*cmplx(0.,1.))/sqrt(2.0)
       hz= real(evt(0))
       write(nwr,'(a,3f8.3,a1)') ' ey= (',hx,hy,hz,')'

       ev(1)=(0.,0.)
       ev(0)=(1.,0.)
       ev(-1)=-conjg(ev(1))
       do n=-1,1
        hc1=(0.,0.)
        do m=-1,1
         hc1=hc1+ev(m)*djv(m,n)
        end do
        evt(n)=hc1
       end do
       hx=-real(evt(1)-evt(-1))/sqrt(2.0)
       hy= real((evt(1)+evt(-1))*cmplx(0.,1.))/sqrt(2.0)
       hz= real(evt(0))
       write(nwr,'(a,3f8.3,a1)') ' ez= (',hx,hy,hz,')'

       return
       end
