c     author : h. spiering
c              institut f. anorg. u. anal. chemie
c              johannes gutenberg-universitaet
c              d-55099 mainz
c              last version october 2006
      
      subroutine fr_mossbauer(cmch,iss,info)
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comthe.for'
      include 'comnuc.for'
      include 'comdas.for'
      integer     iss,info
      integer     ifrth,iaddr,idex,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,nstorTH1,nstorTHyy,nstorSI,ipLG,
     &            jpolsource,jpolabsorber,
     &            iflag_basis,l_Poincare,nLG,nAS,nSC,idum2,ak8,sk8
      real        srw8
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,nstorTHyy,nstorSI,
     &              ipLG,iaddr(3),jpolsource,jpolabsorber,ifrth(6),              
     &              iflag_basis,l_Poincare,nLG,nAS,nSC,idum2,
     &              ak8,sk8,srw8,idex(7)

      real          acsp,uthick_w,unit_chi,channels,vm_SC,convol,
     &              th_dum,drive_mode,channels_vmax,flag_basis,dum,
     &              om_samp,Dsource,Dabsorber,
     &              sc2absorber,sc2aperture,dumcs
      common/acstrf/acsp,uthick_w,dum(2),unit_chi,channels,vm_SC,convol,
     &              th_dum,drive_mode,channels_vmax,flag_basis,
     &              om_samp,Dsource,Dabsorber,
     &              sc2absorber,sc2aperture,dumcs(icstrf-17)
      
      real    avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
     &        Daperture,d_absorber,d_source,dumvs
      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
     &        Daperture,d_absorber,d_source,dumvs(ivstrf-14)
      
      integer ibm,km,mode_drive,lstruct1,lstruct2,lstruct3,
     &        nstorTH2,nstorLG

      parameter (km=256,ibm=2*(maxn-km))
      character cmch*4,ch1*1,text(3)*40,ch132*132,cp132*132

      integer mi,k1,k2,isub,ak2,sk2,kzl,kzla,kzls,ib,ib2,nchansp,
     &        jpollay,nstorint    

c*****************************************************************************
c
c      write(6,'(3a,i3,a,l3)') 'fr_mossbauer cmch=',cmch,' iss=',iss,
c     &           ' b_theory=',b_theory
c      thfrcase()='theory name(ifrcase)' 

      if(cmch.eq.'thna') then
       theoryname='Mossbauer radioactive source        v=100'
       thfrcase(1)='Mossbauer transmission_vA(1)       v=100'         
       thfrcase(2)='Mossbauer transmission_vB(3)      v=100' 
       thfrcase(4)='Mossbauer reemission_vA(2)'
       thfrcase(5)='Mossbauer reemission_vB(4)' 
       thfrcase(3)='Mossbauer transmission_vC(5)'            
       thfrcase(6)='Mossbauer transmission_vD(3)'            
c      thfrcase(7)='Mossbauer resonance reflection(5)' 
       return
      end if        

      if(cmch.eq.'dstr') goto 100
c*****************************************************************************

      nchansp=channels
      if(cmch.eq.'arr0') then
c        write(6,'(a,i5)')' fr_moss ipLG=',nuofdatas
        ipLG=nuofdatas
        l_Poincare=1
c       standard Mossbauer absorber needs Poincare decomposition of rho
        iflag_basis=flag_basis
c        if(ifrcase.eq.5)then
c         l_Poincare=0
c        subroutine optic needs rho_mn       
c        end if
        ifrsto=0
        ib=convol
        if (ib.gt.ibm) ib=ibm
        ib2=ib*2
        if(abs(v_max).gt.0.0) then
         kzl=int(km*vm_SC/abs(v_max))
        else
         kzl=km
        end if
c        write(6,'(a,i5,2f10.2)') 'frame01 kzl=',kzl,vm_SC,v_max
        if(kzl.gt.0) then
         kzls=2*km
         kzla=kzl*2
         if(kzla.gt.2*km) kzla=2*km
        else
         kzla=2*km
         kzls=abs(kzl)*2
         if(kzls.gt.2*km) kzls=2*km
        end if
      
        sk2=kzls
        ak2=kzla
        sk8=sk2*4
        ak8=ak2*4
      
        if(kzla.gt.kzls) then
         nAS=sk2+ak2+ib2
         nSC=sk2+ib2
        else
         nSC=sk2+ak2+ib2
         nAS=ak2+ib2
        end if
  
        nLG=4*(nAS+nSC)
      
c        write(6,'(i2,a,4i5)')ifrcase,
c     &     '=ifrcase fr_mossbauer kzla,kzls,nSC,nAS=',
c     &                           kzla,kzls,nSC,nAS
c        srw8=abs(v_max)/float(km)/8.
        
        nstorTH1=1               ! base
        nstorTH2=km+1            ! norm spectrum
        nstorLG=ipLG+5+(nLG+1)+(nLG+2*mGa+1)+mGa+1    ! Lorentz-Gauss curves

        ifrsto=nstorLG+nstorTH1+nstorTH2+nchansp/2+maxsub*(1+maxthss)
       
        nstorTH=nstorLG
        nstorTHyy=nstorTH+nstorTH1+nstorTH2
        nstorSI=nstorTHyy+nchansp/2
        jpolsource=0
        jpolabsorber=0

c       lstuct1case is assigned in the main routine mossbauer during execution
        je_a=0
        jg_a=0
c       reset of common/sym3j/  in include file comnuc.for
        return
       else if(cmch.eq.'arri') then 
        ifrsto=0
        call l_structure(iss,lstruct1,lstruct2,lstruct3)

      
        if(lstruct1.eq.1.and.lstruct3.gt.0) then
c         write(6,'(a,i1,a2,a)')'c3_prp(',lstruct3,')=',c3_prp(lstruct3)      
         if(c3_prp(lstruct3).eq.'plrs') jpolsource=1
c         ifrsto=km+1     ! storage for folded spectrum for each source site 
        end if

        if(lstruct1.eq.2.and.lstruct3.gt.0) then
c         write(6,'(a,i1,a2,a)')'c3_prp(',lstruct3,')=',c3_prp(lstruct3)      
         if(c3_prp(lstruct3).eq.'plrs') jpolabsorber=1
        end if
        if(lstruct1.eq.2.and.lstruct2.gt.0) then
         
         if(lstruct3.eq.0) then
          jpollay=0
          ifrsto=4
          if(ifrcase.eq.5)ifrsto=4*(nAS+1) 
         else if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1) then
          if(c3_prp(lstruct3).eq.'plrs') jpollay=1
          if(lstruct3.eq.istruct2(lstruct2)) then
           if(jpollay.eq.1) then
            ifrsto=4*(nAS+1)
           else
            ifrsto=nAS+1
           end if
          end if
         end if
        end if 

        if(lstruct1.eq.3.and.lstruct3.gt.0) then
c        detector is always assumed to be unpolarized
         ifrsto=nSC+1
        end if
       return
      else if(cmch.eq.'arre') then
c      storage for absorber function (sum over all sites)
c       if(ifrcase.ne.5)then
        ifrsto=nAS+1
        if(jpolabsorber.eq.1) 
     &  ifrsto=4*(nAS+1)
c       end if
       return
      end if ! arr0,i,e
      
      if(.not.b_theory) then
c       absolute address of nstorSI is known here
        nstorint=maxsub*(1+maxthss)
        do k1=1,nstorint
         array_fr(nstorSI+k1)=(0.,0.)
        end do
      end if

       srw8=abs(v_max)/float(km)/8.
       mode_drive=drive_mode

       mi=istruct2(istruct1(mstruct1))
c      storag on real_fr(2*(iarraysp+nstorFR)+m) (array_f) 
c      corresponds to the i= drive_mode (label 100) 
       mfpt=2*(iarray_sp+nstorFR)  ! y data
       mdfpt=mfpt+nchansp         ! errors of y data (calculated by sqrt 
       mxpt=mfpt+2*nchansp        ! x data (velocity) drive_mode=3
c       write(6,'(a,5i7)')' mfpt,mxpt=',mfpt,mxpt,iarray_sp,nstorFR
c*****************************************************************************
      if(cmch.eq.'data') then
       k1=1
      else if(cmch.eq.'ecic') then
       k1=2
      else if(cmch.eq.'test') then
       k1=3
      else if(cmch.eq.'dfdp') then
       k1=4
      else if(cmch.eq.'subs'.or.cmch.eq.'subt') then
       k1=5
      else if(cmch(1:3).eq.'ple') then
       k1=6
      else if(cmch.eq.'dmod'.or.cmch.eq.'plot') then
       k1=7
      else if(cmch.eq.'punc')then
       k1=8
      end if
      
      goto (110,120,200,300,400,500,600,700),k1
c**********************************************************************
 100  continue
c      k1 input unit (file is opened in main program)
       mode_drive=int(drive_mode)
       if(mode_drive.lt.1.or.mode_drive.gt.3)mode_drive=1
       if(mode_drive.le.2) data_str='y,dy'
       if(mode_drive.ge.3) data_str='y,dy,x'
       call data2dread(0,info)
       return
 110   continue
       k1=iss
       call data2dread(k1,info)
      return
 120   call excinc2d(info)
      return
c************************************************************************
c     'test': theory function is calculated in subroutine mossbauer
      
  200 continue
      
c      write(6,'(a)') ' before moss_the2exp  test'
      k1=1 
      if(cmch.eq.'ecic') k1=0
      call moss_the2exp(k1,info)
c      write(6,'(a)') ' after moss_the2exp  test'
      
      return
c*****************************************************************************
c     derivatives df
  300 continue
      k1=2
      call moss_the2exp(k1,info)
      return
c*****************************************************************************
c     subs, subt
  400 continue
      text(1)='           source'
      text(2)='         absorber'
      text(3)='  detector window'
      if(cmch.eq.'subt') goto 450
      ch1=' '
      if(b_data) then
       ch132=name_data
      else
       ch132=name_theory
      end if
      call chcenter(ch132,ch1,ncl)
      cp132='plot of subspectra of'
      call chcenter(cp132,ch1,ncl)
      print *,' '
      write(nwr,'(a,/,a)') cp132(:ncl),ch132(:ncl)
      ch132='subspectra /added subspectra of'
      call chcenter(ch132,ch1,ncl)
      write(nwr,'(/,a)') ch132(:ncl)
      call moss_selsubspect(text)
      return
c*************************************************************
c  call of moss_subtract
 450  continue
      print *,' '
      print *,' '
      print *,'                     subtraction of subspectra'
      call moss_selsubtract(text,isub)
      call drive(mode_drive)
      call moss_subtract('moss',mi,isub,info)
      k1=1
      call moss_the2exp(k1,info)
      call moss_plot(cmch)
      k1=0
      k2=0
      if(b_theory) k1=1
      call xmosplo(k1,k2)
      return
c**************************************************************************
c     plot execute
c     different plot programs may be called due to a flag constant 
c     to be introduced as global constant
  500 continue
       
       k1=0
       if(b_theory) k1=1
       if(cmch(4:4).eq.'2') k1=2   ! update test
       if(cmch(4:4).eq.'3') k1=3   ! update fit

       k2=1  ! 0: only plot and return, 1: interactive plot
       call xmosplo(k1,k2)

       return
c**************************************************************************
c     display mode , filling of plotarray
 600  continue
c     write(6,'(a,a4,2L5)') 'fr_mossbauer cmch,b_theory,b_data=',
c    &                                    cmch,b_theory,b_data
      
      if(cmch.eq.'dmod') then
       call moss_plot(cmch)
      else
       call drive(mode_drive)
       if(b_theory) then
        k1=3
        call moss_the2exp(k1,info)
        if(n_subset.gt.0) 
     &              call moss_subspect('moss',mi,isub,info)
       end if
       call moss_plot(cmch)
      end if

      return
c**************************************************************************
c     punch data and theory
 700  continue
       k1=iss
       call punch2d(k1,info)
      return

      end
      
      subroutine sel_the2exp(cmch,n1,info)
      character cmch*4
      integer n1,info

      if(cmch.eq.'moss') then
        call moss_the2exp(n1,info)
      else if(cmch.eq.'stro') then
        call strob_the2exp(n1,info)
      end if
      return
      end 


      
      subroutine moss_the2exp(n1,info)
c *****************************************************************
c     n1 = 0 error return
c     n1 = 1 call of theory
c     n1 = 2 derivatives
c     n1 = 3 call of theory without mapping by the transformation 
c            matrices by EFFI (important for subspectra)
c *****************************************************************
      
      include 'comglb.for'
      include 'compar.for' 
      include 'comdat.for'
      include 'comdas.for' 
      include 'comthe.for'
      
      integer km,n1,info
      parameter (km=256)

       integer    iaddr,idex,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,idum1,nstorTHyy
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,idum1,nstorTHyy,iaddr(5),
     &              idex(24)

      real         acsp,uthick_w,unit_chi,channels,vm_SC,convol,th_dum,
     &             drive_mode,channels_vmax,flag_basis,flag_misfit,
     &             om_samp,dumcs,dum
      common/acstrf/acsp,uthick_w,dum,flag_misfit,unit_chi,channels,
     &              vm_SC,convol,th_dum,drive_mode,channels_vmax,
     &              flag_basis,om_samp,dumcs(icstrf-13)

      real    avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
     &        Daperture,d_absorber,d_source,dumvs
      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
     &        Daperture,d_absorber,d_source,dumvs(ivstrf-14)
      logical b_vsp,b_f_factor,b_base,b_bg_fraction,b_v_max,
     &        b_channel_v0,b_v_max2,b_vphase2,b_v_max3,b_vphase3,
     &        b_geo,b_Daperture,b_dabsorber,b_dsource,b_dumvs
      common/bvstrf/b_vsp,b_f_factor,b_base,b_bg_fraction,b_v_max,
     &        b_channel_v0,b_v_max2,b_vphase2,b_v_max3,b_vphase3,
     &        b_geo,b_Daperture,b_dabsorber,b_dsource,b_dumvs(ivstrf-14)
      
      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit
      real      yth,cosa,a_r 
      dimension yth(-maxn:maxn),cosa(1320),a_r(1320)

      integer jsum,icase,N_S,N_B,nTHyy2
      real    r_B,r_S,sumi0,SoverF,AoverF,BoverF,DAoverF,DSoverF,HoverF
      common/geomet/icase,N_S,N_B,r_B,r_S,sumi0,
     &                SoverF,AoverF,BoverF,DAoverF,DSoverF,HoverF
      
      real velocity,geof,dfdgeo
      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn)
      logical b_total,b_fresonant,b_nonlinear,b_scale,b_drive,b_misfit,
     &        b_residual,b_align
 
c      write(6,'(a,8L5)')
c     & 'b_vsp,b_base,b_f_factor,b_bg_fraction,b_geo,b_v_max2=',
c     & b_vsp,b_base,b_f_factor,b_bg_fraction,b_geo,b_v_max2
c      write(6,'(3(a,i6))') ' idumscrt=',idumscrt
c      write(6,'(a,f10.1)') ' ***moss_the2exp base=',base

      icase=0
      if(base.eq.0.) then
        info=1
        infotext(1)='<Mossbauer_spectrum>/parameter/global/base0'
        infotext(2)='**error** base = 0 '
        infotext(3)=' '
        return
      end if

      nomsamp=om_samp+1
      mode_drive=drive_mode
      nchansp=channels
      h=abs(channel_v0/channels_vmax-1.0)*10
      if(h.gt.1.0.or.nchansp.gt.maxn) then
        write(infotext(3),'(a,i5,2(a,f8.2))')
     & 'nchansp=',nchansp,' channels_vmax=',channels_vmax,
     &  ' channel_v0=',channel_v0
        info=10*h
        if(info.le.0) info=1
        infotext(1)='<Mossbauer_spectrum>/global_pa/ch_vmax/ch_v0'
        infotext(2)='**error** with one of the size of'//
     &      ' channels,channels_vmax,channel_v0'
        return
       end if
c     write(6,'(a,f10.3)')' frame01 moss_the2exp fresonant=',fresonant

 
      ka=nstorTH+2
      nTHyy2=nstorTHyy*2

      if(ifrcase.eq.6) then
       call mossbauer_refl(b_total,info)
      else
       call mossbauer_trm(b_total,info)
      end if

      b_align=b_Daperture.or.b_dabsorber.or.b_dsource
      b_nonlinear=b_v_max2.or.b_vphase2
     &                    .or.b_v_max3.or.b_vphase3
      b_scale=b_v_max.or.b_channel_v0.or.b_nonlinear.or.b_align
      dv=abs(v_max)/float(km)

      b_fresonant=b_f_factor.or.b_bg_fraction
      fresonant=f_factor*(1.0-bg_fraction)
      if(fresonant.gt.1.) write(nwr,'(2a)')
     &      '**warning** fresonant larger than 1'
      
      b_drive=b_geo.or.b_scale
      
c      write(6,'(a,4i6)') ' ***moss_the2exp nstorTH,nstorThyy=',
c     &       nstorTH,nstorThyy

      k1=n1
      goto (100,200,300),k1
      
 100   continue
c      calculation of thfk
       ibmisfit=0
       if(b_base.or.b_fresonant.or.b_drive.or.b_total.or.b_align)then
        call drive(mode_drive)
        
c        write(6,'(a,2i4,3x,4f10.3)')' ichanks(1,2),v_max,v1,v2=',
c     &   ichanks(1),ichanks(2),v_max,
c     &    velocity(ichanks(1)),velocity(ichanks(2))
        if(flag_misfit.eq.1) then
         ibmisfit=1
         b_misfit=.true.
        end if

        if(nomsamp.gt.1) then
c        cosine smearing and aperture effects
c         write(6,'(a)')' nomsamp.gt.1'
         do j =0,km
          yth(j)=alog(real(array_fr(ka+j)))
          yth(-j)=alog(aimag(array_fr(ka+j)))
         end do
         do k=1,km/4
          yth(-km-k)=yth(-km)
          yth(km+k) =yth(km)
         end do
     
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           call geometry(j,cosa,a_r,jsum)
           ff=0.0
c          if(j.eq.100.or.j.eq.256)then
c           write(6,'(i4,a,2f10.3)')jsum,'=jsum cosa,a_R:'
c           write(6,'(8f10.3)')(cosa(i),i=1,jsum)
c          end if
           do l=1,jsum
            vn=velocity(j)*cosa(l)
            hi=vn/dv
            i=int(hi)
c           cosa(k)=1.0
            y1=exp(yth(i-1)/cosa(l))
            y2=exp(yth(i)/cosa(l))
            y3=exp(yth(i+1)/cosa(l))
            hi=hi-float(i)
            fa=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
            ff=ff+(1.-(1.-fa)*fresonant)*a_r(l)
           end do
           thfk(j)=base*ff
  
           ff=0.
           if(b_misfit)then
            do l=1,jsum 
             ff=ff+base*a_r(l)
            end do
            dfdp(j)=ff
           end if
          end do
         end do
        else 
c        no cosine smearing
         do j =0,km
          yth(j)=base*(1.-(1.-real(array_fr(ka+j)))*fresonant)
          yth(-j)=base*(1.-(1.-aimag(array_fr(ka+j)))*fresonant)
         end do
         do k=1,km/4
          yth(-km-k)=yth(-km)
          yth(km+k) =yth(km)
         end do
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           vn=velocity(j)
           hi=vn/dv
           i=int(hi)
c           if(abs(i).gt.256)then
c             write(6,'(a,2i8,3x,4f10.3)')' i,j,vn,dv=',i,j,vn,dv
c             read(5,'(i4)')i
c           end if
           y1=yth(i-1)
           y2=yth(i)
           y3=yth(i+1)
           hi=hi-float(i)
           ff=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
           thfk(j)=ff*geof(j)
  
           if(b_misfit)then
            dfdp(j)=base*geof(j)
           end if

          end do
         end do
        end if
        do j=1,nchansp
         real_fr(nTHyy2+j)=thfk(j)
        end do
c       write(6,'(a,4f15.1)') 'getthinf array_fr(1,2) =',
c    &  (array_fr(iarray_sp-1)),array_fr(iarray_sp)
       else
        do j=1,nchansp
         thfk(j)=real_fr(nTHyy2+j)
        end do
       end if
       b_theory=.true.
      return
      
 200  continue
c     derivatives
c      write(6,'(a,f15.5)') ' derivative step=',ddpk

      ib_df=0
      kana=0
      do j=1,nchansp
       thfk(j)=real_fr(nTHyy2+j)
      end do
c     parameter pl(j)

c     variable pl(1)
      if(b_base) then
       b_residual=b_geo.or.b_scale.or.b_fresonant
       if(b_residual) then
        goto 240
       else
c        write(6,'(a,f10.1)')  'derivative of base -----base=',base
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          dfdp(j)=thfk(j)/base
         end do
        end do
        kana=1
        ib_df=1
        goto 250
       end if
      end if
      
c     variable pl(3)
      if(b_geo) then
       b_residual=b_base.or.b_scale.or.b_fresonant
       if(b_residual) then
        goto 240
       else
c       write(6,'(a)')  '   derivative of geo ------------'
c       in case of cosine smearing this derivation is approximate
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          dfdp(j)=dfdgeo(j)*thfk(j)
         end do
        end do
        kana=1
        ib_df=1
        goto 250
       end if
      end if
      
      if(b_fresonant) then
       if(b_bg_fraction.and.b_f_factor) then
        write(nwr,'(a)')
     &  '**warning parameters:bg_fraction,f_factor are correlated by 1'
       end if
       if(b_bg_fraction) then
c       variable pl(2)
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          dfdp(j)=-(thfk(j)-base*geof(j))/(1.0-bg_fraction)
         end do
        end do
        kana=1
        ib_df=1
        goto 250
       end if
      
       if(b_f_factor) then
c      variable pl(2)
        b_residual=b_base.or.b_geo.or.
     &                            b_scale.or.b_bg_fraction
        if(b_residual) then
         goto 240
        else
c        write(6,'(a)')  '   derivative of f_factor ------------'
c        in case of cosine smearing this derivation is approximate
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           dfdp(j)=(thfk(j)-base*geof(j))/f_factor
          end do
         end do
         kana=1
         ib_df=1
         goto 250
        end if
       end if
      end if

 240  kana=0      
      call drive(mode_drive)

      if(nomsamp.gt.1) then
c      cosine smearing and aperture effects
       do j =0,km
        yth(j)=alog(real(array_fr(ka+j)))
        yth(-j)=alog(aimag(array_fr(ka+j)))
       end do
       do k=1,km/4
        yth(-km-k)=yth(-km)
        yth(km+k) =yth(km)
        end do
    
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          call geometry(j,cosa,a_R,jsum)
          ff=0.0
          do l=1,jsum
           vn=velocity(j)*cosa(l)
           hi=vn/dv
           i=int(hi)
           y1=exp(yth(i-1)/cosa(l))
           y2=exp(yth(i)/cosa(l))
           y3=exp(yth(i+1)/cosa(l))
           hi=hi-float(i)
           fa=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
           ff=ff+(1.-(1.-fa)*fresonant)*a_r(l)
          end do      
          dfdp(j)=(base*ff-thfk(j))/ddpk 
         end do 
        end do       ! j=1,nchansp

       else 
c       no cosine smearing
        do j =0,km
         yth(j)=base*(1.-(1.-real(array_fr(ka+j)))*fresonant)
         yth(-j)=base*(1.-(1.-aimag(array_fr(ka+j)))*fresonant)
        end do
        do k=1,km/4
         yth(-km-k)=yth(-km)
         yth(km+k) =yth(km)
        end do
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          vn=velocity(j)
          hi=vn/dv
          i=int(hi)
          y1=yth(i-1)
          y2=yth(i)
          y3=yth(i+1)
          hi=hi-float(i)
          ff=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
          dfdp(j)=(ff*geof(j)-thfk(j))/ddpk
         end do 
        end do       ! j=1,nchansp
       
       end if
       ib_df=1
c      write(6,'(4e15.6)') (dfdp(i),i=1,nchansp,32)
 250  continue
      return
      
 300  continue
      if(.not.b_theory) goto 310
c     this label address is used for the calculation of subspectra      

      if(ifrcase.eq.6) then
       call mossbauer_refl(b_total,info)
      else
       call mossbauer_trm(b_total,info)
      end if


      if(nomsamp.gt.1) then
c      cosine smearing and aperture effects
       do j =0,km
        yth(j)=alog(real(array_fr(ka+j)))
        yth(-j)=alog(aimag(array_fr(ka+j)))
       end do
       do k=1,km/4
        yth(-km-k)=yth(-km)
        yth(km+k) =yth(km)
       end do

        do j=1,nchansp
         call geometry(j,cosa,a_R,jsum)
         ff=0.0
         do l=1,jsum
          vn=velocity(j)*cosa(l)
          hi=vn/dv
          i=int(hi)
          y1=exp(yth(i-1)/cosa(l))
          y2=exp(yth(i)/cosa(l))
          y3=exp(yth(i+1)/cosa(l))
          hi=hi-float(i)
          fa=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
          ff=ff+(1.-(1.-fa)*fresonant)*a_r(l)
         end do
         thfk(j)=base*ff
        end do
      else 
c      no cosine smearing
       do j =0,km
        yth(j)=base*(1.-(1.-real(array_fr(ka+j)))*fresonant)
        yth(-j)=base*(1.-(1.-aimag(array_fr(ka+j)))*fresonant)
       end do
       do k=1,km/4
        yth(-km-k)=yth(-km)
        yth(km+k) =yth(km)
       end do
        do j=1,nchansp
         vn=velocity(j)
         hi=vn/dv
         i=int(hi)
         y1=yth(i-1)
         y2=yth(i)
         y3=yth(i+1)
         hi=hi-float(i)
         ff=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
         thfk(j)=ff*geof(j)
        end do
      end if

 310  return
      end
      
           

  
      subroutine  moss_subspect(cmch,mi,isub,info)
      implicit none
      include 'comglb.for'
      include 'complt.for'
      include 'comdat.for'
      
      integer idumscrt,mi,nchansp,
     &        i,ip,l,ll,j,isub,k1,info
      real    dum,channels,avsp,f_factor,base,dumcsp,dumcvs,dumscrt,
     &        datx,errx,sym,subspectrum,plold
      
      common/acstrf/ dum(5),
     &               channels,dumcsp(icstrf-6)
      common/avstrf/ avsp,f_factor,base,dumcvs(ivstrf-3)

      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit

      parameter(idumscrt=maxscrt-maxn*maxsub-3*maxn)
      common/scrt/datx(maxn),errx(maxn),sym(maxn),
     &            subspectrum(maxn,maxsub),dumscrt(idumscrt)
      real velocity,geof,dfdgeo,p0
      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn)
      
      character cmch*4
      dimension plold(maxthss)

c     write(6,'(a,a)') '*********subroutine subspmoss********',cmch
      nchansp=channels

      do i=1,maxn
       dumscrt(i)=thfk(i)
      end do       
      
       call calpl('test')
      
       do  i=1,mi
        plold(i)=0.0
        call replace_wi(-i,plold(i),info)  ! - take out and write on plold(i)
       end do
c      write(6,'(a,6f10.3)')' subsp-plold(1..)=',(plold(i),i=1,mi)
       nchansp=channels
      
       do  l=1,n_subset
        p0=0.0
        do j=1,mi
         call replace_wi(j,p0,info)          ! + write 0 to wi values
        end do
      
c       write(6,'(a,i4,a,30i3)')' l_subsp=',l,
c     &         ' n_int(l,ll)=',(n_int(l,ll),ll=0,n_int(l,0))
        do ll=1,n_int(l,0)
         ip=n_int(l,ll)
         call replace_wi(ip,plold(ip),info)  ! + write plold(ip) to wi values
        end do
      
        k1=3
        call sel_the2exp(cmch,k1,info)
        do  i=1,nchansp
         subspectrum(i,l)=thfk(i)
        end do
c        write(6,'(a,i4)') 'frame01 subspectrum i=',l
c        write(6,'(4e15.6)') (thfk(i),i=1,nchansp,64)
       end do
      
       do  i=1,mi
        call replace_wi(i,plold(i),info)  ! + write plold(i) to wi values
       end do
c       call moss_the2exp(k1,info)
      
      do i=1,maxn
       thfk(i)=dumscrt(i)
      end do 
      return
      end
      
      subroutine  moss_subtract(cmch,mi,isub,info)
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'complt.for'
      include 'comdat.for'
      include 'comdas.for' 
      include 'comthe.for'
     
      integer idumscrt,mi,nchansp,
     &        i,j,jj,isub,k,k1,info
      real    dum,channels,avsp,f_factor,base,dumcsp,dumcvs,dumscrt,
     &        datx,errx,sym,subspectrum,plold
      
      common/acstrf/ dum(5),
     &               channels,dumcsp(icstrf-6)
      common/avstrf/ avsp,f_factor,base,dumcvs(ivstrf-3)
      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit

      parameter(idumscrt=maxscrt-maxn*maxsub-3*maxn)
      common/scrt/datx(maxn),errx(maxn),sym(maxn),
     &            subspectrum(maxn,maxsub),dumscrt(idumscrt)
      real velocity,geof,dfdgeo,p0
      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn)
      
      character cmch*4
      dimension plold(maxthss)

c     write(6,'(a,a)') '*********subroutine subspmoss********',cmch
      nchansp=channels

      do i=1,maxn
       dumscrt(i)=thfk(i)
      end do       
      
c     write(6,'(a,i4)') ' ********** mi=',mi
      
       call calpl('test')
       do  i=1,mi
        plold(i)=0.0
        call replace_wi(-i,plold(i),info)  ! - take out and write on plold(i)
       end do
c      subtract y - yy
      
c      absorber complete , source and detector window subtracted
      
       nchansp=channels
      
       p0=0.0
       do j=1,isub
        do i=1,mi
         call replace_wi(i,p0,info)  ! + write 0 to wi values
        end do
      
        do i=1,n_sub(j,0)
         jj=abs(n_sub(j,i))
         call replace_wi(jj,plold(jj),info)  ! + write plold(jj) to wi values
        end do
      
        k1=3
        call sel_the2exp(cmch,k1,info)
      
c      write(6,'(a)') ' ------1----back in subtract----------------'
      
        do k=2,ichanks(0),2
         do i=ichanks(k-1),ichanks(k)
          real_fr(mfpt+i)=real_fr(mfpt+i)-(thfk(i)-base*geof(i))
         end do
        end do
       end do  ! isub
      
c      calculation of the theory of the stripped spectrum
       p0=0.0
       do i=1,mi
        call replace_wi(i,p0,info)  ! + write 0.0 to wi values
       end do
      
       do i=1,n_sub(0,0)
        jj=n_sub(0,i)
        call replace_wi(jj,plold(jj),info)  ! + write plold(jj) to wi values
       end do
      
       k1=3
         ! values are not reset by calpl, written on theory-array
       call sel_the2exp(cmch,k1,info)
      
c      write(6,'(a)') ' ------2----back in subtract----------------'
c      restore parameters
       call calpl('test')

      do i=1,maxn
       thfk(i)=dumscrt(i)
      end do 
      
      return
      end

c      subroutine forstruct
c      implicit none
c      include 'comglb.for'
c      integer      istruct,idum 
c      parameter   (istruct=2+4*maxfr1+4+4*maxfr2+3*maxthss+32+8+8+16)
c      common/struct/idum(istruct)    
c      return
c      end
