c     author : h. spiering
c              institut f. anorg. u. anal. chemie
c              johannes gutenberg-universitaet
c              d-55099 mainz
c              last version august 2002

      subroutine fr_stroboscopy(cmch,iss,info)
c     cmch:= arra,extr; test,dfdp,dmod,plot,data,...
c     iss 
      implicit none
       include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'comdas.for'
      include 'complt.for'
      include 'comthe.for'

c     common/struct is stored by effi for each set.
c     istruct0 containes dimensions which are use in the 
c     main routines strob_the2exp and moss_strob

c     mstruct1,istruct1,istruct2 defines the structure of realized
c     in moss_strob 
c     l1_get,...,l3_get are the array addresses of array_fr, 
c     where the results of the routines called by get_theory 
c     are stored.
c     l1_put,...,l3_put are the array addresses of array_fr,
c     where results of the main routine moss_strob are stored
c     the list of addresses can be printed by the command 
c     st 4_yxxx (see he {st})
c     c1_prp,...,c3_prp are properties of the stored data of different 
c     structural levels. Here the property polarized/scalar is stored
c     by the first character ci_prp(1:1) being T (polarized) or F (scalar)
c     (storage of 2x2 matrices/storage of a scalar for each channel).
          
      integer     iss,info
      integer     ifrth,iaddr,idex,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,nstorTH1,nstorTHyy,nstorSI,idum1,idum2,nCC,
     &            idum3,idum4,nLG,ipLG,nRS,nTH,nsampling
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,nstorTHyy,nstorSI,
     &              ipLG,iaddr(3),idum1,idum2,nCC,ifrth(5),                    
     &              idum3,idum4,nLG,nRS,nTH,nsampling,idex(10)


c     nRS is the dimension for  th_22index, nTh for strob_the2exp

      real          acsp,wavelength,uthick_w,uthick_A,
     &              unitchi,channels,v_range,
     &              th_channels,th_sampling,drive_mode,channels_vmax,
     &              Tbunch,flag_basis,flag_phase,strob_order,dumcs
      common/acstrf/acsp,wavelength,uthick_w,uthick_A,
     &              unitchi,channels,v_range,
     &              th_channels,th_sampling,drive_mode,channels_vmax,
     &              Tbunch,flag_basis,flag_phase,strob_order,
     &              dumcs(icstrf-15)  

      real          avsp,dum1,base,dum2,v_max,dumv
      common/avstrf/avsp,dum1,base,dum2,v_max,dumv(ivstrf-5)

      integer mscrd,lstruct1,lstruct2,lstruct3,mode_drive
      real    dumscrd
      parameter (mscrd=maxscrd-3*(maxthss+1))

      character cmch*4,ch8*8,ch1*1,text(3)*40,ch132*132,cp132*132
      integer   nchansp,nrsl,nstorlg,jss,jpol,nstorint,nstrob_order,
     &          i,isub,k,k1,k2,l1,l2,l3,mi
      real omega

c     -nTH, 0, +nTH channels of theoretical spectrum
c     (this will be projected on to the experimental spectrum) 

c     nTH  channel correspond to v_max of the experimental spectrum
c     (definition n_v_max=nTH, n_v corresponds to velocity v)

c     v_range velocity range of the Mossbauer spectrum of the sample
c     v_max > v_range; if the 1. stroboscopic order can be resolved
c     (see time windows , Tbunch dependency) v_max > 3*v_range 

c     nRS=(nstrob_order/2*omega/+v_max+v_range)/v_max*nTH
c     -nRS,0,+nRS channels for the sample (scatterer) and reference 
c     spectrum is stored
c     (definition nstrob=-nstrob_order,..,0,..,nstrob_order)

c     integration -> summation over channels in the integral 
c      Sum T(n+n_omega/2,n_v)*T(n-n_omega/2,n_v)
c      runs as follows  
c      +v: from -v_range/v_max*nTH-nstrob/2*omega/Tbunch
c          to   +v_range/v_max*nTH+nstrob/2*omega/Tbunch+n_v

c     nLG=nRS+nTH
c     the Lorentz curves are shifted up to line positions (of sample
c     and reference) at channel nTH.

c*****************************************************************************
c
c      write(6,'(3a,i3,a,l3)') 'frame01 cmch=',cmch,' iss=',iss,
c     &           ' b_theory=',b_theory
      if(cmch.eq.'thna') then
       theoryname='Mossbauer synchrotron stroboscopy      v=100'
       thfrcase(1)='stroboscopic transmission spectrum(1)'
       thfrcase(2)='stroboscopic reflection spectrum(2)'     
       thfrcase(3)=' '
       return
      end if 
      if(cmch.eq.'dstr') goto 100           
c*****************************************************************************

      nchansp=channels
      if(cmch.eq.'arr0') then
       ipLG=nuofdatas

c      channel numbers of RF 
c      hc/E0= 86.0165018        
c      Tbunch
       nstrob_order=strob_order                ! obtained from subtheory
c                                        called on level 0
       omega=wavelength/Tbunch*100.      ! A/ns=100mm/s
       nTH=th_channels
    
       if(nTH.gt.maxn/2) nTH=maxn/2
       nsampling=2**th_sampling
       if(nsampling.gt.8.0) nsampling=8.0
       
       nRSl=(nstrob_order*omega+2*v_max+v_range)/v_max*nTH
       nLG=8*(nRSl+nTH)
       nstorLG=ipLG+5+(nLG+1)+(nLG+mGa+1)+mGa/2+1 

c       write(6,'(a,4i6)')'nTH,nLG,nstorLG=',nTH,nLG,nstorLG

       if(nRSl.gt.mLG) then
        call c8toi(ch8,mLG)
        info=nRSl
        infotext(1)=
     &  'theory/Mossbauer_stroboscopy/moss-strob/channels'
        infotext(2)=' number of channels too large'
        infotext(3)=ch8//' maximum number of '//
     &   '(nstrob_order*omega+2*v_max+v_range)/v_max*th_channels'
        infotext(4)=' '
        return
       end if
       ifrsto=nstorLG+2*(nTH+1)+2+nchansp/2+maxsub*(1+maxthss)

c      the relativ addresses are stored after finishing
c      the entries arr0,i,e
       nstorTH=nstorLG
       nstorTH1=nstorTH+2*(nTH+1)
       nstorTHyy=nstorTH1+2
       nstorSI=nstorTHyy+nchansp/2
c      the relativ addresses are reloaded before entering frtheoryxx
c      and changed to absolute addresses which are temporarily stored 
c      the 8 integers following c3_prp(maxthss) are considered to be 
c      relative addresses which during reloading are changed to absolute
c      addresses of the complex array  'array_fr(1:marray_sp). 


       nCC=(nRSl+4)*8/nsampling
       nRS=nCC
       omega=omega*nTH*8/nsampling
       return
      else if(cmch.eq.'arri') then 

c      1 site storage on the site level (lstruct3)
c      address:   l3_put(lstruct3)
c      1 layer storage on the layer level (lstruct2)
c      address:   l2_put(lstruct2)
c      storage for each lstruct1, 
c      address: l1_put(lstruct1)      
c      
c      If any site is polarized => polarization. 
     
c      polarization of a layer  lstruct2
       call l_structure(iss,lstruct1,lstruct2,lstruct3)
c       write(6,'(a,4i3)')'jss,l1,l2,l3=',iss,lstruct1,lstruct2,lstruct3
c       write(6,'(i4,2x,a4,4x,a4)')(jss,c_prop(jss),c3_prp(jss),jss=1,10)

       ifrsto=0
       jpol=-1
       if(lstruct3.eq.0.and.lstruct2.gt.0.)then 
        if(istruct1(lstruct1)-istruct1(lstruct1-1).gt.1)then
         jpol=0
         jss=1       
         do l1=1,lstruct1
c          write(6,'(i4,a,8x,a4)')jss,' c1_prp(jss)=',c1_prp(jss)
          jss=jss+1        
          do l2=istruct1(l1-1)+1,istruct1(l1)
c          write(6,'(i4,a,12x,a4)')jss,' c2_prp(jss)=',c2_prp(jss)
           jss=jss+1
           do l3=istruct2(l2-1)+1,istruct2(l2)
            if(l1.eq.lstruct1.and.l2.eq.lstruct2.and.
     &                     c3_prp(l3)(1:4).eq.'plrs') jpol=1
c           write(6,'(a,4i3)')'jss,l1,l2,l3=',jss,l1,l2,l3
c           write(6,'(i4,a,a4,12x,a4)')jss,' c3_prp(jss)=',
c     &              c3_prp(l3)
            jss=jss+1
           end do 
          end do
         end do
        end if
       end if

c      Storage of the theory of each lstruct1 
       if(lstruct2+lstruct3.eq.0) then
c       if any site is polarized => polarization.
         jpol=0 
         jss=1       
         do l1=1,lstruct1
          jss=jss+1        
          do l2=istruct1(l1-1)+1,istruct1(l1)
           jss=jss+1
           do l3=istruct2(l2-1)+1,istruct2(l2)
c            write(6,'(a,3i4,2x,a5)')'jss,l1,lstruct1,c3_prp(jss)=',
c     &                         jss,l1,lstruct1,c3_prp(l3)
            if(l1.eq.lstruct1.and.c3_prp(l3)(1:4).eq.'plrs')jpol=1
            jss=jss+1
           end do 
          end do
         end do
       end if

       if(jpol.eq.1) then
        ifrsto=8*(8*nCC/nsampling+1)
       else if(jpol.eq.0) then
        ifrsto=2*(8*nCC/nsampling+1)
       end if
c       write(6,'(a,3i6)')'ifrsto=',ifrsto,nsampling,nCC
       return
      else if(cmch.eq.'arre') then
c      The size of  storage li_get and li_put is known by the property 
c      polarized T or F.
c       write(6,'(a,8a6)')' fr_strob c1_prp=',(c1_prp(i),i=0,4)
c       write(6,'(a,8a6)')' fr_strob c2_prp=',(c2_prp(i),i=1,8)
c       write(6,'(a,8a6)')' fr_strob c3_prp=',(c3_prp(i),i=1,8)
       
       iss=1
       do lstruct1=1,mstruct1
c        write(6,'(a,i2,a2,a4)')'c1_prp(',lstruct1,')=',c1_prp(lstruct1)  
        c1_prp(lstruct1)='F'
        iss=iss+1
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)
c        write(6,'(a,i2,a2,a4)')'c2_prp(',lstruct2,')=',c2_prp(lstruct2)  
         c2_prp(lstruct2)='F'
         iss=iss+1
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)
c          write(6,'(a,i4)')' iset=',lstruct3
          if(c3_prp(lstruct3)(1:4).eq.'plrs') then
           c3_prp(lstruct3)='T'
           c2_prp(lstruct2)='T'
          else
           c3_prp(lstruct3)='F'
          end if
          iss=iss+1
         end do
         if( c2_prp(lstruct2)(1:1).eq.'T') c1_prp(lstruct1)='T'
        end do
       end do

c       write(6,'(a,8a6)')' fr_strob c1_prp=',(c1_prp(i),i=0,4)
c       write(6,'(a,8a6)')' fr_strob c2_prp=',(c2_prp(i),i=1,8)
c       write(6,'(a,8a6)')' fr_strob c3_prp=',(c3_prp(i),i=1,8)

       ifrsto=0
       return
      end if     ! arr0,i,e

      mode_drive=drive_mode
c      write(6,'(a,i4,L5)')'frame04 mode_drive,b_data=',mode_drive,b_data
c      write(6,'(a)')'frame04 arre'
c      write(6,'(8a4)')(c1_prp(i),i=1,mstruct1)
c      write(6,'(8a4)')(c2_prp(i),i=1,istruct1(mstruct1))
c      write(6,'(8a4)')(c3_prp(i),i=1,istruct2(istruct1(mstruct1)))


c     initializing the array_fr section for nstorint (see subspectra)
c     (intensity of all subsets are 0)

      if(.not.b_theory) then
c       absolute address of nstorSI is known here
        nstorint=maxsub*(1+maxthss)
        do k=1,nstorint
         array_fr(nstorSI+k)=(0.,0.)
        end do
      end if

      if(cmch.ne.'data'.and.(.not.b_data)) mode_drive=1
      mi=istruct2(istruct1(mstruct1))
c     total number of intensity values of the subsets.
c     see select subset 

c      storag on real_fr(2*(iarraysp+nstorFR)+m) (array_f) 
c      corresponds to the i= drive_mode (label 100) 
       mfpt=2*(iarray_sp+nstorFR)  ! y data
       mdfpt=mfpt+nchansp         ! errors of y data (calculated by sqrt 
       mxpt=mfpt+2*nchansp        ! x data (velocity) drive_mode=3

c*****************************************************************************
      if(cmch.eq.'data') then
       k1=1
      else if(cmch.eq.'ecic') then
       k1=2
      else if(cmch.eq.'test') then
       k1=3
      else if(cmch.eq.'dfdp') then
       k1=4
      else if(cmch.eq.'subs'.or.cmch.eq.'subt') then
       k1=5
      else if(cmch(1:3).eq.'ple') then
       k1=6
      else if(cmch.eq.'dmod'.or.cmch.eq.'plot') then
       k1=7
      else if(cmch.eq.'punc')then
       k1=8
      end if
      
      goto (110,120,200,300,400,500,600,700),k1
c**********************************************************************
 100  continue
      mode_drive=int(drive_mode)
      if(mode_drive.lt.1.or.mode_drive.gt.3)mode_drive=1
      if(mode_drive.le.2) data_str='y,dy'
      if(mode_drive.ge.3) data_str='y,dy,x'
      call data2dread(0,info)
      return
 110  continue
      k1=iss
      call data2dread(k1,info)  
      return
 120   call excinc2d(info)
      return
c************************************************************************
c     'test': theory function is calculated in subroutine mossbauer
  200 continue
      k1=1
      call strob_the2exp(k1,info)
c     write(6,'(a)') ' after strob_the2exp  test'
      return
c*****************************************************************************
c     derivatives df
  300 continue
      k1=2
      call strob_the2exp(k1,info)
      return
c*****************************************************************************
c     subs, subt
  400 continue

      text(1)='        reference'
      text(2)='           sample'
      text(3)=' '
      if(cmch.eq.'subt') goto 450

      ch1=' '
      if(b_data) then
       ch132=name_data
      else
       ch132=name_theory
      end if
      call chcenter(ch132,ch1,ncl)
      cp132='plot of subspectra of'
      call chcenter(cp132,ch1,ncl)
      print *,' '
      write(nwr,'(a,/,a)') cp132(:ncl),ch132(:ncl)
      ch132='subspectra /added subspectra of'
      call chcenter(ch132,ch1,ncl)
      write(nwr,'(/,a)') ch132(:ncl)
      call moss_selsubspect(text)
      return
c*************************************************************
c  call of moss_subtract
 450  continue
      print *,' '
      print *,' '
      print *,'                     subtraction of subspectra'
      call moss_selsubtract(text,isub)
      call drive(mode_drive)
      call moss_subtract('stro',mi,isub,info)
      k1=1
      call strob_the2exp(k1,info)
      call moss_plot(cmch)
      k1=0
      k2=0
      if(b_theory) k1=1
      call xmosplo(k1,k2)
      return
c**************************************************************************
c     plot execute
c     different plot programs may be called due to a flag constant 
c     to be introduced as global constant
  500 continue
       
       k1=0
       if(b_theory) k1=1
       if(cmch(4:4).eq.'2') k1=2   ! update test
       if(cmch(4:4).eq.'3') k1=3   ! update fit

       k2=1  ! 0: only 1 plot and return, 1: interactive plot
       call xmosplo(k1,k2)

       return
c**************************************************************************
c     display mode , filling of plotarray
 600  continue
c     write(6,'(a,a)') '********* 500 ********',cmch

      if(cmch.eq.'dmod') then
       call moss_plot(cmch)
      else
       call drive(mode_drive)
       if(b_theory) then
        k1=3
        call strob_the2exp(k1,info)
        if(n_subset.gt.0)
     &       call moss_subspect('stro',mi,isub,info)
       end if
       call moss_plot(cmch)
      end if
      return
c**************************************************************************
c     punch data and theory
 700  continue
       k1=iss
       call punch2d(k1,info)
      return

      end



      subroutine strob_the2exp(k1,info)
c *****************************************************************
c     k1 = 1 call of theory
c     k1 = 2 derivatives
c     k1 = 3 call of theory , calpl is not called
c *****************************************************************
      implicit none
      include 'comglb.for'
      include 'comdat.for'
      include 'comthe.for'
      
      integer     k1,info
      integer     ifrth,iaddr,idex,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,idum1,nstorTHyy,idum,nTH
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,idum1,nstorTHyy,iaddr(5),
     &              ifrth(8),idum(4),nTH,idex(11)

      real          acsp,wavelength,uthick_w,uthick_A,
     &              unitchi,channels,v_range,
     &              th_channels,th_sampling,drive_mode,channels_vmax,
     &              Tbunch,dumcs
      common/acstrf/acsp,wavelength,uthick_w,uthick_A,
     &              unitchi,channels,v_range,
     &              th_channels,th_sampling,drive_mode,channels_vmax,
     &              Tbunch,dumcs(icstrf-12)  

      real    avsp,dum1,base,dum2,v_max,
     &        channel_v0,v_max2,channel_v02,v_max3,channel_v03,geo,       
     &        t_shift,Pxsi,Peta,Pzeta,graz_angle,dumv     
      common/avstrf/avsp,dum1,base,dum2,v_max,
     &        channel_v0,v_max2,channel_v02,v_max3,channel_v03,geo,       
     &        t_shift,Pxsi,Peta,Pzeta,graz_angle,dumv(ivstrf-16)     
      logical b_vs,b_dum1,b_base,b_dum2,b_v_max,b_channel_v0,
     &        b_v_max2,b_vphase2,b_v_max3,b_vphase3,b_geo,b_t_shift,
     &        b_Pxsi,b_Peta,b_Pzeta,b_graz_angle,b_dumv
      common/bvstrf/b_vs,b_dum1,b_base,b_dum2,b_v_max,b_channel_v0,
     &        b_v_max2,b_vphase2,b_v_max3,b_vphase3,b_geo,b_t_shift,
     &        b_Pxsi,b_Peta,b_Pzeta,b_graz_angle,b_dumv(ivstrf-16)

      logical b_total

      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit
      real      yth
      dimension yth(-maxn:maxn)


      real velocity,geof,dfdgeo,h,hi,y1,y2,y3,ff,dv
      common/adrive/velocity(maxn),geof(maxn),dfdgeo(maxn)
      integer nchansp,nchansp2,i,istorth,j,k,mode_drive,nTHyy2
      logical b_residual,b_abscissa

c     write(6,'(3(a,i6))') ' idumscrt=',idumscrt
c      write(6,'(a,f10.1)') ' ***strob_the2exp base=',base
      ibmisfit=0
      if(base.eq.0.) then
        info=1
        infotext(1)='<Mossbauer_stroboscopy>/parameter/global/base0'
        infotext(2)='**error** base = 0 '
        infotext(3)=' '
        return
      end if
      geo=0.

      nchansp=channels
      mode_drive=drive_mode

      h=abs(channel_v0/channels_vmax-1.0)*10
      if(h.gt.1.0.or.nchansp.gt.maxn) then
        write(infotext(3),'(a,i5,2(a,f8.2))')
     & 'nchansp=',nchansp,' channels_vmax=',channels_vmax,
     &  ' channel_v0=',channel_v0

        info=10*h
        infotext(1)='<Mossbauer_stroboscopy>/global_pa/ch_vmax/ch_v0'
        infotext(2)='**error** with one of the size of'//
     &      ' channels,channels_vmax,channel_v0'
        infotext(4)=' '
        return
      end if
c      write(6,'(a,2f15.3)')' frame04 moss_strob base=',base

      nchansp2=nchansp/2
      istorTH=nstorTH+1

      b_abscissa=b_v_max.or.b_channel_v0
      b_abscissa= b_abscissa.or.b_v_max2.or.b_vphase2
     &                    .or.b_v_max3.or.b_vphase3
      dv=abs(v_max)/float(nTH)

c      write(6,'(a,4i6)') ' ***strob_the2exp nstorTHyy,nstorThyyp=',
c     &       nstorTHyy,nstorThyy

      nTHyy2=nstorTHyy*2

      call moss_strob(b_total,info)
c     write(6,'(a,L5,4i6)') 'strob_the2exp b_total=', b_total
      
      goto (100,200,300),k1

 100   continue

c        write(6,'(a,i8,4f15.4)')' frame04 nstorTH1,R_oo=',
c     &  nstorTH1,array_fr(nstorTH1+1),
c     &           array_fr(nstorTH1+2)

       if(b_base.or.b_abscissa.or.b_total) then
        call drive(mode_drive)

        do j =0,nTH
         yth(j)=base*real(array_fr(istorTH+j))
         yth(-j)=base*aimag(array_fr(istorTH+j))
        end do
        do k=1,nTH/4
         yth(-nTH-k)=yth(-nTH)
         yth(nTH+k) =yth(nTH)
        end do

c       write(6,'(a,L5,f10.1,i8)')'b_total,base,istorTH=',
c     &          b_total,base,istorTH
c       write(6,'(6e15.6)') (yth(j),j=-nTH,nTH,16)
c       write(6,'(a,2f10.4,i5)')'velocity(j),v_max,dv,nchannel=',
c     &          v_max,dv,nchansp
c       write(6,'(8i6)') (int(velocity(j)/dv),j=1,nchansp,64)

        do j=1,nchansp
         hi=velocity(j)/dv
         i=int(hi)
         y1=yth(i-1)
         y2=yth(i)
         y3=yth(i+1)
         hi=hi-float(i)
         ff=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
         thfk(j)=ff
        end do
        do j=1,nchansp
         real_fr(nTHyy2+j)=thfk(j)
        end do
       else
        do j=1,nchansp
         thfk(j)=real_fr(nTHyy2+j)
        end do
       end if
c        write(6,'(a,2i8,4f15.4)')
c     &  '*frame04 iarray_sp,nstorTHyy,R_oo=',
c     &  iarray_sp,nstorTHyy,array_fr(nstorTHyy+1),
c     &                               array_fr(nstorTHyy+2)
       b_theory=.true.
      return

 200  continue
      ib_df=0
c     derivatives
     
c      base is analyticaly derived
            
c      common/avstrf/avsp,base,v_max,channel_v0,
c     &              v_max2,channel_v02,v_max3,channel_v03,geo,       
c     &              t_shift,Pxsi,Peta,Pzeta,graz_angle,dumv(idumv)     

      
      do j=1,nchansp
       thfk(j)=real_fr(nTHyy2+j)
      end do
      b_residual=.not.(b_total.or.b_abscissa)
      if(b_base.and.b_residual) then
c       write(6,'(a,f10.1)')  'derivative of base -----base=',base
        do j=1,nchansp
         dfdp(j)=thfk(j)/base
        end do
        kana=1
        ib_df=1
        goto 250
      end if


 
      b_residual=.not.(b_total.or.b_base.or.b_abscissa)
      if(b_residual) goto 250

      kana=0
      do j =0,nTH
       yth(j)=base*real(array_fr(istorTH+j))
       yth(-j)=base*aimag(array_fr(istorTH+j))
      end do
      do k=1,nTH/4
       yth(-nTH-k)=yth(-nTH)
       yth(nTH+k) =yth(nTH)
      end do

      call drive(mode_drive)

      do j=1,nchansp
       hi=velocity(j)/dv
       i=int(hi)
       y1=yth(i-1)
       y2=yth(i)
       y3=yth(i+1)
       hi=hi-float(i)
       ff=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
       dfdp(j)=(ff-thfk(j))/ddpk
      end do   ! j=1,nchansp
      ib_df=1

 250  continue
c     write(6,'(4e15.6)') (dfdp(i),i=1,nchansp,32)
      return

 300  continue
      if(.not.b_theory) goto 310

      call  moss_strob(b_total,info)
      do j =0,nTH
       yth(j)=base*real(array_fr(istorTH+j))
       yth(-j)=base*aimag(array_fr(istorTH+j))
      end do
      do k=1,nTH
       yth(-nTH-k)=yth(-nTH)
       yth(nTH+k) =yth(nTH)
      end do

      do j=1,nchansp
       hi=velocity(j)/dv
       i=int(hi)
       y1=yth(i-1)
       y2=yth(i)
       y3=yth(i+1)
       hi=hi-float(i)
       ff=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
       thfk(j)=ff
      end do
 310  return
      end



