c     author : h. spiering
c              Am Damsberg 86
c              D-55130 Mainz
c              last version April 200

      subroutine fr_synchrotron(cmch,jss,info)
c     synchrotron
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comthe.for'
      include 'comnuc.for'
      include 'comdas.for'

      integer    jss,info,
     &           ifrth,idex,mstruct1,istruct1,istruct2,iaddr,
     &           l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &           nstorTH,nstorTH1,nstorTHyy,nstorSI,nTH1,nCP,nTH2,nsrw,
     &           nstore,iflag_basis,l_Poincare,nLG,ipLG,nTH,
     &           ith_channels,nsampling,ak8,nomega,nstrob_order,jt0_ch,
     &           iT_max,nvch,nhyperfine
      real        srw8
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,nstorTHyy,nstorSI,
     &              ipLG,iaddr(3),nTH1,nCP,nTH2,nsrw,nstore,ifrth(3),           
     &              iflag_basis,l_Poincare,nLG,nTH,ith_channels,
     &              nsampling,ak8,nomega,srw8,nstrob_order,jt0_ch,
     &              iT_max,nvch,nhyperfine,idex(2)
c      1+4*maxfr1+4+4*maxfr2+1+3*maxthss+32+8+8+16             

      real          acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,t0_norm,flag_basis,
     &              th_channels,th_sampling, 
     &              strob_order,omega,dumcsp
      common/acstrf/acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,                           ! 5
     &              ak_extension,T_bunch,scale,channels,              ! 9
     &              ch_angle,graz_beg,graz_end,t0_norm,flag_basis,    ! 14
     &              th_channels,th_sampling,                          ! 16
     &              strob_order,omega,dumcsp(icstrf-19)

      real      avsp,counts,background,Pxsi,Peta,Pzeta,
     &          t_shift,graz_angle,graz_min,phi_z,detekt_eff,
     &          counts_bunch,dumvsp
      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
     &          t_shift,graz_angle,graz_min,phi_z,detekt_eff,
     &          counts_bunch,dumvsp(ivstrf-12)

      integer mscale,nchansp,moschannel,k_extension,
     &        iT_max2,lstruct1,lstruct2,lstruct3,ncloc,
     &        nstorLG,nstorint,i,j,isub,k,k1,k2,m1,m3,jshift
      real    pi,rad,vector_k,cv_ET,schrw
c**************** user defined common block and definitions ******************
      character cmch*4,text(3)*40,formdata(4)*16,ch1*1,ch132*132,
     &          cp132*132
c      used for subroutine channelnumberall(nvch,nhyperfine,nstrob_order,
c                                 nomega,iall) , thfrcase(6)
c      ichall array contains the non eqidistant channel numbers for integra-
c      tion over the stroboscopic windows (important for computation time)
       integer iall,ichall,idumscrd
       common/scrd/ichall(0:maxn*2),idumscrd(maxscrd-1-2*maxn)
       integer nstrob,n_omega,n_theta,n_angpairs,icase
c*****************************************************************************

      if(cmch.eq.'thna') then
       theoryname='Synchrotron source       v=100'
       thfrcase(1)='time differential transmission spectrum(11)   v=100'
       thfrcase(2)='time differential reflection spectrum(21)     v=100'
       thfrcase(3)='time integral - rocking curve-Fourier(22)     v=100'
       thfrcase(4)='time integral - rocking curve(24)        v=100'
       thfrcase(5)='time integral - rocking curve_fi(25)        v=100'
       thfrcase(6)='prompt - rocking curve(23)     v=100'
       thfrcase(7)='time integral - offspecular(31)          v=001'
       thfrcase(8)=' '
c      index <= 8
       return
      end if 
      if(cmch.eq.'dstr') goto 100       
c*****************************************************************************
      ncloc=ncl
      if(ncloc.gt.132)ncloc=132
c      if(cmch.eq.'plot') then
c        write(6,'(a,a)') ' fr_synmos cmch=',cmch
c      end if
      nchansp=channels
      if(cmch.eq.'arr0') then
c      ++++++++++++++++++++++++ arr0 +++++++++++++++++++++++++++++++++
       ipLG=nuofdatas
c       write(6,'(a,i8)')' frame ipLG=',ipLG
       k_extension=ak_extension
       pi=atan(1.)*4.
       rad=pi/180.
       vector_k=2*pi/wavelength    ! /Angstroem
       cv_ET=100.*wavelength       ! mm/s*ns
       iflag_basis=nint(flag_basis)
       l_Poincare=0
       if(ifrcase.eq.11) l_Poincare=1
      
       if(ifrcase.le.22) then
c       time integral - rocking curve-Fourier -------------------
        nsampling=8
 
        iT_max=nint(aiT_max)
         iT_max2=2**iT_max
         schrw=cv_ET/abs(T_bunch*iT_max2)
         i=2*v_max/schrw+1
         moschannel=1
         do while(i.gt.0)
          i=i/2
          moschannel=moschannel*2
         end do

         schrw=schrw*(moschannel-1)/moschannel
         v_max=schrw/2.0*(moschannel-1)

         nTH=moschannel*2**k_extension
         ak8=8*moschannel

         jt0_ch=t0_norm*moschannel/abs(T_bunch)
         ith_channels=moschannel

         if(enwr(6)(1:1).eq.'y') then
          write(nwr,'(a,f10.3,a,i4,/,a,/a,i3)')
     &      'actual used v_max=',v_max,
     &    '  and number of channels of the theory=',moschannel,
     &    '(in order to fulfil the FFT-conditions)',
     &    '  and number of channels for t0_norm=',jt0_ch
         end if

c        write(6,'(a,2f15.5,3i6)')
c     &  'T_bunch,aiT_max,iT_max,iT_max2,nth=',
c     &   T_bunch,aiT_max,iT_max,iT_max2,nth
c         write(6,'(a,4i6)') 'jt0_ch,nTH,nth,moschannel=',
c     &           jt0_ch,nTH,nth,moschannel
         

         if(nTH.gt.2*maxn) then
          info=nTH
          if(ifrcase.eq.22) then
           infotext(1)='<Synchrotron-time_integral>/synmos/channels'
          else
           infotext(1)='<Synchrotron-time_differential>/synmos/channels'
          end if
          infotext(2)=' number of channels too large'
          infotext(3)=' '
          return
         end if

         nCP=0
         if(ifrcase.eq.11.or.ifrcase.eq.21) then
          nCP=nTH
          nsrw=1
          do while(2*nCP.gt.maxn)
           nCP=nCP/2
           nsrw=nsrw*2
          end do
         end if
c         write(6,'(a,3i4)')'frame02 nTH,nCP,nsrw=',nTH,nCP,nsrw

         jshift=abs(t_shift/T_bunch*2.*moschannel)+1
         if(jshift.gt.maxn/4) then
          info=jshift/4
          if(ifrcase.eq.22) then
           infotext(1)='<Synchrotron-time_integral>/synmos/timeshift'
          else
          infotext(1)='<Synchrotron-time_differential>/synmos/timeshift'
          end if
          infotext(2)='t_shift channels too large'
          infotext(3)=' '
          return
         end if

c        write(6,'(a,2f10.1)')'ch_angle=',ch_angle
         srw8=schrw/8.
         nLG=(nTH+moschannel)*8

         if(ifrcase.lt.22) then
          nTH1=nTH/iT_max2
          if(nTH1.gt.512) nTH1=512
          nTH2=8*(nCP+1)
         end if
         if(ifrcase.eq.22) then
          nTH1=int(ch_angle/4.)*2
          nTH2=int(ch_angle/4.)*2
         end if
         nstorLG=5+(nLG+1)+(nLG+mGa+1)+mGa/2+1    ! Lorentz-Gauss curves
       else if(ifrcase.eq.23) then
c       ifrcase=23 prompt  ------------------------------------------
         nsampling=8
         nCP=0
         nTH=0
         srw8=0.
         nstorLG=0
         nTH1=int(ch_angle/4.)*2
         nTH2=16+int(ch_angle/4.)*2
         nstore=0
       else if(ifrcase.eq.24) then
c       time integral - rocking curve--------------------------------

         nstrob_order=strob_order      ! obtained from subtheory
c                                        called on level 0
c        vector_k=2*pi/wavelength    ! /Angstroem
c        cv_ET=100.*wavelength       ! mm/s*ns
         l_Poincare=0
         nsampling=2**th_sampling

         schrw=v_max/th_channels
         nomega=cv_ET/T_bunch/schrw
         i=nomega/2
         nomega=2*i
         schrw= cv_ET/T_bunch/float(nomega)

         ith_channels=nint(th_channels)
         nTH=ith_channels+nomega*nstrob_order
         ak8=8*nTH
         nTH=nTH*8/nsampling
         
         if(enwr(6)(1:1).eq.'y') then
          write(nwr,'(a,f10.2,2(a,i5))')
     &      ' v_max=',v_max,' nomega=',nomega,
     &    '  and number of channels of the theory=',nTH
         end if
         if(nTH.gt.2*maxn) then
          info=nTH
          infotext(1)='<Synchrotron-time_integral>/synmos//channels'
          infotext(2)=' number of theory channels too large'
          infotext(3)=' '
          return
         end if

         nCP=0
         srw8=schrw/8
         nLG=(2*ith_channels+nomega*nstrob_order)*8

         nTH1=int(ch_angle/4.)*2
         nTH2=int(ch_angle/4.)*2
         nstore=0
         nstorLG=5+(nLG+1)+(nLG+mGa+1)+mGa/2+1    ! Lorentz-Gauss curves
       else if(ifrcase.eq.25.or.ifrcase.eq.31) then
c        time integral - rocking curve_fi ----------------------------
c                                              called on level 0
        if(ifrcase.eq.25)then 
         nstrob_order=strob_order      ! obtained from subtheory
        end if            
        if(ifrcase.eq.31) then
c        time integral - offspecular ---------------------------------

c        for the theory  "time integral - offspecular" the common block
c        common/acstrf/ is rearranged (see subroutine thstr_synoffspec in 
c        thstr_synmos.f) Some constants are different 
c        according to the definition of the common block in thstr_synoffspec:         

c     &              ak_extension,T_bunch,scale,channels,
c     &              ch_angle,graz_beg,graz_end,t0_norm,flag_basis,
c     &              th_channels,th_sampling,
c     &              strob_order,omega,dumcsp(icstrf-19)
c        is replaced by 
c     &              n_TH,T_bunch,scale,channels,                          9
c     &              columns,strob_order,t1_window,t2_window,flag_basis,   14
c     &              nhyperfine,n_angpairs,                                16
c     &              DWBA,omega                                            18
c        We get the numbers for the calculation of reservation of storage 
         nstrob_order=graz_beg
         n_omega=omega
         n_angpairs=th_sampling
         n_theta=dumcsp(3)
        end if

c       vector_k=2*pi/wavelength    ! /Angstroem
c       cv_ET=100.*wavelength       ! mm/s*ns
        l_Poincare=0
c       v_max is the velocity according to the hyperfine energies 
c       for 57Fe H_field=33T ca. 8mm/s
        nhyperfine=th_channels
c       th_channels is the number of channels for v_max. The channel
c       width schrw=v_max/th_channel should not exceed 2*gamma,
c       gamma is the natural line width (0.097mm/s for 57Fe)
        nTH=ak_extension            ! nch_TH
c       storage for the Cmatrices of each site 
        k1=0

        if(nTH.gt.4*maxn) nTH=4*maxn
        j=maxn/(1.+float(nstrob_order)*cv_ET/T_bunch/v_max/2.)
        if(nhyperfine.gt.j)nhyperfine=j

        schrw=v_max/float(nhyperfine)
        nomega=cv_ET/T_bunch/schrw
        i=nomega/2
        nomega=2*i

        j=nstrob_order*nomega+nhyperfine
        if(j.ge.nTH)nTH=j+2

        j=(nTH-nstrob_order*nomega-nhyperfine)*2

        
        i=(sqrt(float(4*j+1))-1.)/2.
c        write(6,'(a,8i5)')'#nvch,nhyperfine=',i,nhyperfine,nTH
        if(i.gt.1) then
         j=nTH-nstrob_order*nomega-nhyperfine-i*(i+1)/2
         do while(j.lt.0.or.i.gt.95)
          i=i-1
          j=nTH-nstrob_order*nomega+nhyperfine-i*(i+1)/2
c          write(6,'(a,6i6)') ' i,j=',i,j,nomega,
c     &            nTH-nstrob_order*nomega-nhyperfine
         end do
         if(i.le.95.and.j.gt.0) then
          nvch=i
          goto 10
         end if 
        end if

 10     schrw=v_max/float(nhyperfine)
        nomega=cv_ET/T_bunch/schrw
        i=nomega/2
        nomega=2*i
        schrw= cv_ET/T_bunch/float(nomega)
        
c       nvch are the number of channels with increasing stepwidth
c       .. .  .   .    .     .      .       .       . (=nvch=10)
        if(nvch.gt.95) nvch=95
        call channels_adjust(nvch,nhyperfine,nstrob_order,nomega,
     &                         iall)
c        write(6,'(a,8i5)')'nvch,nhyperfine,nstrob_order,nomega,iall=',
c     &  nvch,nhyperfine,nstrob_order,nomega,iall

        j=nhyperfine+nvch+nstrob_order*nomega/2
        if(iall.lt.0.or.j.gt.maxn) then
         nhyperfine=nhyperfine-2
         if(nhyperfine.lt.32)then 
          nstrob_order=nstrob_order-1
          nhyperfine=nhyperfine+2
          k1=k1+1
         end if 
         goto 10
        end if

        j=ichall(iall)
        if(j.gt.nTH.or.j.gt.4*maxn)then
         nvch=nvch-2
c         write(6,'(a,5i6)') ' nTH,nvch,iall=',j,nTH,nvch,iall
         k1=k1+1         
         goto 10
        end if

        if(k1.eq.0) then
         k1=k1-1
         goto 10
        end if
        nTH=ichall(iall)
c        nTH=494
c        schrw=0.1402
        ith_channels=nhyperfine
        srw8=schrw
        nsampling=1
c       nhyperfine,nstrob_order,nomega,nvch,nTH determine iall,ichall
c       iall is limited by maxn -> -maxn:maxn are the size of arrays
c       these values are transported by common/struct/ 
c      &             iflag_basis,l_Poincare,nLG,nTH,ith_channels,nsampling,
c      &             ak8,nomega,srw8,nstrob_order,jt0_ch,iT_max,nvch,
c      &             idex(3)

        if(n_angpairs.eq.0) then
        write(nwr,'(a,/,a,i5,2(a,f8.3),/,2(a,i5),/,3(a,i5),a2,i4,/,2a)')
     &   'at least one of the constants have been altered:',
     &   ' nch_hypf    =',nhyperfine,'    v_nTH  =',nTH*schrw,
     &   '     dv =',schrw,
     &   ' nstrob_order=',nstrob_order,'    n_omega=',nomega,
     &   ' ch_TH       =',nTH,'    ch_used=',iall,'  ch_intr. =',
     &    nhyperfine+nvch,' /',nhyperfine+nvch+nstrob_order*nomega/2,
     &   'these values are compatible with each other',
     &   ' and all array sizes'
        end if
        

c      -channel by chanel integration--------------
c      nvch=0 
c      iall=nTH
c      do i=0,iall
c       ichall(i)=i
c      end do
c      -remove c also in th_synoffspecular---------

       if(ifrcase.eq.25) then
         nstore=0
         nstorLG=0         ! case=2 (no sampling)-routine is called
c                          only true if flag_SAMP=0
         nTH1=int(ch_angle/4.)*2
         nTH2=int(ch_angle/4.)*2
       else if(ifrcase.eq.31) then
c      -------------------- remove c also in th_synoffspecular---------
        k1=(nhyperfine+nvch)*2                   ! used in Gamma_mju()
        nstore=0                                 ! storage of trace() for 
        DO nstrob=0,nstrob_order                 ! nstrob_order loop
         nstore=nstore+(k1+nstrob*nomega)/2+1
        end do

c       write(6,'(a,10f10.2)')'dumcsp=',strob_order,(dumcsp(i),i=1,5)

        nstorLG=0          ! case=2 (no sampling)-routine is called
        nTH1=0             ! storage of offspec at l1_get(0)+6
c       calculated in  th_scanmode(), here only to preserve shape of ifrsto
        nTH2=4*(iall+1)*2*maxfr2/2        ! storage of Fourier average
c                                           double 2x2 <= maxfr2/2
       end if
      end if    ! ifrcase

c      nTH+1 is the out of synmos , nchansp/2 for thyy in syn_the2exp
c      both on array_fr, yth is calculated from nTH+1 -> nchansp/2
c      and linear t_scale with tshift=0


       ifrsto=ipLG+nstorLG+nTH1+nTH2+nstore+(nchansp+1)/2+
     &                                       maxsub*(1+maxthss)
c       write(6,'(a,8i8)')
c     & 'fr_synmoss ifrsto,ipLG,nstorLG,nTH1,nTH2,nstore,nchansp=',
c     &             ifrsto,ipLG,nstorLG,nTH1,nTH2,nstore,nchansp

c      the relativ addresses are stored after finishing
c      the entries arr0,i,e
       nstorTH=ipLG+nstorLG
       nstorTH1=nstorTH+nTH1
       nstorTHyy=nstorTH1+nTH2+nstore       ! calculated values (nchansp/2) 
c                                             for each measured point  
       nstorSI=nstorTHyy+(nchansp+1)/2          ! the maxsub*(1+maxthss)*2
c                                             are needed for i_int in routine
c                                             select.f of subspectra

c      the relativ addresses are reloaded before entering fr_theoryxx
c      and changed to absolute addresses which are temporarily stored 
c      the 8 integers following c3_prp(maxthss) are considered to be 
c      relative addresses which during reloading are changed to absolute
c      addresses of the complex array  'array_fr(1:marray_sp). 
       je_a=0
       jg_a=0
c      reset of common/sym3j/  in include file comnuc.for
       return

      else if(cmch.eq.'arri')then
c      ++++++++++++++++++++++++++ arri +++++++++++++++++++++++++++++++++
       ifrsto=0
       call l_structure(jss,lstruct1,lstruct2,lstruct3)
c       ifrsto=100+jss
       if(lstruct3.eq.0) then
        if(lstruct2.eq.0) then
c        lstruct1#0 , incoherent sum over mstruct1 members
         if(mstruct1.gt.1) ifrsto=maxn
        else
         if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then
          ifrsto=8*(nTH+1)
         end if
        end if
       end if

       return
      else if(cmch.eq.'arre')then
c       +++++++++++++++++++++++++++ arre ++++++++++++++++++++++++++++++++

       ifrsto=0
       return
      end if   ! arr0,i,e 
      mscale=scale

c      write(6,'(a,/,8i8)')
c     &'iarray_sp,nstorFR,l1_put(0),nstorTH,nstorTH1,nstorTHyy,nstorSI=',
c     & iarray_sp,nstorFR,l1_put(0),nstorTH,nstorTH1,nstorTHyy,nstorSI

c      write(6,'(a,/,6i8,f12.3)')
c     & 'nTH,nTH1,ak8,nLG,nsampling,mscale,srw8=',
c     &                   nTH,nTH1,ak8,nLG,nsampling,mscale,srw8

c     initializing the array_fr section for nstorint (see subspectra)
c     (intensity of all subsets are 0)

      if(.not.b_theory) then
c      absolute address of nstorSI is known here
       nstorint=maxsub*(1+maxthss)
       do k=1,nstorint
        array_fr(nstorSI+k)=(0.,0.)
       end do
      end if


c     pointer
      
c      write(6,'(a,L5,5i7)')' b_data mscale=',b_data,mscale
      if(cmch.ne.'data'.and.(.not.b_data)) mscale=1
      m1=mstruct1
      m3=istruct2(istruct1(mstruct1))
     
c      storag on real_fr(2*(iarraysp+nstorFR)+m) (array_f) 
c      corresponds to the i= drive_mode (label 100)
      mfpt=2*(iarray_sp+nstorFR)  ! measured (function) data
      if(ifrcase.eq.31) then
       mdfpt=mfpt+nchansp         ! errors of f data (calculated by sqrt) 
       mxpt=mfpt+2*nchansp        ! x data (angle) 
       mypt=mfpt+3*nchansp        ! y data (angle)
       mgpt=mfpt+4*nchansp        ! address for x group of angle 
      else  
       mdfpt=mfpt+nchansp         ! errors of y data (calculated by sqrt 
       mxpt=mfpt+2*nchansp        ! x data (angle) mscale=3
      end if
c      write(6,'(a,5i7)')' mfpt,mxptmscale=',mfpt,mxpt,mscale
c*****************************************************************************
c      write(6,'(i4,a,a)') ifrcase,' frame02 entered with=',cmch
      if(cmch.eq.'data') then
       k1=1
      else if(cmch.eq.'ecic') then
       k1=2
      else if(cmch.eq.'test') then
       k1=3
      else if(cmch.eq.'dfdp') then
       k1=4
      else if(cmch.eq.'subs'.or.cmch.eq.'subt') then
       k1=5
      else if(cmch(1:3).eq.'ple') then
       k1=6
      else if(cmch.eq.'dmod'.or.cmch.eq.'plot') then
       k1=7
      else if(cmch.eq.'punc')then
       k1=8
      end if
      
      goto (110,120,200,300,400,500,600,700),k1
c**********************************************************************
 100  continue
      if(ifrcase.eq.31) then
       data_str='z,dz,x y'
       call data3dread(0,info)
      else
       mscale=scale 
       if(mscale.lt.1.or.mscale.gt.2) mscale=1
       formdata(1)='y,dy'
       formdata(2)='y,dy,x'
       data_str=formdata(mscale)
       call data2dread(0,info)      
      end if
      return
 110  continue
      k1=jss 
      if(ifrcase.eq.31) then
       call data3dread(k1,info)
      else
       call data2dread(k1,info)      
      end if
      return
 120  continue
      if(ifrcase.eq.31) then
       call excinc3d(info)
      else
       call excinc2d(info)      
      end if
      return
c************************************************************************
c     'test': theory function is calculated in subroutine mossbauer

  200 continue
      k1=1
      if(ifrcase.eq.31) then
       call synoffspec_the2exp(k1,info)
      else
       call syn_the2exp(k1,info)
      end if
c     write(6,'(a)') ' after syn_the2exp  test'

      return
c*****************************************************************************
c     derivatives df
  300 continue
      k1=2
      if(ifrcase.eq.31) then
       call synoffspec_the2exp(k1,info)
      else
       call syn_the2exp(k1,info)
      end if
      return

c****************************************************************************
c     subs, subt
  400 continue
      text(1)='       scatterer'
      text(2)=' incoherent part'
      text(3)='                '
      if(info.eq.-1.and.n_subset.ne.0) return
      if(cmch.eq.'subt') goto 450
      print *,' '
      print *,'                 **warning** '
      print *,' subspectra are not additive in the time domain'
      ch1=' '
      if(b_data) then
       ch132=name_data
      else
       ch132=name_theory
      end if
      call chcenter(ch132,ch1,ncloc)
      cp132='plot of subspectra of'
      call chcenter(cp132,ch1,ncloc)
      print *,' '
      write(nwr,'(a,/,a)') cp132(:ncloc),ch132(:ncloc)
      ch132='subspectra /added subspectra of'
      call chcenter(ch132,ch1,ncloc)
      write(nwr,'(/,a)') ch132(:ncloc)
      call syn_selsubset(text)
      return
c*************************************************************
c  call of subtract
 450  continue
      print *,' '
      print *,'          subtraction of subspectra'
      print *,'      has no meaning in the time domain'
      return
c**************************************************************************
c     plot execute
c     different plot programs may be called due to a flag constant 
c     to be introduced as global constant
  500 continue
       icase=int(real(array_fr(l1_get(0)+1)))
       k1=0
       if(b_theory) k1=1
       if(cmch(4:4).eq.'2') k1=2   ! update test
       if(cmch(4:4).eq.'3') k1=3   ! update fit

c              0,1    2d standard plot, 2,3 3d-plot
c              0,2: plot and return;  1,3: interactive plot
       k2=1
       if(ifrcase.eq.31)then
        k2=3
        if(ndisplay_mode.ge.3) k2=1
       end if
       call xmosplo(k1,k2)
       return
c**************************************************************************
c     display mode , filling of plotarray
 600  continue
      if(cmch.eq.'dmod') then
        if(ifrcase.eq.31) then
         call synoffspec_plot(cmch,info)
        else
          call syn_plot(cmch)
        end if
      else  ! cmch='plot'
       if(b_theory)then
        k1=3
        if(ifrcase.eq.31) then
         call synoffspec_the2exp(k1,info)
        else
         call syn_the2exp(k1,info)
        end if
        if(n_subset.gt.0)
     &     call syn_subset(m1,m3,'subs',isub,info)
         if(info.gt.0) return
       end if
c       write(6,'(a,a4,4i6)')' fr_synmoss cmch,ifrcase,scale=',
c     &                                cmch,ifrcase,int(scale)
        if(ifrcase.eq.31) then
         call synoffspec_plot(cmch,info)
        else
          call syn_plot(cmch)
        end if
      end if
      return
c**************************************************************************
c     punch data and theory
 700  continue
      k1=jss 
      if(ifrcase.eq.31) then
       call punch3d(k1,info)
      else
       call punch2d(k1,info)
      end if
      return

      end



      subroutine syn_the2exp(n1,info)
c *****************************************************************
c     n1 = 0 error return
c     n1 = 1 call of theory
c     n1 = 2 derivatives
c     n1 = 3 call of theory , calpl is not called
c *****************************************************************
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'comthe.for'
      include 'comdas.for'
      include 'complt.for'

      integer     info,ifrth,idex,istr,dstr,iaddr,
     &            nstorTH,idum1,nstorTHyy,nTH1
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/dstr(istr),nstorTH,idum1,nstorTHyy,iaddr(5),        !13.9.05 
     &              nTH1,ifrth(7),idex(16)

      real          acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,dumcsp
      common/acstrf/acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,dumcsp(icstrf-13)

      real          avsp,counts,background,Pxsi,Peta,Pzeta,
     &              t_shift,dumvsp
      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
     &              t_shift,dumvsp(ivstrf-7)

      logical       b_vs,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_t_shift,b_graz_min,b_dumvsp
      common/bvstrf/b_vs,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_t_shift,b_graz_min,b_dumvsp(ivstrf-8)

      logical b_total,b_residual

      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit
      real      yth
      dimension yth(-maxn:2*maxn)


      real    x_exp,countsy,dx_the,dx_exp,xb_the,xb_exp,
     &        y1,y2,yi,ff,hi
      integer nexp,nthe,iT_max,iT_max2,invers,jshift,
     &        ji,i,k,k1,n1,nn,j,mscale

      common/ascale/  x_exp(maxn)



c      write(6,'(a,5i6)')'syngl n1,ifrcase,scale=',
c     &                         n1,ifrcase,mscale
      ibmisfit=0
      mscale=1                    ! if no data 
      if(b_data)mscale=scale

      countsy=counts-background*channels
c      integral 0-inf is normalized to 1
c      write(6,'(a,4f10.2)') ' frame02 counts,background,channels=',
c     &    counts,background,channels
      nexp=channels
      nthe=nTH1*2

      if(ifrcase.ge.22) then
       countsy=countsy/channels*nTH1       
      else
       iT_max=aiT_max
       iT_max2=2**iT_max  
c      write(6,'(a,i6,f15.5)') 'iT_max2=',2**iT_max
      end if

      if(ifrcase.ge.22) then
       dx_the=abs(graz_end-graz_beg)/(ch_angle-1.0)
       dx_exp=abs(graz_end-graz_beg)/(channels-1.0)
       xb_the=graz_beg+t_shift
       xb_exp=graz_beg
       invers=0
       if(dx_the.lt.0) then
        invers=nexp+1
        dx_the=-dx_the
       end if
      else
       dx_the=abs(T_bunch)/nthe
       dx_exp=abs(T_bunch)/channels
       xb_the=t_shift
       xb_exp=0.0
       invers=0
       if(T_bunch.lt.0) invers=nexp+1
       xb_the=t_shift
      end if
c     warning** xb_exp is not correct if x-data are read from file
c     it is correct after calling x_scale()
      jshift=abs(xb_the/dx_the)+1

c     write(6,'(8f10.5)') (yth(i)*100.,i=-2,nthe,16)
c     write(6,'(8f12.2)') (yth(i)*countsy,i=1,nTH1)
c     write(6,'(4(a,f10.5),a,i4)') ' ***synchrotron*** backgr=',
c    &         background,' aiT_max=',aiT_max,' dx_the=',dx_the,
c    &         '  t_shift=',t_shift,'  nexp=',nexp


      if(ifrcase.ge.22) then
       call synrocking(b_total,info)
      else
       call synchrotron(b_total,info)
      end if

c      write(6,'(a,6L5)')',b_total,b_background,b_counts,b_t_shift =',
c     &             b_total, b_background,b_counts,b_t_shift


      k1=n1
      goto (100,200,300),k1

 100  continue
c     calculation of thfk
      nn=nstorTH*2
      do j =1,nthe
       yth(j)=real_fr(nn+j)
      end do

c      write(6,'(a,/,2i5,2f10.3,i5,2f10.3)')
c     & 'frame mscale,nexp,dx_exp,xb_exp,nthe,dx_the,xb_the=',
c     &        mscale,nexp,dx_exp,xb_exp,nthe,dx_the,xb_the 
c      write(6,'(6g12.2)') (yth(k),k=1,2*nTH1,8)
c      write(6,'(8f10.5)') (yth(k)*100.,k=1,100)

      call x_scale(mscale,nexp,dx_exp,xb_exp)
c      write(6,'(6f12.4)') (x_exp(i),i=1,nexp,16)

      ji=abs(invers-1)
      hi=(x_exp(ji)-xb_the)/dx_the
      i=int(hi)
c      write(6,'(a,4i6,f10.3)')'ji,i,nthe,jshift,hi=',ji,i,nthe,jshift,hi

      if(ifrcase.ge.22) then
       do k=0,jshift+1
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do
      else
       do k=0,jshift+1
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do
      end if
c      write(6,'(6g12.2)') (yth(k),k=1,2*nTH1+4)


      do j=1,nexp
       ji=abs(invers-j)
       hi=(x_exp(ji)-xb_the)/dx_the
       i=int(hi)
       if(i.le.0)i=i-1
       hi=hi-float(i)
c       y2=yth(i-2)+yth(i+2)
c       y1=yth(i-1)+yth(i+1)
c       aa=(2.0*y2-y1-yth(i))/14.0
c       bb=(-2.0*(yth(i-2)-yth(i+2))-yth(i-1)+yth(i+1))/10.0
c       cc=(-3.0*y2+12.0*y1+17*yth(i))/35.0
c       yi=cc+hi*(aa*hi+bb)
       y1=yth(i)
       y2=yth(i+1)
       yi=y1+hi*(y2-y1)
       thfk(j)=yi*countsy+background
      end do
      nn=nstorTHyy*2
      do j=1,nexp
       real_fr(nn+j)=thfk(j)
      end do
c      write(6,'(6g12.2)') (thfk(i),i=1,nexp,8)
      b_theory=.true.

      return

 200  continue
      ib_df=0
c     derivatives
c     ib_df=1: derivative calculated
c     ib_df=0 happens if a parameter of a set, wich is not currently 
c     fitted, is free. It will be fixed in the routine fit. 

c     analytical and numerical derivatives are handled fdifferently
c     integer kana (k analytical) = 1 indicates an analytical derivative

c     (the fact that a parameter x can mix up variables type 
c      complicates the situation. An analytical derivative of a variale 
c      can only be calculated, if it is not connected to a different 
c      parameter by the transformation matrix)  

c     variable background, counts are analytically derived 
c     the total number of variables of the set is contained in b_total
c     (for all variables of synchrotron, synrock) and the glabal 
c     variables of this routine: counts,background,t_shift
c     t_shift is numerically derived (enters x_scale by xb_the)

c      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
c     &          t_shift,graz_angle,graz_min,phi_z,dumvsp(idumvsp)

      b_total=b_total.or.b_t_shift

      b_residual=.not.(b_total.or.b_counts)
c     all variables unchanged but background

      if(b_background.and.b_residual) then
c       write(6,'(a)')  '   derivative of background ------------'
        do j=1,nexp
         dfdp(j)=1.0
        end do
        kana=1
        ib_df=1
        goto 250
      end if
c     for background derivative the last theory values were not neccessary
      nn=nstorTHyy*2
      do j=1,nexp
       thfk(j)=real_fr(nn+j)
      end do
c     write(6,'(8f10.5)') (thfk(i),i=1,nexp,18)

      b_residual=.not.(b_total.or.b_background)
c     all variables but counts
      if(b_counts.and.b_residual) then
c       write(6,'(a)')  '   derivative of counts ------------'
        do j=1,nexp
         dfdp(j)=(thfk(j)-background)/countsy
        end do
        kana=1
        ib_df=1
        goto 250
      end if


c     numerical derivatives
      b_residual=.not.(b_total.or.b_background.or.b_counts.or.
     &                b_graz_min)
c     (b_residual=.true.: parameter is connected only to variables 
c     of other sets 
c      write(6,'(a,l5,g15.3)')'fr_synmoss b_resid.,ddpk=',b_residual,ddpk
      if(b_residual) goto 250  

      kana=0
      nn=nstorTH*2
      do j =1,nthe
       yth(j)=real_fr(nn+j)
      end do
      if(ifrcase.ge.22) then
       do k=0,jshift
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do
      else
       do k=0,jshift+1
        yth(-k)=yth(nthe-k)
       end do
      end if

      call x_scale(mscale,nexp,dx_exp,xb_exp)

      do j=1,nexp
       ji=abs(invers-j)
       hi=(x_exp(ji)-xb_the)/dx_the
       i=int(hi)
       if(i.le.0)i=i-1
       hi=hi-float(i)
       y1=yth(i)
       y2=yth(i+1)
       ff=y1+hi*(y2-y1)
       dfdp(j)=(ff*countsy+background-thfk(j))/ddpk
      end do   ! j=1,nexp
      ib_df=1

 250  continue
      return

 300  continue
c     calculation of thfk

      if(.not.b_theory) goto 310
      if(ifrcase.ge.22) then
       call synrocking(b_total,info)
      else
       call synchrotron(b_total,info)
      end if
      nn=nstorTH*2       
      do j =1,nthe
       yth(j)=real_fr(nn+j)
      end do
c      write(6,'(6g12.2)') (yth(k),k=1,2*nTH1,8)

      if(ifrcase.ge.22) then
       do k=0,jshift
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do
      else
       do k=0,jshift+1
        yth(-k)=yth(nthe-k)
       end do
      end if
      call x_scale(mscale,nexp,dx_exp,xb_exp)
      
      if(ndisplay_mode.gt.1) then
       do j=1,nexp
        ji=abs(invers-j)
        hi=(x_exp(ji)-xb_the)/dx_the
        i=int(hi)
        if(i.le.0)i=i-1
        hi=hi-float(i)
        y1=yth(i)
        y2=yth(i+1)
        yi=y1+hi*(y2-y1)
        thfk(j)=yi*countsy+background
       end do
      else
       do j=1,nthe
        thfk(j)=yth(j)*countsy+background
       end do
      end if
 310  return
      end


      subroutine synoffspec_the2exp(n1,info)
c     author : h. spiering
c              Am Damsberg 86
c              D-55130 Mainz
c              2006-2007
c *****************************************************************
c     n1 = 0 error return
c     n1 = 1 call of theory
c     n1 = 2 derivatives
c     n1 = 3 call of theory , calpl is not called
c *****************************************************************
      implicit none
      include 'comglb.for'
      include 'comdat.for'
      include 'comthe.for'
      include 'complt.for'


      integer     info,ifrth,idex,istr,dstr,iaddr,
     &            nstorTH,idum1,nstorTHyy,nTH1
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/dstr(istr),nstorTH,idum1,nstorTHyy,iaddr(5),        !13.9.05 
     &              nTH1,ifrth(7),idex(16)

      real          acsp,wavelength,uthick_A,
     &              unitchi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,columns,
     &              strob_order,t1_window,t2_window,flag_basis,  
     &              th_channels,DWBA,angpairs,dumcsp
      common/acstrf/acsp,wavelength,uthick_A,
     &              unitchi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,columns,
     &              strob_order,t1_window,t2_window,flag_basis,  
     &              th_channels,angpairs,DWBA,dumcsp(icstrf-18)

      real          avsp,counts,background,Pxsi,Peta,Pzeta,
     &              ang_shift,dumvsp
      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,ang_shift,
     &              dumvsp(ivstrf-7)

      logical       b_vs,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_dumvsp
      common/bvstrf/b_vs,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_dumvsp(ivstrf-6)

      logical b_total,b_residual,b_trot

      integer   ib_df,kana,ibmisfit,iaset
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit

      real      yth,ab_the
      dimension ab_the(128),iaset(128)
      integer   idscrd,iscrd,jth
      parameter (iscrd=maxscrd-128*128-9*maxn-1)
      common/scrd/jth(-3:124,-3:124),yth(-maxn:max8),idscrd(iscrd)


      real    countsy,y1,y2,y3,y4,y5,y6,ff,aa,bb,cc,dd,ee,
     &        h,hx,hy,dx_the,dy_the,xb_the,yb_the,Dx_exp,Dy_exp
      integer nexp,nthe,k,k1,n1,j,ig,jx,jy,j1,j2,j3,j4,j5,j6,i_3d


c      write(6,'(a,5i6)')'syngl n1,ifrcase,scale=',
c     &                         n1,ifrcase

      countsy=counts-background*channels
c      integral 0-inf is normalized to 1
c      write(6,'(a,4f10.2)') ' frame02 counts,background,channels=',
c     &    counts,background,channels

      
      call synoffspec(b_total,info)
      call ot_theo(i_3d,ab_the,iaset,xb_the,dx_the,yb_the,dy_the)
      b_theory=.true.
      if(.not.b_data) return

      nexp=channels
      nthe=nTH1
      ibmisfit=0

c      write(6,'(a,2i6,3f10.3)')'fr_synmos nstorTH,nTH1=',
c     &                                    nstorTH,nTH1
c      write(6,'(a,6L5)')',b_total,b_background,b_counts,b_t_shift =',
c     &             b_total, b_background,b_counts,b_t_shift

      k1=n1
      goto (100,200,300),k1

 100  continue
c     calculation of thfk
      do j =1,nthe
       yth(j)=real_fr(2*nstorTH+j)*countsy+background
      end do
      yth(0)=0.
      yth(-1)=0.
c        write(6,'(a,i5)')' ichanks=',ichanks(0)
c        write(6,'(10i5)')(ichanks(j),j=1,ichanks(0))
c        write(6,'(8f12.3)') (yth(j),j=1,nthe)

       if(i_3d.eq.0) then
c       2d interpolation of the theory at experimental points
        do k=2,ichanks(0),2
c        n-theta group
         do j=ichanks(k-1),ichanks(k)
          ig=real_fr(mgpt+j)
c         to each theta group ig  belong n-omega theoreticalangles 
          hx=(real_fr(mxpt+j)-ab_the(ig))/dx_the
          jx=int(hx)
          hx=hx-float(jx)
          jx=jx+iaset(ig)
          y1=yth(jx)
          y2=yth(jx+1)
          y3=yth(jx+2)
          aa= (y1+y3-2.*y2)/2.
          bb= (y3-y1)/2.
          thfk(j)=(aa*hx+bb)*hx+y2
          if(thfk(j).lt.0.) thfk(j)=0.
c          write(6,'(4i3,8f12.2)')j,ig,iaset(ig),io,
c     &               real_fr(mxpt+j),ab_the(ig),y1,y2,y3,thfk(j)
         end do
        end do
       else
c       3d interpolation of the theory at experimental points
        b_trot=.false.
        if(i_3d.eq.1)b_trot=.true.

        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)  
           Dx_exp=real_fr(mxpt+j)-xb_the
           Dy_exp=real_fr(mypt+j)-yb_the
           if(b_trot) then
            h=Dx_exp
            Dx_exp=(Dx_exp-Dy_exp)/2.            
            Dy_exp=(h+Dy_exp)/2.
           end if       
           hx=Dx_exp/dx_the
           jx=int(hx)                         ! theta() of theory 
           hx=hx-float(jx)
           hy=Dy_exp/dy_the
           jy=int(hy)                         ! omega() of theory 
           hy=hy-float(jy)

           if(jth(jx,jy+2).gt.0)then
            if(jth(jx+2,jy).gt.0)then
c            standard case
             j1=jth(jx,jy)
             j2=jth(jx+1,jy)
             j3=jth(jx+2,jy)
             j4=jth(jx,jy+1)
             j5=jth(jx+1,jy+1)
             j6=jth(jx,jy+2)
            else   ! jth(jx+2,jy)=0
c            x_max boundary
             j1=jth(jx+1,jy)
             j2=jth(jx,jy)
             j3=jth(jx-1,jy)
             j4=jth(jx+1,jy+1)
             j5=jth(jx,jy+1)
             j6=jth(jx+1,jy+2)
             hx=1.-hx
            end if
           else    !jth(jx,jy+2)=0
            if(jth(jx+2,jy).gt.0)then
c            y_max boundary
             j1=jth(jx,jy+1)
             j2=jth(jx+1,jy+1)
             j3=jth(jx+2,jy+1)
             j4=jth(jx,jy)
             j5=jth(jx+1,jy)
             j6=jth(jx,jy-1)
             hy=1.-hy
            else   ! jth(jx+2,jy)=0
c            x-max,y_max corner
             j1=jth(jx+1,jy+1)
             j2=jth(jx,jy+1)
             j3=jth(jx-1,jy+1)
             j4=jth(jx+1,jy)
             j5=jth(jx,jy)
             j6=jth(jx+1,jy-1)
             hx=1.-hx
             hy=1.-hy
            end if           
           end if

c           write(6,'(6i3,2(2x,i3,2f10.3),2f10.3)')j1,j2,j3,j4,j5,j6,
c     &         jx,hx,real_fr(mxpt+j),jy,hy,real_fr(mypt+j),Dx_exp,Dy_exp
           ff=yth(j1)
           y2=yth(j2)-ff
           y3=yth(j3)-ff
           y4=yth(j4)-ff
           y5=yth(j5)-ff
           y6=yth(j6)-ff
           
           aa=-(2.*y2-y3)
           bb=-(y3-4.*y2)
           cc=-(2.*y4-y6)
           dd=-(y6-4.*y4)
           ee=(y5-y4-y2)*2.

           thfk(j)=((aa*hx+bb)*hx+(cc*hy+dd+ee*hx)*hy)/2.+ff
         end do
        end do
       end if

      do j=1,nexp
       real_fr(2*nstorTHyy+j)=thfk(j)
      end do
c      write(6,'(2f12.2)') (real_fr(mfpt+j),thfk(j),j=1,nexp)

      return

 200  continue
      ib_df=0
c     derivatives
c     ib_df=1: derivative calculated
c     ib_df=0 happens if a parameter of a set, wich is not currently 
c     fitted, is free. It will be fixed in the routine fit. 

c     analytical and numerical derivatives are handled fdifferently
c     integer kana (k analytical) = 1 indicates an analytical derivative

c     (the fact that a parameter x can mix up variables type 
c      complicates the situation. An analytical derivative of a variale 
c      can only be calculated, if it is not connected to a different 
c      parameter by the transformation matrix)  

c     variable background, counts are analytically derived 
c     the total number of variables of the set is contained in b_total
c     (for all variables of synchrotron, synrock) and the glabal 
c     variables of this routine: counts,background,t_shift
c     t_shift is numerically derived (enters x_scale by xb_the)

c      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
c     &          t_shift,graz_angle,graz_min,phi_z,dumvsp(idumvsp)
       
      b_total=b_total
      b_residual=.not.(b_total.or.b_counts)
c     all variables unchanged but background

      if(b_background.and.b_residual) then
c       write(6,'(a)')  '   derivative of background ------------'
        do j=1,nexp
         dfdp(j)=1.0
        end do
        kana=1
        ib_df=1
        goto 250
      end if
c     for background derivative the last theory values were not neccessary
 
      do j=1,nexp
       thfk(j)=real_fr(2*nstorTHyy+j)
      end do
c     write(6,'(8f10.5)') (thfk(i),i=1,nexp,18)

      b_residual=.not.(b_total.or.b_background)
c     all variables but counts
      if(b_counts.and.b_residual) then
c       write(6,'(a)')  '   derivative of counts ------------'
        do j=1,nexp
         dfdp(j)=(thfk(j)-background)/countsy
        end do
        kana=1
        ib_df=1
        goto 250
      end if


c     numerical derivatives
      b_residual=.not.(b_total.or.b_background.or.b_counts)
c     (b_residual=.true.: parameter is connected only to variables 
c     of other sets 
      if(b_residual) goto 250  

      kana=0
      do j =1,nthe
       yth(j)=real_fr(2*nstorTH+j)*countsy+background
      end do
      yth(-1)=0.
c      write(6,'(8g12.3)') (real_fr(2*nstorTH+j),j=1,nthe)

       if(ndisplay_mode.gt.0) then
c       2d interpolation of the theory at experimental points
        do k=2,ichanks(0),2
c        n-theta sets
         do j=ichanks(k-1),ichanks(k)
          ig=real_fr(mgpt+j)
c         to each theta group ig  belong n-omega theoreticalangles 
          hx=(real_fr(mxpt+j)-ab_the(ig))/dx_the
          jx=int(hx)
          hx=hx-float(jx)
          jx=jx+iaset(ig)
          y1=yth(jx)
          y2=yth(jx+1)
          y3=yth(jx+2)
          aa= (y1+y3-2.*y2)/2.
          bb= (y3-y1)/2.
          ff=(aa*hx+bb)*hx+y2
          if(ff.lt.0.) ff=0.
          dfdp(j)=(ff-thfk(j))/ddpk
c          write(6,'(8f12.3)') ff,thfk(j)
         end do
        end do
c        write(6,'(8g12.3)') (dfdp(j),j=1,nthe)
       else 
c       3d interpolation of the theory at experimental points
        b_trot=.false.
        if(i_3d.eq.1)b_trot=.true.

        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)  
           Dx_exp=real_fr(mxpt+j)-xb_the
           Dy_exp=real_fr(mypt+j)-yb_the
           if(b_trot) then
            h=Dx_exp
            Dx_exp=(Dx_exp-Dy_exp)/2.            
            Dy_exp=(h+Dy_exp)/2.
           end if       
           hx=Dx_exp/dx_the
           jx=int(hx)                         ! theta() of theory 
           hx=hx-float(jx)
           hy=Dy_exp/dy_the
           jy=int(hy)                         ! omega() of theory 
           hy=hy-float(jy)

           if(jth(jx,jy+2).gt.0)then
            if(jth(jx+2,jy).gt.0)then
c            standard case
             j1=jth(jx,jy)
             j2=jth(jx+1,jy)
             j3=jth(jx+2,jy)
             j4=jth(jx,jy+1)
             j5=jth(jx+1,jy+1)
             j6=jth(jx,jy+2)
            else   ! jth(jx+2,jy)=0
c            x_max boundary
             j1=jth(jx+1,jy)
             j2=jth(jx,jy)
             j3=jth(jx-1,jy)
             j4=jth(jx+1,jy+1)
             j5=jth(jx,jy+1)
             j6=jth(jx+1,jy+2)
             hx=1.-hx
            end if
           else    !jth(jx,jy+2)=0
            if(jth(jx+2,jy).gt.0)then
c            y_max boundary
             j1=jth(jx,jy+1)
             j2=jth(jx+1,jy+1)
             j3=jth(jx+2,jy+1)
             j4=jth(jx,jy)
             j5=jth(jx+1,jy)
             j6=jth(jx,jy-1)
             hy=1.-hy
            else   ! jth(jx+2,jy)=0
c            x-max,y_max corner
             j1=jth(jx+1,jy+1)
             j2=jth(jx,jy+1)
             j3=jth(jx-1,jy+1)
             j4=jth(jx+1,jy)
             j5=jth(jx,jy)
             j6=jth(jx+1,jy-1)
             hx=1.-hx
             hy=1.-hy
            end if           
           end if

c           write(6,'(6i3,2(2x,i3,2f10.3),2f10.3)')j1,j2,j3,j4,j5,j6,
c     &         jx,hx,real_fr(mxpt+j),jy,hy,real_fr(mypt+j),Dx_exp,Dy_exp
           ff=yth(j1)
           y2=yth(j2)-ff
           y3=yth(j3)-ff
           y4=yth(j4)-ff
           y5=yth(j5)-ff
           y6=yth(j6)-ff
           
           aa=-(2.*y2-y3)
           bb=-(y3-4.*y2)
           cc=-(2.*y4-y6)
           dd=-(y6-4.*y4)
           ee=(y5-y4-y2)*2.
           ff=((aa*hx+bb)*hx+(cc*hy+dd+ee*hx)*hy)/2.+ff
           dfdp(j)=(ff-thfk(j))/ddpk
         end do
        end do
       end if

      ib_df=1

 250  continue
      return

 300  continue
c     calculation of thfk

      if(.not.b_theory.or..not.b_data) goto 310

      call synoffspec(b_total,info)
c     calculation of thfk
      do j =1,nthe
       yth(j)=real_fr(2*nstorTH+j)*countsy+background
      end do
      yth(0)=0.
      yth(-1)=0.

      if(i_3d.eq.0) then
c      2d interpolation of the theory at experimental points
       do k=2,ichanks(0),2
c       n-theta group
        do j=ichanks(k-1),ichanks(k)
         ig=real_fr(mgpt+j)
c        to each theta group ig  belong n-omega theoreticalangles 
         hx=(real_fr(mxpt+j)-ab_the(ig))/dx_the
         jx=int(hx)
         hx=hx-float(jx)
         jx=jx+iaset(ig)
         y1=yth(jx)
         y2=yth(jx+1)
         y3=yth(jx+2)
         aa= (y1+y3-2.*y2)/2.
         bb= (y3-y1)/2.
         thfk(j)=(aa*hx+bb)*hx+y2
         if(thfk(j).lt.0.) thfk(j)=0.
c         write(6,'(4i3,8f12.2)')j,ig,iaset(ig),io,
c    &               real_fr(mxpt+j),ab_the(ig),y1,y2,y3,thfk(j)
        end do
       end do
      end if
c     3d: the full theory is plotted (independent of the data)
 310  return
      end


      subroutine syn_subset(m1,m3,cmch,isub,info)
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'complt.for'
      include 'comdat.for'
      include 'comdas.for'
      include 'comthe.for'

      integer    m1,m3,isub,info,
     &           ifrth,idex,istr,dstr,iaddr,nTH1
      character frthname*64
      parameter (istr=6+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/dstr(istr),frthname(2),
     &              iaddr(8),nTH1,ifrth(7),idex(16)          !13.9.05

      integer   idumscrt
      parameter(idumscrt=maxscrt-maxn*maxsub-5*maxn)
      real        datx,errx,sym,subspectrum,daty,erry,dumscrt
      common/scrt/datx(maxn),errx(maxn),sym(maxn),
     &            subspectrum(maxn,maxsub),
     &            daty(maxn),erry(maxn),dumscrt(idumscrt)

      real           dum,channels,dumcsp
      common/acstrf/dum(9),channels,dumcsp(icstrf-10)

      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit

      character cmch*4
      real      plold,plold1,plold3,p0
      dimension plold(maxthss),plold1(maxthss),plold3(maxthss)

      integer  i,ip,ia,ie,j,jj,k,k1,l,ll,llm,lj,n1,nexp,nthe
 
c      write(6,'(a,a)') '*********subroutine syn_subset********',cmch


       nexp=channels
       nthe=nTH1*2

      if(cmch.eq.'subs') then
       call calpl('test')

       do  i=1,m1
        plold1(i)=0.
       end do
       do  i=1,m3
        plold3(i)=0.0
       end do

       do  i=1,m1
        j=-(2*maxthss+i)
        call replace_wi(j,plold1(i),info)  ! - take out and write on plold(i)
       end do
       do  i=1,m3
        call replace_wi(-i,plold3(i),info)  ! - take out and write on plold(i)
       end do
c       write(6,'(a,10f8.2)')'frame02 plold1()=',(plold1(i),i=1,m1)
c       write(6,'(a,10f8.2)')'frame02 plold3()=',(plold3(i),i=1,m3)

       do  l=1,n_subset
        p0=0.0
        do  i=1,m1
         j=2*maxthss+i
         call replace_wi(j,p0,info)  ! + write 0 to wi values
        end do

        llm=n_int(l,0)
        ll=0
        do while(ll.lt.llm.and.n_int(l,ll).gt.0)
         ll=ll+1
        end do

c        write(6,'(a,2i4)')' frame02 ll,llm=',ll,llm
        if(ll.eq.llm.and.n_int(l,llm).gt.0) then
         do  i=1,m3
          call replace_wi(i,p0,info)  ! + write 0 to wi values
         end do
        end if
c      write(6,'(a,i4,a,5i4)')' l_subsp=',l,
c     &         ' n_int(l,ll)=',(n_int(l,ll),ll=1,4)
        ll=1
        do while(ll.le.llm.and.n_int(l,ll).gt.0 )
         ip=n_int(l,ll)
         if(ip.gt.maxthss) then
          i=ip-2*maxthss
c          write(6,'(a,2i4,f10.3)')'frame02 ip,plold1(i)=',ip,i,plold1(i)
          call replace_wi(ip,plold1(i),info)  ! + write plold(ip) to wi values
         else
c          write(6,'(a,2i4,f10.3)')'frame02 ip,plold3(i)=',ip,i,plold3(i)
          call replace_wi(ip,plold3(ip),info)  ! + write plold(ip) to wi values
         end if
         if(ll.eq.llm) goto 10 
         ll=ll+1
        end do
 10     continue
c       ll le llm is now guaranteed      8.2.06

        if(ll.lt.llm) then
         do lj=ll,llm,2
          ia=-n_int(l,lj)
          ie=-n_int(l,lj+1)
          do ip=ia,ie
c          write(6,'(a,i4,f10.3)')'frame02 ip,plold3(ip)=',ip,plold3(ip)
           call replace_wi(ip,plold3(ip),info)
          end do
         end do
        end if

        k1=3
        call syn_the2exp(k1,info)

        j=nexp
        if(ndisplay_mode.eq.1)j=nthe
         do  i=1,j
          subspectrum(i,l)=thfk(i)
         end do
c        end if
       end do

       do  i=1,m1
        j=2*maxthss+i
        call replace_wi(j,plold1(i),info)  ! + write plold(jj) to wi values
       end do
       do  i=1,m3
        call replace_wi(i,plold3(i),info)  ! + write plold(jj) to wi values
       end do
      end if  !  cmch=subs,test



      if(cmch.eq.'subt') then
c     write(6,'(a,i4)') ' ********** m1=',m1

       call calpl('test')
        do  i=1,m1
        call replace_wi(-i,plold(i),info)  ! - take out and write on plold(i)
       end do
c      write(6,'(a,i2,a2,f15.5)') ' plold(',i,')=',plold(i)

c      subtract y - yy

c      absorber complete , source and detector window subtracted


       nexp=channels
       do k=1,nexp
        daty(k)=real_fr(mfpt+k)
       end do

       p0=0.0
       do j=1,isub
        do i=1,m1
         call replace_wi(i,p0,info)  ! + write 0 to wi values
        end do

        do i=1,n_sub(j,0)
         jj=abs(n_sub(j,i))
         call replace_wi(jj,plold(jj),info)  ! + write plold(jj) to wi values
        end do

        k1=3
        call syn_the2exp(n1,info)

c      write(6,'(a)') ' ------1----back in subtract----------------'

        do i=1,nexp
         daty(i)=daty(i)-thfk(i)
        end do
       end do  ! isub

c      calculation of the theory of the stripped spectrum
       p0=0.0
       do i=1,m1
        call replace_wi(i,p0,info)  ! + write 0.0 to wi values
       end do

       do i=1,n_sub(0,0)
        jj=n_sub(0,i)
        call replace_wi(jj,plold(jj),info)  ! + write plold(jj) to wi values
       end do

       k1=3
         ! values are not reset by calpl, written on theory-array
       call syn_the2exp(k1,info)

c      write(6,'(a)') ' ------2----back in subtract----------------'
c      restore parameters
       call calpl('test')
      end if    ! cmch='subt'

      k1=3
      call syn_the2exp(k1,info)

      return
      end


 


      SUBROUTINE INDEXi(N,IRRIN,INDX)
      DIMENSION IRRIN(N),INDX(N)
      DO 11 J=1,N
        INDX(J)=J
11    CONTINUE
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          INDXT=INDX(L)
          Q=IRRIN(INDXT)
        ELSE
          INDXT=INDX(IR)
          Q=IRRIN(INDXT)
          INDX(IR)=INDX(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            INDX(1)=INDXT
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(IRRIN(INDX(J)).LT.IRRIN(INDX(J+1)))J=J+1
          ENDIF
          IF(Q.LT.IRRIN(INDX(J)))THEN
            INDX(I)=INDX(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        INDX(I)=INDXT
      GO TO 10
      END




      subroutine channels_adjust(nvch,nhyperfine,nstrob_order,nomega,
     &                           iall)
c       the routine calculates channels needed for a nonequidistant
c       channel numbers for all later shifts +- nomega in the stoboscopic 
c       integration
c       iall is limited by maxn -> -maxn:maxn are the size of arrays
        include 'comglb.for'
        integer nvch,nhyperfine,nstrob_order,nomega,iall,ichall,
     &          inp,IRRIN,INDX,idumscrd
        parameter(nn=16*maxn)
        dimension ichh(0:nn),inp(-nn:nn),IRRIN(nn),
     &            INDX(nn)
        common/scrd/ichall(0:maxn*2),idumscrd(maxscrd-1-maxn*2)
        equivalence (idumscrd(1),ichh(0)),(idumscrd(nn+2),inp(-nn)),
     &     (idumscrd(3*nn+3),IRRIN(1)),(idumscrd(4*nn+3),INDX(1))
       iall=0  
       DO n=0,nstrob_order  
c       +-m =2m eqidistant steps,
        kom=n*nomega/2
         mcht=kom+nhyperfine
         do i=0,mcht
          inp(i)=i
         end do
         do i=0,mcht
          inp(mcht+i)=i+kom
         end do
         j=2*mcht
         do i=kom,mcht
          inp(j+i)=i-kom
         end do 
         j=3*mcht-kom+1
         do i=1,nvch
          inp(j+i)=mcht+i*(i+1)/2+kom
         end do
         j=3*mcht-kom+1+nvch
         do i=1,nvch
          inp(j+i)=mcht+i*(i+1)/2-kom
         end do

         j=3*mcht-kom+1+nvch*2
         if(iall+j.gt.nn) then
          iall=-iall-j
c          write(6,'(a,i6)')' nn zu klein iall+j=',-iall
          return
         end if
         do i=0,j
          IRRIN(i+1+iall)=inp(i)
         end do 
         iall=iall+j+1
c         write(6,'(a,i7)')' before iall=',iall
         call INDEXi(iall,IRRIN,INDX)
         do k=1,iall
          ichh(k)=IRRIN(INDX(k))
         end do
c         print '(a )', 'before             elimination'
c         print '(20i5)',(ichh(i),i=1,iall)
c         print '(20i5)',(ichh(i),i=1,iall/2)
c         print '(20i5)',(ichh(i),i=iall/2+1,iall)
c         print '(20i5)',n,kj,m,nomega,nvch
c         read(5,'(a)')

         k=0
c        elimination of multiple indices
  400    k=k+1
         if(ichh(k).eq.ichh(k+1))then
          iall=iall-1
          do kk=k+1,iall
           ichh(kk)=ichh(kk+1)
          end do
          k=k-1
          ichh(iall+1)=0
         end if
         if(k.lt.iall-1) goto 400
         do i=1,iall
          IRRIN(i)=ichh(i)
         end do
c        print '(a )', 'after elimination'
c        print '(20i5)',(ichh(i),i=1,iall)
c        read(5,'(a)')
c        end do  ! +-nomega
c        write(6,'(a,i7)')' after  iall=',iall

       END DO  !for all nStrobo
c       print '(" order  ")'
c       print '(" iall,nvch,nhyperfine= ",5i6)',iall,nvch,nhyperfine
       ichall(0)=0
       if(iall.le.2*maxn)then
        do k=1,iall
         ichall(k)=ichh(k)
        end do
       else
        iall=-iall
       end if
       
       return
       end


      subroutine ot_theo(i_3d,ab_the,iaset,xb_the,dx_the,yb_the,dy_the)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
     
      real        ab_the,xb_the,dx_the,yb_the,dy_the
      dimension   ab_the(128)
      integer     i_3d,icase,iaset,istruct1,istruct2,l1_get,
     &            mstruct1,nstorTH,nTH1,iaddr,idex,istr,idum
      dimension   iaset(128)
c                  istruct=2+4*maxfr1+4+4*maxfr2+3*maxthss+32+8+8+16,
      parameter   (istr=3*maxfr2+3*maxthss+2*(maxfr1+1)+32)
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     
     &              l1_get(0:maxfr1),idum(istr),
     &              nstorTH,iaddr(7),nTH1,idex(23)
      integer     k_omega,n_omega,i_theta,n_theta,i_angle,j,ig
      real        omega,omega_beg,domega,omega_end,grazinc,grazout,
     &            theta,theta_beg,dtheta,theta_end
      integer   idscrd,iscrd,jth
      parameter (iscrd=maxscrd-128*128)
      common/scrd/jth(-3:124,-3:124),idscrd(iscrd)

c      n_theta,theta_beg,dtheta,n_omega,omega_beg,domega
       icase=int(real(array_fr(l1_get(0)+1)))
       n_omega=int(real(array_fr(l1_get(0)+2)))
       n_theta=int(aimag(array_fr(l1_get(0)+2)))
       omega_beg=real(array_fr(l1_get(0)+3))
       domega=aimag(array_fr(l1_get(0)+3))
       theta_beg=real(array_fr(l1_get(0)+4))
       dtheta=aimag(array_fr(l1_get(0)+4))
       omega_end=real(array_fr(l1_get(0)+5))
       theta_end=aimag(array_fr(l1_get(0)+5))

       nstorTH=l1_get(0)+6             ! see th_scanmode()
       nTH1=real(array_fr(l1_get(0)+6))
c       write(6,'(a,3f10.1)')'fr_synmos array_fr=',array_fr(l1_get(0)+6)
c       write(6,'(a,i4,4x,3f10.4)')
c     &  'n_theta,theta_beg,dtheta,theta_end=',
c     &   n_theta,theta_beg,dtheta,theta_end
c       write(6,'(a,i4,4x,3f10.4)')
c     &   'n_omega,omega_beg,domega,omega_end=',
c     &   n_omega,omega_beg,domega,omega_end
       do i_theta=-3,n_theta+3
       do k_omega=-3,n_omega+3   
        jth(i_theta,k_omega)=0
       end do
       end do
      i_3d=0
      if(icase.eq.3) i_3d=1
      if(icase.eq.4) i_3d=-1 

      iaset(1)=0
      i_angle=0
      do i_theta=1,n_theta
       theta=theta_beg+dtheta*(i_theta-1)
       ig=0
       do k_omega=1,n_omega        
        omega=omega_beg+domega*(k_omega-1)

       if(icase.eq.1.or.icase.eq.4) then
          grazinc=omega
          grazout=theta
        else if(icase.eq.2.or.icase.eq.3) then
           grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta
           grazout=2*omega_beg+domega*(n_omega-1)+
     &       (i_theta-1)*dtheta*2-grazinc
        else if(icase.eq.5) then
c        PHI_s=omega N_s=n_omega
         j=i_theta/2
         if(2*j.eq.i_theta) then
c         + dTheta_out
          grazinc=omega
          grazout=(omega+dtheta*j)
         else
c         + dTheta_out
          grazinc=(omega+dtheta*j)
          grazout=omega
         end if
         if(omega+dtheta*j.gt.omega_end)goto 77
        end if
        i_angle=i_angle+1   
        jth(k_omega-1,i_theta-1)=i_angle
 
        ig=ig+1
        if(ig.eq.1)then
         ab_the(i_theta)=grazinc
        end if

 77     continue
       end do     ! n_omega
 777   iaset(i_theta+1)=i_angle
       end do     ! n_theta
       xb_the=omega_beg
       dx_the=domega
       yb_the=theta_beg
       dy_the=dtheta
c       write(6,'(a,4f12.2)')'xb_the,dx_the,yb_the,dy_the=',
c     &      xb_the,dx_the,yb_the,dy_the
       return
       end
