      subroutine frstr_mossbauer(l_nfrtheo,lstruct1,lstruct2,
     &                                           cmch,property)
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character*132 ch132,property,cmch*4,chth*8,ch16*16
      logical lfrthi2i6

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:','fr'//property(1:6),
     & ' l_nfrtheo=',l_nfrtheo,
     & ' subr= frstr_mossbauer  nameth_as=',nameth_as(:40)
      
      if(cmch.eq.'name') then
       l_nfrtheo=1         
c#########################################################################
       property  ='Mossbauer spectrum'                                      !name
       ntheory(1)='Mossbauer radioactive source'
c#########################################################################
       return
      end if

c     property defines the name of the helpfile: Mossbauer_spectrum.help

c     the different cases of theories are selected by the subroutine
c     thstr_frmossbauer:
c     l_nfrtheo=1 :'Mossbauer transmission_vA'
c     l_nfrtheo=2 :'Mossbauer transmission_vB'
c     l_nfrtheo=3 :'Mossbauer reemission_vA
c     l_nfrtheo=4 :'Mossbauer reemission_vB'
c     l_nfrtheo=5 :'Mossbauer transmission_vC'
c     l_nfrtheo=6 :'Mossbauer transmission_vD'
cc    l_nfrtheo=7 :'Mossbauer resonance reflection'
 
c     sequence change in thstr_mossbauer in order to have transmission
c     theories together
      i1=1    !  nameth(1)
      i2=2    !  nameth(2)
      i3=5    !  nameth(5)
      i4=6    !  nameth(6)
      i5=3    !  nameth(3)
      i6=4    !  nameth(4)
      lfrthi2i6=l_nfrtheo.eq.i2.or.l_nfrtheo.eq.i6

c     the frame routine fr_mossbauer has the theoryname (ntheory(1))
c     and the same list of cases (sequence arbitrary). The numbers 
c     in brackets (without any blanks!) at the end are again arbitrary
c     (different for each case). These numbers are accessible as ifrcase
c     in routines fr_mossbauer and th_mossbauer by the 'common/thpt/'
c     in comthe.for:

c       theoryname='Mossbauer radioactive source'
c       thfrcase(1)='Mossbauer transmission_vA(1)'         
c       thfrcase(2)='Mossbauer transmission_vB(3)'
c       thfrcase(3)='Mossbauer reemission_vA(2)'           
c       thfrcase(4)='Mossbauer reemission_vB(4)'           
c       thfrcase(5)='Mossbauer transmission_vC(5)'           
c       thfrcase(6)='Mossbauer transmission_vD(3)'  

cc      thfrcase(7)='Mossbauer resonance reflection(6)' 

c      The numbers l_nfrtheo are used for selection of constants and 
c      variables (defined by parameters and transformation matices)
c      for the common blocks from which the theories (1,...,5) take
c      the values.
c      lstruct1=0                common/acstrf/    /avstrf/  
c                                applies to all devices
c      lstruct1=1  lstruct2=0    common/acfr1trf/    /avfr1trf/      
c                  lstruct2=1    common/acfr2trf/    /avfr2trf/
c                                device: source 
c      lstruct1=2  lstruct2=0    common/acfr1trf/    /avfr1trf/      
c                  lstruct2=1    common/acfr2trf/    /avfr2trf/
c                                device: absorber/scatterer 
c      lstruct1=2  lstruct2=0    common/acfr1trf/    /avfr1trf/      
c                  lstruct2=1    common/acfr2trf/    /avfr2trf/
c                                device: detector 
c-------------------------------------------------------
c     only for common/acstrf/    /avstrf/
c     ##   from data file, ask [n]
c     ## y from data file, ask [y]
c     ##n  from data file, no ask

c     for common/acfritrf/  
c          include constant, no ask
c     #    include constant ask [n]
c     # y  include constant ask [y]
c     #n   not include constant no ask
c--------------------------------------------------------

      chth='fr'//property(1:6)
      nstruct=' '
 
      goto(100,200,300,400)lstruct1+1
c------------------------------------------------------------------------
 100  continue
      
      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & ' list=1 seq=2  chth='//chth  
       return
      end if
      
      if(l_nfrtheo.eq.i1.or.lfrthi2i6) then
      strcmt(0)=' 9  10'
      strcmt(1)=
     &'  source, absorber, detector are considered as layers, '
      strcmt(2)='  the absorber may consist of several layers and '
      strcmt(3)=
     &'  each layer n contains 0-N inequivalent lattice sites:'
      strcmt(4)=
     &'       layer 1        ___________________  source    '
      strcmt(5)='     _                                              '
      strcmt(6)=
     &'    \\  layer 2       ___________________  absorber   '
      strcmt(7)=
     &' n_period                    ...                      '
      strcmt(8)=
     &'    /_ layer n-1      ___________________  absorber   '
      strcmt(9)=
     &'       layer n        ___________________  detector window '
      
      strcmt(10)='source_absorber_detector   sp          , ##  2 '
      strcmt(11)=' '
      strcmt(12)=
     & 'v=0 between source and detector window with resonant nuclei'
      strcmt(13)='theory/'//chth//'/layer/detector'
      
      else if(l_nfrtheo.eq.i3.or.l_nfrtheo.eq.i4) then
      strcmt(0)=' 4 5'
      strcmt(1)=
     &'  source and scatterer(CEMS)  are considered as layers, '
      strcmt(2)=
     &'  each layer n contains 0-N inequivalent lattice sites:'
      strcmt(3)= 
     &'       layer 1        __________________  source    '
      strcmt(4)=
     &'       layer 2        __________________  scatterer'
      
      strcmt(5)='source_scatterer       sp          , ##n  2 '
      strcmt(6)=' '
      strcmt(7)='detector window containes no resonant nuclei '
      strcmt(8)='theory/'//chth//'/layer/CEMS'

      else if(l_nfrtheo.eq.i5) then
      strcmt(0)=' 8  9'
      strcmt(1)=
     &'  source, mosaic absorber , detector are considered as layers, '
      strcmt(2)='  the absorber may consist of several mosaic parts and'
      strcmt(3)=
     &'  each layer/part n contains 0-N inequivalent lattice sites:'
      strcmt(4)=
     &'       layer 1        ___________________  source    '
      strcmt(5)='     _                                              '
      strcmt(6)=
     &'       layer 2       part1,...,partm____  absorber   '
      strcmt(7)='                                       m=lyer2 - n-1'
      strcmt(8)=
     &'       layer n        ___________________  detector window '
      
      strcmt(9)='source_absorber_detector   sp          , ##  2 '
      strcmt(10)=' '
      strcmt(11)=
     & 'v=0 between source and detector window with resonant nuclei'
      strcmt(13)='theory/'//chth//'/layer/detector'
            
      else if(l_nfrtheo.eq.i6) then
      strcmt(0)=' 10  11'
      strcmt(1)=
     &'  source and scatterer are considered as layers, '
      strcmt(2)='  the scatterer may consist of several layers and '
      strcmt(3)=
     &'  each layer n contains 0-N inequivalent lattice sites:'
      strcmt(4)=
     &'       layer 1        __________________  source    '
      strcmt(5)=
     &'       layer 2        __________________  scatterer (cover)'
      strcmt(6)='     _                                              '
      strcmt(7)=
     &'    \\  layer 3       __________________  scatterer'
      strcmt(8)=
     &' repetition                    ...                      '
      strcmt(9)=
     &'    /_ layer n-1      __________________  scatterer  '
      strcmt(10)=
     &'       layer n        __________________  scatterer (substrate)'
      
      strcmt(11)='source_scatterer       sp          , ##n  2 '
      strcmt(12)=' '
      strcmt(13)='detector window containes no resonant nuclei '
      strcmt(13)='theory/'//chth//'/layer/scatterer'
      end if
      return
c-----------------------------------------------------------------------
c     device:Mossbauer source
 200  continue
c     device  common/acfr1trf/    /avfr1trf/ 

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      if(lstruct2.gt.0) goto 210

      strcmt(1)='source_layer       sc              #n  1 '
      strcmt(2)=' '
      strcmt(3)='number of layers of the source '
      strcmt(4)='theory/'//chth//'/layer/source'
      strcmt(5)='distribution of parameters at sites of the layer'
      
      return
c     --------------------------------------------------
 210  continue
c     layers of device  common/acfr2trf/    /avfr2trf/ 
      k=1
      do while(strco(k)(:5).ne.'#beg#')
       k=k+1
      end do
      jc=k-1
      jcb=jc+1

      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1

c     Temperature of the source at position 5 of  common/acfr2trf/
c     (all theories l_nfrtheo)
      strco(jc+1)='T_source              5   # n     300.0 '
                ! temperatue of the layer 
      jc=jc+1

      if(l_nfrtheo.eq.i1.or.l_nfrtheo.eq.i3) then 

c      l_nfrtheo=1 :'Mossbauer transmission_vA'
c                   call of subroutine th_hdeq,th_lines126,th_hdeqmiscellaneous,
c                   th_relaxglobalsad,th_relaxtwostatesad
c      common/acfr2trf/acfr2

       strco(jc+1)='iset_powder                2 # n  0 '
                ! iset=1-6 for 4-128 points on 1/48 of the sphere
       strco(jc+2)='isymmetry                  3 # n  10 '
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)
       jc=jc+2

c      common/avfr2trf/ avfr2,dum(5),Hext,thetaHe,phiHe,phi,theta,psi
       strtm(jm+1,1)='Hextern_sc                ,# n 3 3'
       strtm(jm+1,2)='external magnetic field (lab) at the source'
       strth(jh+1,1)='Hext             , 0.0  0.0 0.0  1.0'
       strth(jh+2,1)='thetaHe          , 0.0 0.0 0.0   1.0'
       strth(jh+3,1)='phiHe            , 0.0 0.0 0.0   1.0 '
       strth(jh+1,2)='Hext                     6    1 0 0  '
       strth(jh+2,2)='thetaHe                  7    0 1 0 '
       strth(jh+3,2)='phiHe                    8    0 0 1'
       jh=jh+3
       strtm(jm+2,1)='euler_source              ,# n 3 3'
       strtm(jm+2,2)='orientation of the source (lab)'
       strth(jh+1,1)='phi              , 0.0  0.0 0.0  1.0'
       strth(jh+2,1)='theta            , 0.0 0.0 0.0   1.0'
       strth(jh+3,1)='psi              , 0.0 0.0 0.0   1.0 '
       strth(jh+1,2)='phi                       9    1 0 0  '
       strth(jh+2,2)='theta                    10    0 1 0 '
       strth(jh+3,2)='psi                      11    0 0 1'
       jh=jh+3      
       jm=jm+2
              
      else if(lfrthi2i6.or.l_nfrtheo.eq.i4.or.l_nfrtheo.eq.i5)then 
c      l_nfrtheo=2 :'Mossbauer transmission_vB'
c                   call of subroutine th_hdeqf
c      common/acfr2trf/acfr2,rep_grp,aset,asymmetry,a_psi,temperature
c      common/avfr2trf/avfr2,th_factor,dum(4),Hext,thetaHe,phiHe,
c                      phi,theta,psi     


       strco(jc+1)='iset_powder                2 #  0 '
                ! iset=1-6 for 4-128 points on 1/48 of the sphere
       strco(jc+2)='isymmetry                  3 #  10 '
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)
       strco(jc+3)='n_psi_powder               4 #  0 '
                ! 3rd Euler angle, rotation around S_lab(z)
                ! neccessary if Hext not parallel S_lab(z)
       jc=jc+3

       strtm(jm+1,1)='thickn_factor            ,# n 1 1'
       strtm(jm+1,2)='thickness factor for all sites of the layer'
       strth(jh+1,1)='th_factor           , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='th_factor               1    1  '
       jm=jm+1
       jh=jh+1

       strtm(jm+1,1)='x2_anisotropy            ,# 2 2'
       strtm(jm+1,2)='mean square <x2> of a crystal (source)'
       strth(jh+1,1)='d_x2                  ,  0.0  0.0 0.0  0.1'
       strth(jh+2,1)='x2_eta                ,  0.0  0.0 0.0  0.1'
       strth(jh+1,2)='d_x2                     12    1 0  '
       strth(jh+2,2)='x2_eta                   13    0 1  '
 
       strtm(jm+2,1)='x2_orientation           ,# 3 3'
       strtm(jm+2,2)='x2_orientation with ref. to a crystal (source)'
       strth(jh+3,1)='x2_phi                , 0.0  0.0 0.0  1.0'
       strth(jh+4,1)='x2_theta              , 0.0  0.0 0.0  1.0'
       strth(jh+5,1)='x2_psi                , 0.0  0.0 0.0  1.0'
       strth(jh+3,2)='x2_phi                   14    1 0 0 '
       strth(jh+4,2)='x2_theta                 15    0 1 0 '
       strth(jh+5,2)='x2_psi                   16    0 0 1 '
       jm=jm+2
       jh=jh+5
 
       strtm(jm+1,1)='ax_texture               ,# n 2 2'
       strtm(jm+1,2)='texture of the source layer '
       strth(jh+1,1)='t200                   , 0.0  0.0 0.0  0.1'
       strth(jh+2,1)='t400                   , 0.0  0.0 0.0  0.1'
       strth(jh+1,2)='t200                     17    1 0'
       strth(jh+2,2)='t400                     18    0 1 '
       jm=jm+1
       jh=jh+2

       strtm(jm+1,1)='Hextern_sc               ,# 3 3'
       strtm(jm+1,2)='external magnetic field (lab) at the source'
       strth(jh+1,1)='Hext             , 0.0  0.0 0.0   1.0'
       strth(jh+2,1)='thetaHe          , 0.0  0.0 0.0   1.0'
       strth(jh+3,1)='phiHe            , 0.0  0.0 0.0   1.0 '
       strth(jh+1,2)='Hext                     6    1 0 0  '
       strth(jh+2,2)='thetaHe                  7    0 1 0 '
       strth(jh+3,2)='phiHe                    8    0 0 1'
       jh=jh+3      
       jm=jm+1       

      end if

      do k=jcb,jc
       ch16=strco(k)
       ch132=strco(k)(17:)
       call stringlength(ch132,l)
       strco(k)=ch16//'         '//ch132(:l)//'/'//chth
      end do
      strco(jc+1)='#end#  5 seq'
      strco(jc+2)='#beg#'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do
      strtm(jm+1,1)='#end#  18 '
      strtm(jm+2,1)='#beg#'   



      strcmt(1)='source   s               #  1 1 '
      strcmt(2)=' '
      strcmt(3)='number of inequivalent sites of the source '
      strcmt(4)='theory/'//chth//'/sites/source'
      strcmt(5)='distribution of parameters of site number'
      
      return
c--------------------------------------------------------------------
c     device:Mossbauer absorber/scatterer
 300  continue

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if
      if(lstruct2.gt.0) goto 310

      if(l_nfrtheo.le.i1.or.lfrthi2i6)then
       strcmt(1)='absorber_layer  ab  l  l1=po ln=an      #  1  1'
       strcmt(2)='name of the absorber layer '
       strcmt(3)='number of layers of the absorber '
       strcmt(4)='theory/'//chth//'/absorber/layer'
       strcmt(5)='distribution of parameters at sites of the layer'
      else if(l_nfrtheo.eq.i3.or.l_nfrtheo.eq.i4)then
       strcmt(1)='scatterer_layer  sr  l l1=co li=sw ln=su # 1 1'
       strcmt(2)='name of the scatterer layer '
       strcmt(3)='number of layers of the scatterer '
       strcmt(4)='theory/'//chth//'/scatterer/layer'
       strcmt(5)='distribution of parameters at sites of the layer'
      else if(l_nfrtheo.eq.i5)then
       strcmt(1)='absorber_layer  mo  l  l1=p1 ln=pn      #  1  1'
       strcmt(2)='name of the mosaic absorber layer '
       strcmt(3)='number of parts of the absorber '
       strcmt(4)='theory/'//chth//'/mosaicabsorber/layer'
       strcmt(5)='distribution of parameters at sites of the part'
      else if(l_nfrtheo.eq.i6)then
       strcmt(1)='scatterer_layer  sr  l l1=co li=sw ln=su #  3 3'
       strcmt(2)='l1=cover li=sandwich ln=substrate '
       strcmt(3)='number of layers of the scatterer '
       strcmt(4)='theory/'//chth//'/scatterer/layer'
       strcmt(5)='distribution of parameters at sites of the layer'
      end if
      return
c     --------------------------------------------
 310  continue
c     layers of device  common/acfr2trf/    /avfr2trf/ 
      
      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1 
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
c                1        0         012345
      k=1
      do while(strco(k)(:5).ne.'#beg#')
       k=k+1
c       write(6,'(i2,2x,a)')k,strco(k)(:60)
      end do
      jc=k-1
      jcb=jc+1
      

      strco(jc+1)='temperature              5  # n    300.0 '
                ! temperatue of the layer 
      jc=jc+1

      if(l_nfrtheo.eq.i1.or.l_nfrtheo.eq.i3) then 

       strco(jc+1)='iset_powder                2 # n  0 '
                ! iset=1-6 for 4-128 points on 1/48 of the sphere
       strco(jc+2)='isymmetry                  3 # n  10 '
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)
       jc=jc+2

c      l_nfrtheo=1,3 :'Mossbauer transmission_vA, reemission_vA'
c                   call of subroutine th_hdeq    
c      common/acfr2trf/acfr2
c      common/avfr2trf/ avfr2,dum(5),Hext,thetaHe,phiHe,phi,theta,psi
       strtm(jm+1,1)='thickn_factor             # n 1 1'
       strtm(jm+1,2)='thickness factor for all sites of the layer'
       strth(jh+1,1)='th_factor           , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='th_factor               1    1  '
       jm=jm+1
       jh=jh+1

       strtm(jm+1,1)='Hextern                  ,# n 3 3'
       strtm(jm+1,2)='external magnetic field (lab) at the absorber'
       strth(jh+1,1)='Hext             , 0.0  0.0 0.0  1.0'
       strth(jh+2,1)='thetaHe          , 0.0 0.0 0.0   1.0'
       strth(jh+3,1)='phiHe            , 0.0 0.0 0.0   1.0 '
       strth(jh+1,2)='Hext                     6    1 0 0  '
       strth(jh+2,2)='thetaHe                  7    0 1 0 '
       strth(jh+3,2)='phiHe                    8    0 0 1'
       jh=jh+3
       strtm(jm+2,1)='euler                      ,# n 3 3'
       strtm(jm+2,2)='orientation of the absorber/scatterer (lab)'
       strth(jh+1,1)='phi              , 0.0  0.0 0.0  1.0'
       strth(jh+2,1)='theta            , 0.0 0.0 0.0   1.0'
       strth(jh+3,1)='psi              , 0.0 0.0 0.0   1.0 '
       strth(jh+1,2)='phi                       9    1 0 0  '
       strth(jh+2,2)='theta                    10    0 1 0 '
       strth(jh+3,2)='psi                      11    0 0 1'
       jh=jh+3       
       jm=jm+2

       if(l_nfrtheo.eq.i1) then
        strcmt(1)='absorber_layer   s       #  1  0'
        strcmt(2)=' '
        strcmt(3)='number of inequivalent sites of the absorber layer'
        strcmt(4)='theory/'//chth//'/absorber/layer/sites'
        strcmt(5)='distribution of parameters of site number'
       else if(l_nfrtheo.eq.i3) then
        strcmt(1)='scatterer        s       #  1  0'
        strcmt(2)='li=(1 0)  '
        strcmt(3)='Number of inequivalent sites of the scatterer'
        strcmt(4)='theory/'//chth//'/scatterer/sites'
        strcmt(5)='distribution of parameters of site number'
       end if
      else if(lfrthi2i6.or.l_nfrtheo.eq.i4.or.l_nfrtheo.eq.i5)then 
c      l_nfrtheo=2,4,5 :'Mossbauer transmission_vB, reemission_vB
c                                  transmission_vC
c                   call of subroutine th_hdeqf
c      common/acfr2trf/acfr2,rep_grp,aset,asymmetry,a_psi,temperature
c      common/avfr2trf/avfr2,th_factor,dum(4),Hext,thetaHe,phiHe,
c                      phi,theta,psi     


       strco(jc+1)='iset_powder                2 #  0 '
                ! iset=1-6 for 4-128 points on 1/48 of the sphere
       strco(jc+2)='isymmetry                  3 #  10 '
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)
       strco(jc+3)='n_psi_powder               4 #  0 '
                ! 3rd Euler angle, rotation around S_lab(z)
                ! neccessary if Hext not parallel S_lab(z)
       jc=jc+3

       strtm(jm+1,1)='thickn_factor           ,# n 1 1'
       strtm(jm+1,2)='thickness factor for all sites of the layer'
       strth(jh+1,1)='th_factor             , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='th_factor               1    1  '
       jm=jm+1
       jh=jh+1

       strtm(jm+1,1)='x2_anisotropy            ,# 2 2'
       strtm(jm+1,2)=
     & 'mean square <x2> of a crystal of the scatterer layer'
       if(lfrthi2i6)strtm(jm+1,2)=
     &  'mean square <x2> of a crystal of the absorber layer'
       if(l_nfrtheo.eq.i5)strtm(jm+1,2)=
     &  'mean square <x2> of a crystal of the the absorber part'       
       strth(jh+1,1)='d_x2                  ,  0.0  0.0 0.0  0.1'
       strth(jh+2,1)='x2_eta                ,  0.0  0.0 0.0  0.1'
       strth(jh+1,2)='d_x2                     12    1 0  '
       strth(jh+2,2)='x2_eta                   13    0 1  '
 
       strtm(jm+2,1)='x2_orientation           ,# 3 3'
       strtm(jm+2,2)=
     & 'x2_orientation with ref. to a crystal (scatterer layer)'
       if(lfrthi2i6)strtm(jm+2,2)=
     & 'x2_orientation with ref. to a crystal (absorber layer)'
       if(l_nfrtheo.eq.i5)strtm(jm+2,2)=
     & 'x2_orientation with ref. to a crystal (absorber part)'
       strth(jh+3,1)='x2_phi                , 0.0  0.0 0.0  1.0'
       strth(jh+4,1)='x2_theta              , 0.0  0.0 0.0  1.0'
       strth(jh+5,1)='x2_psi                , 0.0  0.0 0.0  1.0'
       strth(jh+3,2)='x2_phi                   14    1 0 0 '
       strth(jh+4,2)='x2_theta                 15    0 1 0 '
       strth(jh+5,2)='x2_psi                   16    0 0 1 '
       jm=jm+2
       jh=jh+5
 
       strtm(jm+1,1)='ax_texture               ,#  n 2 2'
       strtm(jm+1,2)='texture of the scatterer layer '
       if(lfrthi2i6)strtm(jm+1,2)='texture of the absorber layer'
       if(l_nfrtheo.eq.i5)strtm(jm+1,2)='texture of the absorber part '
       strth(jh+1,1)='t200                   , 0.0  0.0 0.0  0.1'
       strth(jh+2,1)='t400                   , 0.0  0.0 0.0  0.1'
       strth(jh+1,2)='t200                     17    1 0'
       strth(jh+2,2)='t400                     18    0 1 '
       jm=jm+1
       jh=jh+2

       strtm(jm+1,1)='Hextern                  ,# 3 3'
       strtm(jm+1,2)='external magnetic field (lab) at the scatterer'
       if(lfrthi2i6.or.l_nfrtheo.eq.i5)strtm(jm+1,2)=
     &           'external magnetic field (lab) at the absorber'
       strth(jh+1,1)='Hext             , 0.0  0.0 0.0   1.0'
       strth(jh+2,1)='thetaHe          , 0.0  0.0 0.0   1.0'
       strth(jh+3,1)='phiHe            , 0.0  0.0 0.0   1.0 '
       strth(jh+1,2)='Hext                     6    1 0 0  '
       strth(jh+2,2)='thetaHe                  7    0 1 0 '
       strth(jh+3,2)='phiHe                    8    0 0 1'
       jh=jh+3      
       jm=jm+1 
      
       
       if(lfrthi2i6) then
        strcmt(1)='absorber_layer   s       #  1  0'
        strcmt(2)=' '
        strcmt(3)='number of inequivalent sites of the absorber layer'
        strcmt(4)='theory/'//chth//'/absorber/layer/sites'
        strcmt(5)='distribution of parameters of site number'
       else if(l_nfrtheo.eq.i4) then
        strcmt(1)='scatterer        s       #  1  0'
        strcmt(2)='li=(1 0)  '
        strcmt(3)='Number of inequivalent sites of the scatterer'
        strcmt(4)='theory/'//chth//'/scatterer/sites'
        strcmt(5)='distribution of parameters of site number'
       else if(l_nfrtheo.eq.i5) then
        strcmt(1)='mosaic_absorber_part   s       #  1  0'
        strcmt(2)=' '
        strcmt(3)='number of inequivalent sites of the absorber part'
        strcmt(4)='theory/'//chth//'/absorber/part/sites'
        strcmt(5)='distribution of parameters of site number'
       end if
      else if(l_nfrtheo.eq.i6) then
       strco(jc+1)='rep.grp                  1  # 1.1 '
                ! layer belongs to a group which repeat with period
       jc=jc+1
      
       strtm(jm+1,1)='Hextern                  ,# n 3 3'
       strtm(jm+1,2)='external magnetic field (lab) at the scatterer'
       strth(jh+1,1)='Hext             , 0.0  0.0 0.0  1.0'
       strth(jh+2,1)='thetaHe          , 0.0 0.0 0.0   1.0'
       strth(jh+3,1)='phiHe            , 0.0 0.0 0.0   1.0 '
       strth(jh+1,2)='Hext                     6    1 0 0  '
       strth(jh+2,2)='thetaHe                  7    0 1 0 '
       strth(jh+3,2)='phiHe                    8    0 0 1'
       jh=jh+3

       strtm(jm+2,1)='rotation                  ,# n 3 3'
       strtm(jm+2,2)='rotation of the scatterer surface'
       strth(jh+1,1)='phi              , 0.0  0.0 0.0  1.0'
       strth(jh+1,2)='phi                      9    1 0 0  '
       jh=jh+1
       strtm(jm+1,1)='thickn_lay              , 1 1'
       strtm(jm+1,2)='thickness of the layer'
       strth(jh+1,1)='thicklay        , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='thicklay                1    1  '
c                  1        0         012345
      
       strtm(jm+2,1) ='r_chi_electronic          , 1 1'
       strtm(jm+2,2) ='real part of chi_electronic of the layer  '
       strth(jh+2,1)='r_chilay        , 0.0  0.0 0.0  0.1'
       strth(jh+2,2)='r_chilay                2    1 '

       strtm(jm+3,1) ='i_chi_electronic          , 1 1'
       strtm(jm+3,2) ='imaginary part of chi_electronic of the layer'
       strth(jh+3,1)='i_chilay        , 0.0  0.0 0.0  0.1'
       strth(jh+3,2)='i_chilay                3    1'
      
       strtm(jm+4,1)='roughness                ,# 1 1'
       strtm(jm+4,2)='roughness of the layer  '
       strth(jh+4,1)='roughness        , 0.0  0.0 0.0  0.1'
       strth(jh+4,2)='roughness               4    1 '
       jm=jm+4
      
       strcmt(1)='scatterer_layer   s       #  1  0'
       strcmt(2)='li=(1 0)  '
       strcmt(3)='Number of inequivalent sites of the scatterer layer'
       strcmt(4)='theory/'//chth//'/scatterer/layer/sites'
       strcmt(5)='distribution of parameters of site number'
      end if
     
      do k=jcb,jc
       ch16=strco(k)
       ch132=strco(k)(17:)
       call stringlength(ch132,l)
       strco(k)=ch16//'         '//ch132(:l)//'/'//chth
      end do
      strco(jc+1)='#end#  5 seq'
      strco(jc+2)='#beg#'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do
      strtm(jm+1,1)='#end# 18'
      strtm(jm+2,1)='#beg#'

      return
c--------------------------------------------------------------------
c      common/avfr1trf/pvfr1,Hext,thetaHe,phiHe
c      detector

 400  continue
      
      if(cmch.eq.'hdbk') return
      if(lstruct2.gt.0) goto 410
      
      
      strcmt(1)='layer_detector  dt             #n  1   1'
      strcmt(2)=' '
      strcmt(3)='number of layers of the detector '
      strcmt(4)='theory/'//chth//'/layer/detector'
      
      return
 410  continue
      
      if(cmch.eq.'hdbk') return

      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
      
      strtm(jm+1,1)='Hextern_dt                 ,# 3 3'
      strtm(jm+1,2)='external magnetic field (lab) at the detector'
      strth(jh+1,1)='Hext             , 0.0  0.0 0.0  1.0'
      strth(jh+2,1)='thetaHe          , 0.0 0.0 0.0   1.0'
      strth(jh+3,1)='phiHe            , 0.0 0.0 0.0   1.0 '
      strth(jh+1,2)='Hext                    6     1 0 0 '
      strth(jh+2,2)='thetaHe                 7     0 1 0 '
      strth(jh+3,2)='phiHe                   8     0 0 1 '
      jm=jm+1
      strtm(jm+1,1)='#end#  8 '
      strtm(jm+2,1)='#beg#'
      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

      strcmt(1)='detector    s            #  1 1'
      strcmt(2)=' '
      strcmt(3)='number of inequivalent sites of the detector'
      strcmt(4)='theory/'//chth//'/sites/detector'
      strcmt(5)='distribution of parameters of site number'
      
      return
      end
      
      
