       subroutine g_field(mlay,b_Cm,b_domain,MAXGRP,GEOSTR,
     &                                            SQ,K1,Kmatrix,
     &                   roughlay,VKD,Rmatrix,lay_domain,Tmatrix)
C*********************************************************************************************************************
C      Subroutine calculates Fourier transformation of the field (experssion
C      2.12 in the article). Result is stored in Tmatrix.
C     Size of the Tmatrix is 2*2*i, where i - Number of the layer with domains (pay attention) 
C
CC*********************************************************************************************************************
 
 
      implicit none
C     input:
      integer    mlay,MAXGRP,GEOSTR,lay_domain
      real*8     SQ,K1,roughlay,VKD
      complex*8  Tmatrix
      complex*16 Rmatrix,Kmatrix
      logical    b_Cm,b_domain
      dimension  b_Cm(mlay),b_domain(mlay),GEOSTR(0:2*MAXGRP),
     &           Kmatrix(2,2,mlay),roughlay(mlay),
     &           VKD(mlay),Rmatrix(2,2),Tmatrix(2,2,lay_domain)
     &           

C   other variables:
      integer    I,J,L,n_rep,GRP,LMIN,LMAX,POINTER,I_D,NLOG
      real*4     absCmatr
      complex*16 C0,C1,CI,M(4,4),ML(4,4),MS(4,4),KL(2,2),
     &           A(2,2),B(2,2),T(2,2)
      logical    b_odz,b_grp
C********* Variables added by Khaidukov for neutron case*******
      integer    Lprev,Lnext,n
      logical    prev_dgnl,both_dgnl,both_NONdgnl
      complex*16 KLprev(2,2)
      real*8     DabsMatr,z1,z2,DL
C**************************************************************
      parameter  (C0=(0.D0,0.D0), C1=(1.D0,0.D0), CI=(0.D0,1.D0))


C     To set the characteristic matrix to unit matrix
      do I=1,4
       do J=1,4
        M(I,J) =C0
       end do
       M(I,I) =C1
      end do

      I_D=0
      POINTER=0                                     
      z1=0.0D0  ! First 
      z2=0.0D0  ! and the second coordinate for each layer


      do GRP=1,MAXGRP      ! loop for the groups
       do I=1,4
        do J=1,4
         MS(I,J)=C0
        end do
        MS(I,I)=C1
       end do

       b_grp=.false.
       LMIN =POINTER+1
       LMAX =POINTER+GEOSTR(2*GRP)
       n_rep=GEOSTR(2*GRP-1)
C-------------------------------------------------------------------
       DO n=1,n_rep

        do I=1,4
         do J=1,4
          ML(I,J)=C0
         end do
         ML(I,I)=C1
        end do

        do L=LMIN,LMAX 
	 if(VKD(L).gt.0)then

	  b_odz=.not.b_Cm(L)
	  b_grp=.true.  			 

          DL=VKD(L)
          if(DL.lt.0.d0)DL=1.0d30
	  z2=z1+DL

          KL(1,1)=Kmatrix(1,1,L)
          KL(1,2)=Kmatrix(1,2,L)
          KL(2,1)=Kmatrix(2,1,L)
          KL(2,2)=Kmatrix(2,2,L)
          absCmatr=dreal(KL(1,2)*conjg(KL(1,2))+
     &                    KL(2,1)*conjg(KL(2,1)))

          if(absCmatr.lt.1.e-15) then
           b_odz=.true.
          end if

          IF (b_domain(L)) THEN !If there are b_domains in this layer 
c                                store inform
           call transb(SQ,KL,Rmatrix,M,A,B)  ! 
           call analytic_fourier(z1,z2,SQ,K1,KL,A,B,T)
           I_D=I_D+1
           Tmatrix(1,1,I_D)=T(1,1)
	   Tmatrix(1,2,I_D)=T(1,2)
	   Tmatrix(2,1,I_D)=T(2,1)
	   Tmatrix(2,2,I_D)=T(2,2)
          END IF     ! b_domain

          call genM(b_odz,SQ,DL,KL,M)  !

C---------------------- Roughness--------------------------------------------
	  IF (roughlay(L).GT.0.1) THEN
           if (n_rep.GT.1.and.L.eq.Lmin) then  ! In case of repeating layers
	    Lprev=Lmax	                       ! we are more interested in the 
	   else                                ! information about roughnesses
                              		       ! in repeated ones. 
	    Lprev=L-1			       ! #Khaidukov
	   END IF

           if(n_rep.GT.1.and.L.eq.LMAX) then  !
            Lnext=LMIN         ! For peiodical structure the rougness
           else                ! is also periodical! The next layer to 
            Lnext=L+1          ! the last element is the first layer! 
            if(Lnext.gt.mlay) Lnext=mlay
           end if              


	   DO I=1,2
	    DO J=1,2 
	     IF (Lprev.EQ.0) THEN 
	      KLprev(I,J)=C0       ! In case of 1st layer KLprev is for vacuum
	      prev_dgnl=.true.
             END IF                
	     IF (Lprev.GT.0) THEN 	  
              KLprev(I,J)=Kmatrix(I,J,Lprev)              ! sp 10.11.06
	      prev_dgnl=.not.b_Cm(Lprev)			
	     ENDIF

            END DO
	   END DO

           DabsMatr=(KLprev(1,2)-KL(1,2))                  ! sp 10.11.06
     &                    *conjg((KLprev(1,2)-KL(1,2)))+
     &                    (KLprev(2,1)-KL(2,1))
     &                    *conjg((KLprev(2,1)-KL(2,1)))         
	
           IF (prev_dgnl.and.b_odz) then	       !
            both_dgnl   =.true.	                       !  Rohlsberger roughness1
            both_NONdgnl=.false.                       !
           ELSEIF (DabsMatr.lt.1.d-15) then            !
            both_dgnl   =.true.	                       !  Rohlsberger roughness1
            both_NONdgnl=.false.                       !
           ELSEIF (.not.prev_dgnl.and..not.b_odz) then
            both_dgnl   =.false.                       !
            both_NONdgnl=.true.                        !  Deak's roughness
           ELSE  
            both_dgnl   =.false.                       !  Rohlsberger roughness2
            both_NONdgnl=.false.                       !
           ENDIF

C          --------------------------------------------------------
C	   both_dgnl=.false.             !DONT FORGET TO REMOVE!!!!
C          both_NONdgnl=.true.              !Deak's roughness
C          --------------------------------------------------------

           call roughness(both_dgnl,both_NONdgnl,roughlay(L),
     &                   roughlay(Lnext),SQ,KLprev,KL,M)    
          END IF !Roughness
C----------------------end of Roughness-----------------------------

          call mat4(M,ML,ML)
          call mat4(ML,MS,M) 
c         write(6,'(8g12.4)')M
c         read(5,'(a)')
         endif ! VKD(L) > 0.         
         z1=z2
        end do ! L


        if(n_rep.gt.1.and.b_grp)then
         if(n.gt.1)then
          do I=1,4
           do J=1,4
            M(I,J)=ML(I,J)
           end do
          end do
         end if ! n.gt.1

         NLOG=alog(float(n))/alog(2.0)

         do I=1,NLOG
          call mat4(ML,ML,ML)
         end do

         do I=1,n-2**NLOG
          call mat4(M,ML,ML)
         end do
         do I=1,4
          do J=1,4
           MS(I,J)=ML(I,J)
           M(I,J) =ML(I,J)
          end do
         end do

        end if  ! n_rep>1

       END DO   ! n=1,n_rep

       POINTER=POINTER+GEOSTR(2*GRP)
      end do ! GRP

      return
      end

C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine transb(QD,KL,R,L,A,B)

C *******************************************************************
C
C Calculation of the 2x2 A and B matrixes - amplitudes of wave on the 
c upper border
C
C ******************************************************************

       implicit none

 ! Input 
      real*8     QD     !Kz- perpendicular komponent of wave vektor (Kz=Qz*0.5)
      complex*16 KL(2,2),R(2,2),L(4,4) !
  
!   Output
      complex*16 A(2,2),B(2,2)


!Other
      complex*16 L11(2,2),L12(2,2), L21(2,2),L22(2,2),
     &           RM(2,2),RP(2,2),A1(2,2),A2(2,2),
     &           C1(2,2),C2(2,2),C1P(2,2),C2P(2,2),
     &           C1M(2,2),C2M(2,2)
      real*8     QD2

      integer    I,J

C   ********************Body of the subroutine**************************************

      QD2=QD*QD

C    Definition of 2x2 block matrices L21, L22 and 
C    the 2x2 I-R and I+R matrices

      do I=1,2
       do J=1,2
        L11(I,J)= 0.5D0*L(I,J)  
	L12(I,J)= 0.5D0*L(I,J+2)
        L21(I,J)= 0.5D0*L(I+2,J)
        L22(I,J)= 0.5D0*L(I+2,J+2)
C
        RM(I,J) = -R(I,J)
        RP(I,J) =  R(I,J)
       end do

       RM(I,I)  =  1.D0-R(I,I)
       RP(I,I)  =  1.D0+R(I,I)

      end do
!Now Lij are block matrixes already divided by 2, Rm=1-R, Rp=1+R
        
      A1(1,1)=(KL(1,1)/QD2)+1.D0   !
      A1(1,2)= KL(1,2)/QD2         !A1=1+(K/Kz**2)
      A1(2,1)= KL(2,1)/QD2         !
      A1(2,2)=(KL(2,2)/QD2)+1.D0   !


      call sqrt2(A1,A2)            !A2=sqrt(A1)==etha  


      call inv2(A2,A1)             !A1=etha**-1
 
      call mat2(A1,L11,C1)         !C1=(etha**-1)*L11*0.5
      call mat2(A1,L12,C2)         !C2=(etha**-1)*L12*0.5

      do I=1,2
       do J=1,2
        C1P(I,J)=L21(I,J)+C1(I,J)  !C1P=(L21+(etha**-1)*L11)*0.5
        C1M(I,J)=L21(I,J)-C1(I,J)  !C1M=(L21-(etha**-1)*L11)*0.5
        C2P(I,J)=L22(I,J)+C2(I,J)  !C2P=(L22+(etha**-1)*L12)*0.5
        C2M(I,J)=L22(I,J)-C2(I,J)  !C2M=(L22-(etha**-1)*L12)*0.5
       end do
      end do
      call mat2(C1P,RM,C1)         !C1=(L21+(etha**-1)*L11)*(1-R)*0.5
      call mat2(C2P,RP,C2)         !C2=(L22+(etha**-1)*L12)*(1+R)*0.5
      call mat2(C1M,RM,A1)         !A1=(L21-(etha**-1)*L11)*(1-R)*0.5
      call mat2(C2M,RP,A2)         !A2=(L22-(etha**-1)*L12)*(1+R)*0.5
       do I=1,2
       do J=1,2
        A(I,J)=C1(I,J)+C2(I,J)     ! A=[L21+(etha**-1)*L11)*(1-R)+
		                   !   (L22+(etha**-1)*L12)*(1+R)]*0.5
        B(I,J)=A1(I,J)+A2(I,J)     ! B=[(L21-(etha**-1)*L11)*(1-R)+
                                   !   (L22-(etha**-1)*L12)*(1+R)]*0.5
       end do
      end do

      return
      end
C ******************************************************************************
C Subroutines calculate integral (exp(ikz)*A+exp(-ikz)B)*exp(-ik'z)dz 
C in the interval from z1 to z2
C ******************************************************************************

      subroutine analytic_fourier(z1,z2,QD,K1,KL,A,B,T)
      implicit none

! Input
      real*8 z1,z2,QD,K1
      complex*16 KL(2,2),A(2,2),B(2,2)
!OutPut   
      complex*16 T(2,2)
! Other
      complex*16 b_const,iz1,iz2,DM1(2,2),K(2,2),DMA(2,2),DMB(2,2),
c    & DMA1(2,2),DMB1(2,2),DMA2(2,2),DMB2(2,2),DMAS(2,2),DMBS(2,2),
     & DMAA(2,2),DMBB(2,2),iz21,CI,C1

      parameter (CI=(0.0D0,1.0D0),C1=(1.D0,0.D0))
      real*8 Kz2
      integer I,J
!Khaidukov 15.10.2005
      complex*16 phase_of_A(2,2),phase_of_B(2,2)
C********************Body of the subroutine

      iz1 =CI*z1
      iz2 =CI*z2
      iz21=iz2-iz1
      b_const=-CI/2.50662827D0*exp(-iz1*K1)  !b_const=1/i*sqrt(2*pi)
      Kz2=QD*QD
 
      DM1(1,1)=KL(1,1)+Kz2
      DM1(1,2)=KL(1,2)                          !DM1=Ko**2+KL
      DM1(2,1)=KL(2,1)
      DM1(2,2)=KL(2,2)+Kz2 

      call sqrt2(DM1,K)   ! K=sqrt(Ko**2+KL)- z component of incoming wavevector   
                          ! in the given layer
!-----------REMOVE ADDITIONAL PHASES FROM AMPLITUDES A and B
!       A->A*exp(-ikz1)  B->B*exp(ikz1)

      DO I=1,2
       DO J=1,2
        DMA(I,J)=K(I,J) 
	DMB(I,J)=K(I,J) 
       END DO
       DMA(I,I)= -K1+K(I,I)                ! DMA=-K1+K
       DMB(I,I)= -K1-K(I,I)                ! DMB=-K1-K
      END DO
Ccc

      DO I=1,2
       DO J=1,2
	phase_of_A(I,J)= iz21*DMA(I,J)   !phase_of_A= iz21*DMA
        phase_of_B(I,J)= iz21*DMB(I,J)   !phase_of_B= iz21*DMB
       END DO
      END DO

      call exp2(phase_of_A) !phase_of_A=exp(iz21*DMA)
      call exp2(phase_of_B) !phase_of_B=exp(iz21*DMB)
C
      DO I=1,2
       phase_of_A(I,I)=phase_of_A(I,I)-C1
       phase_of_B(I,I)=phase_of_B(I,I)-C1 
      END DO

      call mat2(phase_of_A,A,A) !A:=(exp(iz21*DMA)-I)*A 
      call mat2(phase_of_B,B,B) !B:=(exp(iz21*DMB)-I)*B 
Ccc
!       DO I=1,2          !Kh
!       DO J=1,2
 !      A(i,j)=(0.0,0.0)
 !       B(i,j)=(0.0,0.0)
 !     	END DO
 !       END DO
 !       A(1,1)=(1.0,0.0)
 ! 	A(2,2)=A(1,1)
!  Born-like approximation Khaidukov

      call inv2(DMA,DMAA) !DMAA=[K-K1]**-1
      call inv2(DMB,DMBB) !DMBB=[K+K1]**-1

      call mat2(DMAA,A,DMA) !DMA=([K-K1]**-1)*A
      call mat2(DMBB,B,DMB) !DMB=([K+K1]**-1)*B

      DO I=1,2
       DO J=1,2
        T(I,J)=(DMA(I,J)+DMB(I,J))*b_const
       END DO
      END DO

      return
      end

CC      DO I=1,2
CC       DO J=1,2
CC        DMA1(I,J)= iz1*DMA(I,J)       ! DMA1= i*z1*(K-K1)
CC	DMA2(I,J)= iz2*DMA(I,J)       ! DMA1= i*z2*(K-K1)
CC        DMB1(I,J)=-iz1*DMB(I,J)       ! DMB1=-i*z1*(K+K1)
CC	DMB2(I,J)=-iz2*DMB(I,J)       ! DMB2=-i*z2*(K+K1)
CC       END DO
CC      END DO
CC
CC      call exp2(DMA1)           ! DMA1=exp(i*z1*(K-K1))
CC      call exp2(DMA2)           ! DMA2=exp(i*z2*(K-K1))
CC      call exp2(DMB1)           ! DMB1=exp(-i*z1*(K+K1))
CC      call exp2(DMB2)           ! DMB2=exp(-i*z2*(K+K1))
CC
CC    DO I=1,2
CC     DO J=1,2
CC      DMAS(I,J)=DMA2(I,J)-DMA1(I,J) !DMAS=exp(i*z2*(K-K1))-exp(i*z1*(K-K1))
CC      DMBS(I,J)=DMB1(I,J)-DMB2(I,J) !DMBS=exp(-i*z1*(K+K1))-exp(-i*z2*(K+K1))
CC     END DO
CC    END DO
CC      
CC      
CC	
!	call mat2(A,DMAA,DMA) !DMA=A*[K-K1]**-1
!	call mat2(B,DMBB,DMB) !DMB=B*[K+K1]**-1
CC
CC
CC      call mat2(DMAS,DMA,DMAA)
!DMAA=[exp(i*z2*(K-K1))-exp(i*z1*(K-K1))]*([K-K1]**-1)*A
CC      call mat2(DMBS,DMB,DMBB)
!DMBB=[exp(-i*z1*(K+K1))-exp(-i*z2*(K+K1))]*([K+K1]**-1)*B


C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       subroutine g_phase(mlay,b_domain,MAXGRP,GEOSTR,SQ,
     &                      VKD,lay_domain,Tmatrix)
C*********************************************************************************************************************
C      Subroutine calculates Fourier transformation of the field (experssion
C      2.12 in the article). Result is stored in Tmatrix.
C     Size of the Tmatrix is 2*2*i, where i - Number of the layer with domains (pay attention) 
C
CC*********************************************************************************************************************
 
 
      implicit none
C     input:
      integer    mlay,MAXGRP,GEOSTR,lay_domain
      real*8     SQ,VKD
      complex*8  Tmatrix
      logical    b_domain
      dimension  b_domain(mlay),GEOSTR(0:2*MAXGRP),
     &           VKD(mlay),Tmatrix(2,2,lay_domain)
     &           

C   other variables:
      complex*16 C0,CI
      real*8     DL
      integer    L,n,n_rep,GRP,LMIN,LMAX,POINTER,I_D 

      parameter  (C0=(0.D0,0.D0), CI=(0.D0,1.D0))
C**************************************
      real*8     z1,z2
             
C---------------------------------------------

!  To set the Fouphase vector to zero fisrt
      I_D=0
      POINTER=0                                     
      z1=0.0D0  !First 
      z2=0.0D0  !and the second coordinate for each layer

      do GRP=1,MAXGRP      ! loop for the groups

C
       LMIN =POINTER+1
       LMAX =POINTER+GEOSTR(2*GRP)
       n_rep=GEOSTR(2*GRP-1)

       DO n=1,n_rep

        do L=LMIN,LMAX 
	 if(VKD(L).gt.0.d0) then  			 

          DL=VKD(L)
          if(DL.lt.0.d0)DL=1.0d30
	  z2=z1+DL

          IF (b_domain(L)) THEN !If there are domains in this layer store inform
   
           I_D=I_D+1

           Tmatrix(1,1,I_D)=-2.D0/SQ*exp(CI*SQ*(z1+DL/2.D0))
     &                     *sin(SQ*DL/2.D0)
           Tmatrix(2,2,I_D)=Tmatrix(1,1,I_D)
           Tmatrix(1,2,I_D)=C0
           Tmatrix(2,1,I_D)=C0
          END IF     ! Domains

         endif ! VKD(L) > 0.         
         z1=z2
        end do ! L

       END DO   ! n=1,n_rep

       POINTER=POINTER+GEOSTR(2*GRP)
      end do ! GRP

      return
      end





















