c Program for non-specular SMR spectra evaluation from correlated
c +- domains. 
cVesrion 2.
c        Khaidukov & Deak 
c        October 2005
C       +Summer 2006
c        H. Spiering november 2006
      subroutine synoffspec(b_total,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
      include 'complt.for'

      logical     b_total
      integer     info,ifrth,iaddr,idex,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,nstorTH1,nstorTHyy,nstorSI,nTH1,nCP,nTH2,nsrw,
     &            nstore,iflag_basis,l_Poincare,nLG,nTH,ith_channels,
     &            nsampling,ak8,nomega,nstrob_order,jt0_ch,iT_max,nvch,
     &            nhyperfine
      real        srw8
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),   !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,nstorTHyy,nstorSI,
     &              iaddr(4),nTH1,nCP,nTH2,nsrw,nstore,ifrth(3),              
     &              iflag_basis,l_Poincare,nLG,nTH,ith_channels,
     &              nsampling,ak8,nomega,srw8,nstrob_order,jt0_ch,
     &              iT_max,nvch,nhyperfine,idex(2)

      real          acsp,wavelength,uthick_A,
     &              unitchi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,columns,
     &              strob_order,t1_window,t2_window,flag_basis,  
     &              th_channels,Th_approx,angpairs,dumcsp
      common/acstrf/acsp,wavelength,uthick_A,
     &              unitchi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,columns,
     &              strob_order,t1_window,t2_window,flag_basis,  
     &              th_channels,angpairs,Th_approx,dumcsp(icstrf-18)

      real          avs,counts,background,Pxsi,Peta,Pzeta,
     &              ang_shift,dumvsp
      common/avstrf/avs,counts,background,Pxsi,Peta,Pzeta,
     &              ang_shift,dumvsp(ivstrf-7)

      logical       b_vs,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_ang_shift,b_dumvsp
      common/bvstrf/b_vs,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_ang_shift,b_dumvsp(ivstrf-7)
 
      real            acfr1,dumcfr1
      common/acfr1trf/acfr1,dumcfr1(icfr1trf-1)

      real            avfr1,pvfr1,Hext,thetaHe,phiHe,phiA,thetaA,psiA,
     &                lLcor_length,uUcor_length,dumvfr1
      common/avfr1trf/avfr1,pvfr1,Hext,thetaHe,phiHe,phiA,thetaA,psiA,
     &                lLcor_length,uUcor_length,dumvfr1(ivfr1trf-10)
      logical         b_vfr1,b_pvfr1,b_Hext,b_thetaHe,b_phiHe,b_phiA,
     &                b_thetaA,b_psiA,b_lLcorlength,b_uUcorlength,
     &                b_dumvfr1
      common/bvfr1trf/b_vfr1,b_pvfr1,b_Hext,b_thetaHe,b_phiHe,b_phiA,
     &                b_thetaA,b_psiA,b_lLcorlength,b_uUcorlength,
     &                b_dumvfr1(ivfr1trf-10)


      real            acfr2,rep_grp,dumcfr2
      common/acfr2trf/acfr2,rep_grp,dumcfr2(icfr2trf-2)

      real            avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                eta_domain,dumvfr2
      common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                eta_domain,dumvfr2(ivfr2trf-6)
      logical         b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_etadomain,b_dumvfr2
      common/bvfr2trf/b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_etadomain,b_dumvfr2(ivfr2trf-6)

      real            vsstrf,sftr
      common/avsstrf/ vsstrf(ivsstrf)
      logical         b_vsstrf
      common/bvsstrf/ b_vsstrf(ivsstrf)

      logical b_sites,b_domain
      real    winc
      real*8  thicklayer,vkd,roughlay
      integer ipos_mstruct1,laystr
      complex rho,A
      dimension b_sites(maxfr2),b_domain(maxfr2),
     &          winc(maxfr1),ipos_mstruct1(maxfr1),
     &          thicklayer(maxfr2),vkd(maxfr2),roughlay(maxfr2),
     &          laystr(2*maxfr2+2),rho(2,2),A(2,2)


C **** Definitions of structure variables L. Deak 09.10.2002 ***
      integer POINTER,GRP,MAXGRP,GEOSTR(0:2*maxfr2)
      logical b_first,b_isgt1
C ****                                                       ***     
      integer   iposlayav,iposlay,ichstr,ichall,indmu,indll,indly,
     &          lmu1,lmu2,maxn4,iscrd
      real      eta,wi,trace,Qz,ar_ratio,dscrd
      complex   chilay,rg1,g2r,
     &          SQRO,Sexpa,cmat,sFourier,
     &          Fourier,cmatav,cmat2
      parameter (iscrd=maxscrd-3-5*maxn-11*maxfr2-maxfr2*maxfr2*2
     &                    -16-128*maxn-66-24-8*maxfr2-16-max8-256,
     &                    maxn4=4*maxn)
      common/scrd/ichall(0:maxn*2),iposlay(maxfr2,2),ichstr(0:maxn),
     &          indmu(maxfr2),indll(maxfr2),indly(maxfr2),
     &          lmu1(maxfr2*maxfr2),lmu2(maxfr2*maxfr2),
     &          eta(maxfr2),wi(maxfr2,2),
     &          trace(-maxn:maxn),
     &          iposlayav(maxfr2),chilay(maxfr2),
     &          rg1(4,-maxn4:maxn4),g2r(4,-maxn4:maxn4),
     &          SQRO(4),Sexpa(0:32),cmat(4),sFourier(4),
     &          Fourier(2,2,maxfr2),
     &          cmatav(4),cmat2(4),dscrd(iscrd),Qz(max8),ar_ratio(0:255)

      integer lstruct1,lstruct2,lstruct3,isubthe,
     &        icase,i_angle,k_omega,i_theta,n_omega,n_theta,
     &        iall,mlay,lay_domain,nn_ne0,nstorIN,nstorTH2,
     &        isite,inc_pos,iss,i,k,ll,j,jj,n,nn,isgtp,lay,
     &        n_approx,i_approx,kom1,kom2,ibg_angle
      real    theta,theta_beg,dtheta,omega,omega_beg,domega,
     &        theta_m,omega_end,theta_end,pi,rad,sing,Offspec,
     &        weight,h1,ratio,start,finish
      real    vector_k,grazinc,grazout,corroff,thmax,hoffspec
      real*8  SQ,K1
      complex hc1,hci,hc0
      dimension hoffspec(64)

      real    c1,dumc
      common/acmaps/c1,dumc(icstrf-1)
c      complex forout, dimension forout(4,-maxn:maxn)
      logical b_lay,b_absorber,b_corr,b_angpairs,b_wr

      b_absorber=.false.
      b_corr=b_lLcorlength.or.b_uUcorlength
      b_angpairs=angpairs.gt.0.

      n_approx=Th_approx
c------------------------------------------------------------------
      nstorIN=nstorTH-maxfr2**2       ! pointer of the storage for 
c                                       the integrals 
c-------------------------------------------------------------------


      call mapsub(0)
      b_total=b_Pxsi.or.b_Peta.or.b_Pzeta.or.b_ang_shift

c     calculation of non equidistant energy points
       call channels_adjust(nvch,nhyperfine,nstrob_order,nomega,
     &                          iall)

c      the routine calculates channels needed for a nonequidistant
c      channel numbers for all later shifts +- nomega in the stoboscopic 
c      integration
c----------------------------------------------------------------------
c       nvch=0 
c       iall=nTH
c       do i=0,iall
c        ichall(i)=i
c       end do
c       ichall(nTH+1)=-1
c----------------------------------------------------------------------

      isubthe=1
      call get_theory(isubthe,info)
      b_total= b_total.or.(isubthe.gt.0) 
      hc1=cmplx(1.,0.)
      hci=cmplx(0.,1.)
      hc0=cmplx(0.,0.)

c      write(6,'(/,a,i3,/,a,/)')'synoffspec ifrcase=',ifrcase,
c     & 'this routine is under development - no results produced yet' 
c     this routine synoffspec is only called for ifrcase=31

cc    thfrcase(1)='time differential transmission spectrum(11)'
cc    thfrcase(2)='time differential reflection spectrum(21)'
c     thfrcase(3)='time integral - rocking curve,Fourier(22)'
c     thfrcase(4)='time integral - rocking curve(24)'
c     thfrcase(5)='prompt - rocking curve(23)'
c     thfrcase(5)='time integral - offspecular(31)'

c-------------------------------------------------------------------
c     write(6,'(3(a,e8.2))')
c    &    ' synmos-- Pxsi=',Pxsi,' Peta=',Peta,' Pzeta=',Pzeta
       pi=atan(1.)*4.
       rad=pi/180.
c      transformation matrix from spherical basis to (sigma,pi)-basis
       vector_k=2.0*pi/wavelength    ! /Angstroem
c---------------------------------------------------------------------------
c     transformation matrix from spherical basis to (sigma,pi)-basis
c     orientation of the absorber with respect to the beam

       rho(1,1)=cmplx(1.+Pzeta,0.)/2.
       rho(1,2)=cmplx(Pxsi,-Peta)/2.
       rho(2,1)=cmplx(Pxsi,Peta)/2.
       rho(2,2)=cmplx(1.-Pzeta,0.)/2.
                               
c      rho=(1+P*sigma)/2
c                (0  1)            (0  -i)              (1   0)  
c      sigma_xsi=(1  0), sigma_eta=(i   0),  sigma_zeta=(0  -1)   

      lstruct1=0
      iss=1
 1000 continue
 
      lstruct1=lstruct1+1
      if(lstruct1.gt.mstruct1) goto 2000
      inc_pos=l1_put(lstruct1)
      ipos_mstruct1(lstruct1)=inc_pos
c     inc_pos points to the data block on array_fr of the inc_oherent parts
c     running from 1 to mstruct1

c       write(6,'(a,i1,a2,i8)')
c     &         'synmos l1_put(',lstruct1,')=',l1_put(lstruct1)  

       call mapsub(iss)
       winc(lstruct1)=pvfr1
       b_total=b_total.or.b_pvfr1
c      weigth of the incoherent part (first number on common/avfr1trm/ belonging 
c      to the theory)


c      thetaA=(graz_end-graz_beg)/2.
       sing=sin(0.001*thetaA)

       iss=iss+1
       b_lay=.false.
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)
c       carefull lstruct2 counts the number of layers over all devices lstruct1
c      ------------------------------------------------------------
c      layer lay1,2 ... mlay of  absorber
c      ---------------------------------------------------------------
c      The Lorentz curve of the absorber in npq is 1 at resonance so that
c      for a singl line the exponent at resonance is just -teff (effective
c      thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/srw8,
c      normalizes ( to area 1) the Lorentz curve.
c
c      Sums of absorber curves at the positions Eagd.
c
c      ----0--------------------------naLG
c       naLG--------------------------0-------------        srw8
c        nTH------------0------------nTH                    srw

        lay=lstruct2

        call mapsub(iss)

        thicklayer(lay)=thicklay
        if(abs(re_chilay)+abs(ai_chilay).gt.1.0e-10) then
         chilay(lay)=cmplx(re_chilay,ai_chilay)*unitchi
        else
         chilay(lay)=(0.,0.)
        end if
        b_lay=b_vfr2.or.b_thicklay

        eta(lay)=eta_domain
c       to each layer may belong another eta, but there is only one eta 
c       per layer independent of the number of sites.
c       The case of strong antiferromagnetic correlation between layers
c       requires eta/1-eta for neigbouring layers!! 
c       if rep_grp is negativ the logical b_domain(lay) is .True.

        b_domain(lay)=rep_grp.lt.0
        i=abs(rep_grp)
        laystr(2*lay-1)=i
        laystr(2*lay)=10*(abs(rep_grp)-float(i)+.01)
        roughlay(lay)=roughness*vector_k

        b_isgt1=.false.
        if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then
         b_isgt1=.true.
         iposlayav(lay)=l2_put(lstruct2)
         jj=iposlayav(lay)
         do i=0,nTH
           ll=jj+8*i
          array_fr(ll+1)=chilay(lay)
          array_fr(ll+2)=chilay(lay)
          array_fr(ll+3)=(0.,0.)
          array_fr(ll+4)=(0.,0.)
          array_fr(ll+5)=chilay(lay)
          array_fr(ll+6)=chilay(lay)
          array_fr(ll+7)=(0.,0.)
          array_fr(ll+8)=(0.,0.)
         end do
        end if

        b_sites(lay)=.false.
        isite=0
        iss=iss+1
        do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)
c        carefull lstruct3 counts the number of sites over all layers lstruct2
         isite=isite+1
c        isite counts inside this layer 
         b_sites(lay)=.true.
c        at least one nuclear scatterer in the layer (used in g_optic)
         call mapsub(iss)
         
         sftr=vsstrf(2)
         weight=sftr*uthick_A
         wi(lay,isite)=weight/vector_k
        
c        intensity wi of the site 
  
         if(b_vsstrf(2)) then
          if(weight.gt.sing/20..or.sing.gt.0.05) 
     &      write(nwr,'(2(a,g8.1),a)')
     &    '** f*unit_thickness=',weight,' << sin(th)=',sing,' << 1 ?'
c           write(nwr,'(a,2g12.5)')'sftr=',sftr,weight/vector_k
          end if


         isubthe=0
         call get_theory(isubthe,info)
c        get_theory comes back with isubthe<0 if nothing to do
         b_lay=b_lay.or.(isubthe.gt.0)
 
         iposlay(lay,isite)=l3_get(lstruct3)
 
c        pointer on array_fr for the forward scattering amplitude for
c        each site it has to be multiplied by the weight(f factor) and 
c        the thickness of the layer thicklayer(lay). The weight thicklayer
c        will be carried by vkd=vector_k*thicklayer(lay).

         if(b_isgt1) then
          isgtp=l3_get(lstruct3)
          jj=iposlayav(lay)
          if(isite.eq.1)then
           h1=wi(lay,isite)*eta(lay)
          else 
           h1=wi(lay,isite)*(1.-eta(lay))
          end if
          do n=1,8*(nTH+1)
           array_fr(jj+n)=array_fr(jj+n)+array_fr(isgtp+n)*h1
          end do
         else
          write(nwr,'(a)')' only one site -> no domains !!'
         end if

         iss=iss+1
        end do
        b_absorber=b_absorber.or.b_lay

       end do
c      end of loop over all layers

       mlay=lay
       laystr(2*lay+2)=-1
       laystr(2*lay+1)=0
       b_total=b_total.or.b_absorber

c      write(6,'(a)')'++++++++++++++synrock++++++++++++++++++++++'
c      write(6,'(a,20i3)') 'laystr(1..lay)=',(laystr(i),i=1,2*lay)
c-----------------------------------------------------------------------
c     here the matrix R for the layers are given :
c     satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                         (samplay(n,lay) -sapplay(n,lay))
c
c     calculation of the transmittivity matrix T for all channels n
c     by   T = exp(iR)*rho*exp(-iR+)


      if(.not.(b_total.or.b_corr)) goto 1000

c     if no change of any layer )and sites of the layer changed b_total=.false.
      do lay=1,mlay
       vkd(lay)=vector_k*thicklayer(lay)
      end do

c       write(6,'(a,20i4)')'laystr=',(laystr(i),i=1,2*mlay) 
C      ****************************************************************
C      Construction of the layer structure from the laystr variable. 
c      GEOSTR(GRP) is the number of layers in group GRP.
c      L. Deak, 09.10.2002                                                     *** 
       GRP         =0
       GEOSTR(GRP) =0
       MAXGRP      =0
C
       b_first     =.true.
       POINTER=1
       do lay=2,2*mlay,2
        if(b_first)then
         if(GRP.eq.laystr(lay))then
          GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1
         else
          POINTER         =POINTER+GEOSTR(2*GRP)
          GRP             =GRP+1
          MAXGRP          =GRP
          GEOSTR(2*GRP)   =1
          GEOSTR(2*GRP-1) =laystr(lay-1)
         end if
         if(vkd(lay/2).lt.0.) then
          b_first         =.false.
          vkd(lay/2)      =1.d30
          GEOSTR(2*GRP-1) =1
         end if ! VKD < 0
        end if  ! b_first
       end do
c       write(6,'(a,20i4)')
c     &    'MAXGRP,GEOSTR=',MAXGRP,(GEOSTR(i),i=1,2*MAXGRP) 
C      ******************************************************************
        b_wr=.false.
        DO i=1,2
         DO k=1,2
          A(i,k)=rho(i,k)
         END DO
        END DO
        call ssqrt2(A,A)
        SQRO(1)=A(1,1)
        SQRO(2)=A(2,1)
        SQRO(3)=A(1,2)
        SQRO(4)=A(2,2)

c      n_theta,theta_beg,dtheta,n_omega,omega_beg,domega
       icase=int(real(array_fr(l1_get(0)+1)))
       n_omega=int(real(array_fr(l1_get(0)+2)))
       n_theta=int(aimag(array_fr(l1_get(0)+2)))
       omega_beg=real(array_fr(l1_get(0)+3))
       domega=aimag(array_fr(l1_get(0)+3))
       theta_beg=real(array_fr(l1_get(0)+4))
       dtheta=aimag(array_fr(l1_get(0)+4))
       omega_end=real(array_fr(l1_get(0)+5))
       theta_end=aimag(array_fr(l1_get(0)+5))
       theta_m=aimag(array_fr(l1_get(0)+6))

c       write(6,'(a,i3)')' icase=',icase
c      nstorTH is 0 by fr_synchrotron() (usage does not interfere
       nstorTH=l1_get(0)+6             ! see th_yscanmode()
       nstorTH2=nstorTH*2
       nTH1=real(array_fr(l1_get(0)+6))

c       write(6,'(a,3i7)') 'th_synoff  nTH1,nstorTH=',nTH1,nstorTH
c       write(6,'(a,i4,4x,3f10.4)')
c     &  'n_theta,theta_beg,dtheta,theta_end=',
c     &   n_theta,theta_beg,dtheta,theta_end
c       write(6,'(a,i4,4x,3f10.4)')
c     &   'n_omega,omega_beg,domega,omega_end=',
c     &   n_omega,omega_beg,domega,omega_end

        call corfou(maxfr2,MAXGRP,GEOSTR,b_domain,
     &           indmu,indll,indly,lmu1,lmu2,lay_domain,nn_ne0)

	call window_function(nstrob_order,T_bunch,t1_window,t2_window,
     &                                                         Sexpa)   
       i=1
       do while(eta(i).ne.0.)
        i=i+1
       end do
       eta_domain=eta(i-1)
 
c       write(6,'(a, 2f12.3)')
c     &  ' eta_domain,lLcor_length=',eta_domain,lLcor_length
      call cpu_time(start)
      b_corr=b_corr.and.(.not.b_total)
      if(b_angpairs.or.n_approx.ge.1.or.b_corr) goto 555
c      n_approx=0   grazinc<=grazout:diwa  i_approx=1
c                   grazinc>grazout :dowa  i_approx=2
c      n_approx=1   i_approx=1  diwa 
c      n_approx=2   i_approx=2  dowa
c      n_approx=3   i_approx=3  Born approximation
 
c     ---------  begin of loops over specular angles -> ratio: dowa/diwa
      if(icase.le.4)then 
c      icase=1 exchange of theta and omega in routine scanmode
       do i_theta=1,n_theta
        theta=theta_beg+dtheta*(i_theta-1)

        grazinc=0.001*theta/2.
        SQ=sin(grazinc)
        K1=-SQ
        call  offspecular(b_wr,
     &                    2,mlay,b_sites,b_domain,MAXGRP,GEOSTR,
     &                       roughlay,vkd,lay_domain,
     &                       nstorTH1,nTH2,nstore,nn_ne0,iall,
     &                       nstrob_order,nvch,nhyperfine,nomega,
     &                       SQ,K1,Offspec)
        ar_ratio(i_theta)=Offspec
c        write(6,'(l5,a,2g12.4)')dowa,' Offspec=',Offspec,theta
        call  offspecular(b_wr,
     &                    1,mlay,b_sites,b_domain,MAXGRP,GEOSTR,
     &                       roughlay,vkd,lay_domain,
     &                       nstorTH1,nTH2,nstore,nn_ne0,iall,
     &                       nstrob_order,nvch,nhyperfine,nomega,
     &                       SQ,K1,Offspec)
        ar_ratio(i_theta)=Offspec/ar_ratio(i_theta)
c        write(6,'(l5,a,2g12.4)')dowa,' Offspec=',Offspec,theta
       end do
      else if(icase.eq.5)then 
       do k_omega=1,n_omega
        ar_ratio(k_omega)=0.0
       end do 
       do k_omega=1,n_omega        
        omega=omega_beg+domega*(k_omega-1)
        grazinc=0.001*omega
        SQ=sin(grazinc)
        K1=-SQ
c        write(6,'(a,6g12.3)')' omega=',omega
        call  offspecular(b_wr,
     &                    1,mlay,b_sites,b_domain,MAXGRP,GEOSTR,
     &                       roughlay,vkd,lay_domain,
     &                       nstorTH1,nTH2,nstore,nn_ne0,iall,
     &                       nstrob_order,nvch,nhyperfine,nomega,
     &                       SQ,K1,Offspec)
        ar_ratio(k_omega)=Offspec
c                write(6,'(i6,6g12.3)')k_omega,Offspec
        call  offspecular(b_wr,
     &                    2,mlay,b_sites,b_domain,MAXGRP,GEOSTR,
     &                       roughlay,vkd,lay_domain,
     &                       nstorTH1,nTH2,nstore,nn_ne0,iall,
     &                       nstrob_order,nvch,nhyperfine,nomega,
     &                       SQ,K1,Offspec)
c                write(6,'(i6,6g12.3)')k_omega,Offspec
        if(Offspec.gt.0)then
         ar_ratio(k_omega)=ar_ratio(k_omega)/Offspec
        else
         ar_ratio(k_omega)=0.
        end if
       end do
c       write(6,'(8f10.2)')(ar_ratio(k_omega),k_omega=1,n_omega)
      end if
c     ----------- end of loops over specular angles -> ratio: dowa/diwa
 555  continue
      kom1=1
      kom2=n_omega 
      if(.not.(b_angpairs.or.b_corr))then
       if(n_approx.eq.4) then
c       symmetrized diwa
        kom2=(n_omega+1)/2
       else if(n_approx.eq.5) then 
c       symmetrized diwa
        kom1=(n_omega+1)/2
       end if
      end if
 
      i_angle=0
      nn=nstorTH*2+nTH1
      do i_theta=1,n_theta
       theta=theta_beg+dtheta*(i_theta-1)
       ibg_angle=i_angle+1
       do k_omega=kom1,kom2        
        omega=omega_beg+domega*(k_omega-1)
        if(omega.eq.0.) omega=domega/100. 

        if(icase.eq.1.or.icase.eq.4)then
c        exchange of theta and omega in routine scanmode
         grazinc=theta
         grazout=omega
         ratio=ar_ratio(i_theta)        
        else if(icase.eq.2.or.icase.eq.3) then
         grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta
         grazout=2*omega_beg+domega*(n_omega-1)+
     &       (i_theta-1)*dtheta*2-grazinc
         if(grazout.lt.0.) then
          Offspec=0.0
          i_angle=i_angle+1
          goto 776
         end if 
         ratio=ar_ratio(i_theta)
        else if(icase.eq.5) then
c        PHI_s=omega N_s=n_omega
         j=i_theta/2
         if(2*j.eq.i_theta) then
c         + dTheta_out
          grazinc=omega
          grazout=omega+dtheta*j
         else
c         + dTheta_out
          grazinc=omega+dtheta*j
          grazout=omega
         end if
         if(omega+dtheta*j.gt.omega_end)goto 777
         ratio=ar_ratio(k_omega)
        end if   

        i_angle=i_angle+1

        if(n_approx.eq.0)then
         i_approx=2
         if(grazinc.lt.grazout)i_approx=1               ! dowa/diwa
        else if(n_approx.eq.1.or.n_approx.eq.4)then
         i_approx=1 
        else if(n_approx.eq.2.or.n_approx.eq.5)then 
         i_approx=2
        else if(n_approx.eq.3)then
          i_approx=3
        end if

        grazinc=(grazinc+0.01)*0.001
        grazout=(grazout+0.01)*0.001                
        Qz(i_angle)=vector_k*(cos(grazout)-cos(grazinc))
        
        SQ= sin(grazinc)
        K1=-sin(grazout)
c        write(6,'(i2,a,6g12.3)')i_approx,'=i_app,Qz,SQ=',Qz(i_angle),SQ
        if(b_angpairs.or.b_corr) goto 777
        call  offspecular(b_wr,
     &                    i_approx,mlay,b_sites,b_domain,MAXGRP,GEOSTR,
     &                       roughlay,vkd,lay_domain,
     &                       nstorTH1,nTH2,nstore,nn_ne0,iall,
     &                       nstrob_order,nvch,nhyperfine,nomega,
     &                       SQ,K1,Offspec)
c          write(6,'(i4,a,2g12.3,f12.5,f10.3)') k_omega,
c     & ' grazinc,grazout=',grazinc*1000,grazout*1000,Offspec*1.e5,ratio

        if(n_approx.eq.0.and.i_approx.eq.2)Offspec=Offspec*ratio
        Offspec=Offspec*srw8*eta_domain*(1.0-eta_domain)

c        if(abs(Qz(i_angle)).lt.1.e-10)

 776    real_fr(nn+i_angle)=Offspec
 777    continue
       end do          ! omega
       if(b_angpairs.or.b_corr) goto 778
       if(n_approx.gt.3) then
        j=i_angle
        do k=kom1,kom2
         hoffspec(k)=real_fr(nn+j)
         j=j-1
        end do
c        write(6,'(a,4i4)') 'kom1,kom2,j,i_angle=',kom1,kom2,j,i_angle 
c        write(6,'(6(i3,g12.3))')(k,hoffspec(k),k=kom1,kom2) 
        if(n_approx.eq.4) then 
         do k=2,kom2
          i_angle=i_angle+1
          real_fr(nn+i_angle)=hoffspec(k)
         end do 
c         write(6,'(a,3i4)') 'ibg_angle=',ibg_angle
c         write(6,'(6g12.3)')(real_fr(nn+k),k=ibg_angle,i_angle)
        else if(n_approx.eq.5) then
         i_angle=j
         do k=kom1,kom2
          i_angle=i_angle+1
          real_fr(nn+i_angle)=hoffspec(k)
         end do
c         write(6,'(a,3i4)') 'ibg_angle,i_angle=',ibg_angle,i_angle
c         write(6,'(6(i3,g12.3))')(k,real_fr(nn+k),k=ibg_angle,i_angle)               
         do k=kom2-1,kom1,-1
          i_angle=i_angle+1
          real_fr(nn+i_angle)=hoffspec(k)
         end do 
        end if              
       end if
 778   continue
c      write(6,'(a,3i4)') 'ibg_angle=',ibg_angle
c      write(6,'(6g12.3)')(real_fr(nn+k),k=ibg_angle,i_angle)
      end do          ! theta
      if(b_corr)b_total=.true.

      thmax=0.
      if(.not.b_angpairs) then
       do k=1,i_angle
        Offspec=real_fr(nn+k)*corroff(Qz(k),lLcor_length*1.0e4)
        if(Offspec.gt.thmax)thmax=Offspec
        real_fr(nstorTH2+k)=Offspec
       end do
       do k=1,i_angle
        real_fr(nstorTH2+k)=real_fr(nstorTH2+k)/thmax
       end do
c       write(6,'(5f12.4)')(real_fr(nstorTH2+k),k=1,i_angle)

       nTH1=real(array_fr(nstorTH))
       do k=i_angle+1,nTH1
        real_fr(nstorTH2+k)=0.0
       end do
      end if

      h1=real(array_fr(nstorTH))
      array_fr(nstorTH)=cmplx(h1,float(i_angle))
      call cpu_time(finish)
      print '(" runtime = ",f15.3," seconds.")',finish-start
c############### connection to global ###########
 2000  continue
      return
      end





	subroutine window_function(nStrobo,Tbunch,t1,t2,S)   
	implicit none
	integer    nStrobo
	real*4     Tbunch,t1,t2
	complex*8 S(0:32)
	real*4     T2pT1,T2mT1,t1_window,t2_window,pi,pi_inv
	complex*8 CI
	parameter (CI=(0.0,1.0)) 
	integer    i

C    maxSn    =                             : 10
C    T_bunch : the perod of the synchrotron : 176 ns
C    t1      : starting of the time window  :  10 ns
C    t2       = T_bunch-t1                  : 166 ns

        t1_window        = t1/Tbunch
        t2_window        = t2/Tbunch

        pi               = atan(1.0)*4.0
        pi_inv           = 1.0/pi
        T2pT1            = (t2_window+t1_window)*pi
        T2mT1            =  t2_window-t1_window
C
C be careful, we want to use 2*Re[S(n)*Tr..] so
C S(0) is the half of the mathematical S(0) !!!!
C
        S(0)             = cmplx(T2mT1,0.0)/2.
        T2mT1            = T2mT1*pi

        do i=1,nStrobo
         S(i)            = pi_inv*
     &         cmplx(cos(float(i)*T2pT1),sin(float(i)*T2pT1))
     &                       *sin(float(i)*T2mT1)/float(i)
        end do

      return
      end



      subroutine th_offspeccorrelation(isubthe,icase,iput,iget,info)
      implicit none

      include 'comglb.for'
      include 'comthe.for'

      integer isubthe,icase,iput,iget,info
      real          c1,dumc,case
      common/acmaps/c1,
     &              dumc(icstrf-1)
      logical       b_c1,b_dumc
      common/bcmaps/b_c1,
     &              b_dumc(icstrf-1)
      real          v1,va12,vb12,dumv
      common/avmaps/v1,va12,vb12,dumv(ivstrf-3)
      logical       b_v1,b_va12,b_vb12,b_dumv
      common/bvmaps/b_v1,b_va12,b_vb12,b_dumv(ivstrf-3)


 
      if(isubthe.lt.0) then
       c1=1
c      storage for this routine
       theoryname='offspecular_correlation_matrix     v=001'
       return
      end if
       call get_theory(isubthe,info)
       case=real(array_fr(iget+1))
       array_fr(iput+1)=cmplx(float(icase),case)
 
       if(.not.b_c1) then
        isubthe=-abs(isubthe)
        return
       end if

      return
      end

      subroutine th_offspeccorrelfunc(isubthe,icase,iput,iget,info)
      implicit none

      include 'comglb.for'
      include 'comthe.for'

      integer isubthe,icase,iput,iget,info
      real          c1,dumc
      common/acmaps/c1,
     &              dumc(icstrf-1)
      logical       b_c1,b_dumc
      common/bcmaps/b_c1,
     &              b_dumc(icstrf-1)
      real          v1,va12,vb12,dumv
      common/avmaps/v1,va12,vb12,dumv(ivstrf-3)
      logical       b_v1,b_va12,b_vb12,b_dumv
      common/bvmaps/b_v1,b_va12,b_vb12,b_dumv(ivstrf-3)


 
      if(isubthe.lt.0) then
       c1=1
c      storage for this routine
       theoryname='offspecular_correlation_function     v=001'
       return
      end if
      array_fr(iput+1)=cmplx(float(icase),0.)  

       if(.not.b_c1) then
        isubthe=-abs(isubthe)
        return
       end if

      return
      end


      subroutine th_scanmode(isubthe,icase,iput,iget,info)
      implicit none

      include 'comglb.for'
      include 'comthe.for'

      integer      isubthe,icase,iput,iget,info
       real          c1,dumc
      common/acmaps/c1,dumc(icstrf-1)
      logical       b_c1,b_dumc
      common/bcmaps/b_c1, b_dumc(icstrf-1)
      
      integer j,n_omega,n_theta,i_angle,i_theta,k_omega
      real    omega_beg,domega,omega_end,theta_beg,dtheta,theta_end,
     &        theta_m,omega,theta

        theoryname='offspecular_scanmode     v=001'
c      when asking for 'theoryname's  of subroutines b_c1=.false.
c      => calculations avoided
       if(.not.b_c1) then
        isubthe=-abs(isubthe)
        return
       end if

c       write(6,'(a,5i8)')' scanmode isubthe,icase,iput,iget=',
c     &                              isubthe,icase,iput,iget

       if(icase.eq.1) then
        n_omega=dumc(1)
        omega_beg=dumc(2)        
        omega_end=dumc(3)
        if(n_omega.gt.1) then
         domega=(omega_end-omega_beg)/(n_omega-1)
        else
         domega=0.
        end if
        n_theta=dumc(4) 
        theta_beg=dumc(5)           
        dtheta=dumc(6)
        if(n_theta.le.1) then
         dtheta=0.
         theta_end=theta_beg
        else 
         theta_end=theta_beg+(n_theta-1)*dtheta
        end if
        goto 10        
       end if
 
       if(icase.eq.2.or.icase.eq.3) then
c        if(isubthe.gt.0)   call get_theory(isubthe,info)        

c       omega scan   (at theta_beg/2 specular reflection)
        j=dumc(1)/2
        n_omega=2*j+1
        omega_beg=dumc(2)         
        n_theta=dumc(4)
        theta_beg=dumc(5)
        omega_end=theta_beg
        domega=(omega_end-omega_beg)/(n_omega-1)
        dtheta=dumc(6)
        theta_end=theta_beg+(n_theta-1)*dtheta
        goto 10        
       end if 

       n_omega=dumc(1)
       omega_beg=dumc(2)         
       omega_end=dumc(3)
       if(n_omega.gt.1) then
        domega=(omega_end-omega_beg)/(n_omega-1)
       else
        domega=0.
       end if
       if(icase.eq.4) then
        n_theta=dumc(4) 
        theta_beg=dumc(5)            
        theta_end=dumc(6)
        if(n_theta.gt.1) then
         dtheta=(theta_end-theta_beg)/(n_theta-1)
        else 
         dtheta=0.
        end if
        goto 10
       end if

       n_theta=dumc(4) 
       theta_beg=dumc(5)            
       dtheta=dumc(6)
       if(n_theta.le.1) then
        dtheta=0.
        theta_end=theta_beg
       else 
        theta_end=theta_beg+(n_theta-1)*dtheta
       end if
 
       if(icase.eq.5) then
c       scan parallel to  theta_in= theta_out (specular)         
c       PHI_s=omega N_s=n_omega, dtheta parallel shift
        if(n_theta.eq.1) then
          dtheta=0.
        else
         dtheta=domega*2.0
         theta_beg=0.
         theta_end=n_theta*dtheta
         n_theta=n_theta*2-1
        end if
       end if
       
 10    c1=6
c      if isubthe<0 iput is not yet defined (iput=0) 
c      => storage on array_fr not possible  
       if(isubthe.gt.0) then
        array_fr(iput+1)=cmplx(float(icase),float(icase))
        array_fr(iput+2)=cmplx(float(n_omega),float(n_theta))
        array_fr(iput+3)=cmplx(omega_beg,domega)
        array_fr(iput+4)=cmplx(theta_beg,dtheta)
        array_fr(iput+5)=cmplx(omega_end,theta_end)
       end if

       if(icase.le.4) then
        i_angle=(n_theta+1)*(abs(n_omega)+1)
        goto 20
       end if

       i_angle=0
       do i_theta=1,n_theta
        theta=theta_beg+dtheta*(i_theta-1)
        do k_omega=1,n_omega        
         omega=omega_beg+domega*(k_omega-1)
         
         if(icase.eq.5) then
c         PHI_s=omega N_s=n_omega
          j=i_theta/2
          if(omega+dtheta*j.gt.omega_end+0.01)goto 77
         end if
         i_angle=i_angle+1
 77      continue
        end do
       end do
 20    c1=c1+(i_angle+1)
c      write(6,'(a,5i6)')' iput,c1,i_angle=',iput,int(c1),i_angle
       
       if(isubthe.gt.0)array_fr(iput+6)=cmplx(c1-6.,theta_m)
      return
      end


      subroutine th_oromega(isubthe,icase,iput,iget,info)
      implicit none

      include 'comglb.for'
      include 'comthe.for'

      integer      isubthe,icase,iput,iget,info
       real          c1,dumc
      common/acmaps/c1,dumc(icstrf-1)
      logical       b_c1,b_dumc
      common/bcmaps/b_c1, b_dumc(icstrf-1)
      
        theoryname='offspecular_omega     v=001'
c      when asking for 'theoryname's  of subroutines b_c1=.false.
c      => calculations avoided
       if(.not.b_c1) then
        isubthe=-abs(isubthe)
        return
       end if

c       write(6,'(a,5i8)')' ##### oromega iput,iget=',iput,iget

       c1=dumc(1)
       
      return
      end


	subroutine ssqrt2(A,B)
C ******************************************************************
C                     ssqrt matrix (for 2X2)
C ******************************************************************
C
      implicit none
C
	complex*8 A(2,2),B(2,2),DetA,TrA,AA,sqDetA
	real*4     imDetA,small
	parameter (small=1e-8 )
!     Khaidukov 05.10.2005
      real*4 check_value
C
C       B     = sqrt(A) =[A+I*sqrt(DetA)]/sqrt[TrA+2*sqrt(DetA)]
C       
      check_value=abs(A(1,2)*A(2,1)/(A(1,1)*A(2,2)))
      IF (check_value.LT.small) THEN 
	B(1,1)=sqrt(A(1,1))                                    ! Diagonal matrix
	B(2,2)=sqrt(A(2,2))                                    !
	B(1,2)=cmplx(0.,0.)
        B(2,1)=cmplx(0.,0.)
   
      ELSE
        DetA  = A(1,1)*A(2,2)-A(1,2)*A(2,1)                    ! NON
	sqDetA= sqrt(DetA)                                     !DIAGONAL
        TrA   = A(1,1)+A(2,2)                                  ! 
                                                               
	imDetA=aimag(DetA)                                      
	if(imDetA.gt.0.) sqDetA=-sqDetA
	AA    = 1./sqrt(TrA+2.*sqDetA)

	B(1,1)= (A(1,1)+sqDetA)*AA
	B(2,2)= (A(2,2)+sqDetA)*AA                               !MATRIX
	B(1,2)= A(1,2)*AA                                        !
	B(2,1)= A(2,1)*AA                                        ! 
	END IF
	return
	end
      

      subroutine corfou(maxl,MAXGRP,GEOSTR,b_domain,
     &           indmu,indll,indly,lmu1,lmu2,lay_domain,nn_ne0)
      implicit none
      integer classPOINTER,GRP,MAXGRP,LMAX,LMAX1,LMIN,LMIN1,n_rep,
     &        n_rep1,n,n1,I1,L1,mu1,mu2,maxl,
     &        GEOSTR,i2,l,classPOINTER1,GRP1,
     &        indmu,indll,indly,lmu1,lmu2,nn,nn1,nn2,lay_domain,nn_ne0
      logical b_domain
      dimension GEOSTR(0:2*MAXGRP),b_domain(maxl/6),
     &          indmu(maxl),indll(maxl),indly(maxl),
     &          lmu1(maxl*maxl),lmu2(maxl*maxl)

       nn=0
       nn1=0
       DO mu1=1,2 
	I1=0
        classPOINTER=0
        do GRP=1,MAXGRP              ! loop for the groups
         LMIN =classPOINTER+1
         LMAX =classPOINTER+GEOSTR(2*GRP)
         n_rep=GEOSTR(2*GRP-1)
	 n=1
         DO WHILE (n.LE.n_rep)
	  n=n+1
          do L=LMIN,LMAX                        ! L 
	   if(b_domain(L)) then      
            nn1=nn1+1
	    I1=I1+1
            indly(nn1)=L
            indmu(nn1)=mu1
            indll(nn1)=I1

            nn2=0
            DO mu2=1,2
	     I2=0
             classPOINTER1=0
             do GRP1=1,MAXGRP            ! loop for the groups
              LMIN1 =classPOINTER1+1
              LMAX1 =classPOINTER1+GEOSTR(2*GRP1)
              n_rep1=GEOSTR(2*GRP1-1)
              n1=1
              DO WHILE (n1.LE.n_rep1)
               n1=n1+1
               do L1=LMIN1,LMAX1
                if(b_domain(L1))  then  !
                 nn2=nn2+1
  	         I2=I2+1
c--------------  All the model assumptions are in this IF-block------------ 
                 nn=nn+1              
c                (-1)**(I1+I2+1-delta(mu1,mu2))
                 IF (mod(I1+I2,2).EQ.0)then
                  lmu1(nn)=nn1
                  lmu2(nn)=nn2
                  if(mu1.ne.mu2)then
                   lmu1(nn)=-nn1
                   lmu2(nn)=-nn2 
                  end if
   	         ELSE 
                  lmu1(nn)=nn1
                  lmu2(nn)=nn2
                  if(mu1.eq .mu2) THEN
                   lmu1(nn)=-nn1
                   lmu2(nn)=-nn2 
                  end if
 	         END IF
c-------------- -------------- end of IF-block ------------------------  
                endif ! vkd(L1) > 0. and ksi(L1)>0
	       end do ! L1
              END DO  ! n1<=n1_rep
              classPOINTER1=classPOINTER1+GEOSTR(2*GRP1)
             end do ! GRP1
            END DO       ! over mu2
           endif    ! VKD(L) > 0. and ksi>0        
          end do    ! L
	 END DO     ! n<=n_rep
         classPOINTER=classPOINTER+GEOSTR(2*GRP)
        end do      ! GRP
       END DO       ! over mu1
      lay_domain=I1
      nn_ne0=nn

      return
      end


      subroutine Gamma_mju(b_wr,dowa,nstorTH1,nTH2,nstore,nn_ne0,iall,
     &              nstrob_order,nvch,nhyperfine,nomega,Offspec)
      implicit none
      include 'comglb.for'
      include 'comthe.for'

      logical dowa,b_wr
      integer   nstorTH1,nTH2,nstore,nn_ne0,iall,nstrob_order,nvch,
     &          nhyperfine,nomega
      real      Offspec

      integer   iposlayav,iposlay,ichstr,ichall,indmu,indll,indly,
     &          lmu1,lmu2,maxn4,idumscrd
      real      eta,wi,trace,dumscrd
      real      ap0,ap1,ap2,bp0,bp1,bp2,cp0,cp1,cp2,dx1,dx2,dx3
      complex   chilay,rg1,g2r,
     &          SQRO,Sexpa,cmat,sFourier

      parameter (idumscrd=maxscrd-11*maxfr2-3-5*maxn-
     &                    maxfr2*maxfr2*2-16-128*maxn-66-24-12*96,
     &                    maxn4=4*maxn)
      common/scrd/ichall(0:maxn*2),iposlay(maxfr2,2),ichstr(0:maxn),
     &          indmu(maxfr2),indll(maxfr2),indly(maxfr2),
     &          lmu1(maxfr2*maxfr2),lmu2(maxfr2*maxfr2),
     &          eta(maxfr2),wi(maxfr2,2),
     &          trace(-maxn:maxn),
     &          iposlayav(maxfr2),chilay(maxfr2),
     &          rg1(4,-maxn4:maxn4),g2r(4,-maxn4:maxn4),
     &          SQRO(4),Sexpa(0:32),cmat(4),sFourier(4),
     &          ap0(0:95),ap1(0:95),ap2(0:95),
     &          bp0(0:95),bp1(0:95),bp2(0:95),
     &          cp0(0:95),cp1(0:95),cp2(0:95),
     &          dx1(0:95),dx2(0:95),dx3(0:95),
     &          dumscrd(idumscrd)

      integer   i,icht,ii,ij,j,ka,k0,k1,k2,ll1,lay1,mu1,ll2,lay2,mu2,
     &          mcht,np,nn,neg,nstrob,np1,np2,lmu1nn,lmu1sig,
     &          lmu2nn,lmu2sig,nstorTH12,nst,ipos1,ipos2,ni
      real      ap,bp,cp,hsit,det,x0,x1,x2,hh,h1,h2,pcr,pci

      complex   hc,B(4)
c      complex   forout,store
c      dimension forout(4,-maxn:maxn),store(-maxn:maxn),ncht(4)
c         open(unit=8,file='ch8.dat'
c     &            ,status='unknown'
c     &            ,access='sequential'
c     &            ,form='formatted') 

c       call cpu_time(start)
c       write(6,'(10i6)')(ichall(ka),ka=0,iall)
c       write(6,'(a,10i6)')'Ga iall,ichall(iall)=',iall,ichall(iall)
c        nna=796
        nstorTH12=nstorTH1+nTH2
        mu1=0
        lay1=0
        ll1=0
c        write(6,'(a,5i6)')'nstorTH1,nstorTH12+1,nstorTH12+nstore=',
c     &                     nstorTH1,nstorTH12+1,nstorTH12+nstore
        do i=nstorTH12+1,nstorTH12+nstore 
         array_fr(i)=(0.,0.)
        end do

        do nn=1,nn_ne0
         lmu1nn=lmu1(nn)
         lmu1sig=1 
         if(lmu1nn.lt.0)then 
           lmu1sig=-1 
           lmu1nn=-lmu1nn
         end if
         lmu2nn=lmu2(nn)
           lmu2sig=1 
         if(lmu2nn.lt.0)then 
           lmu2sig=-1 
           lmu2nn=-lmu2nn
         end if

         mu2=indmu(lmu2nn)
         lay2=indly(lmu2nn)
         ll2=indll(lmu2nn)
         np2=nstorTH1+4*(2*iall+1)*(ll2-1)
         ipos2=iposlay(lay2,mu2)

c        -------------lmu1-------------------
         if(mu1.eq.indmu(lmu1nn).and.
     &      lay1.eq.indly(lmu1nn).and.ll1.eq.indll(lmu1nn)) goto 10

         mu1=indmu(lmu1nn)
         lay1=indly(lmu1nn)
         ll1=indll(lmu1nn)
         np1=nstorTH1+4*(2*iall+1)*(ll1-1)
         ipos1=iposlay(lay1,mu1)

         hh=wi(lay1,mu1)
         DO ka=0,iall
          ii=ichall(ka)
          do neg=-1,1,2          
 
           np=ipos1+8*ii+(neg+1)*2
c          change from effi- to Fortran convention
c          effi (1 3)  to fortran  ( 1 3 )
c               (4 2)              ( 2 4 )
           if(dowa)then
            Cmat(1)=conjg(array_fr(np+1)*hh)    
            Cmat(4)=conjg(array_fr(np+2)*hh)    
            Cmat(3)=conjg(array_fr(np+4)*hh)
            Cmat(2)=conjg(array_fr(np+3)*hh)
           else
            Cmat(1)=array_fr(np+1)*hh    
            Cmat(4)=array_fr(np+2)*hh    
            Cmat(3)=array_fr(np+3)*hh
            Cmat(2)=array_fr(np+4)*hh
           end if
           np=np1+8*ka+(neg+1)*2
           do i=1,4
            sFourier(i)=array_fr(np+i)
           end do
           B(1)=Cmat(1)*sFourier(1)+Cmat(3)*sFourier(2) 
           B(2)=Cmat(2)*sFourier(1)+Cmat(4)*sFourier(2)
           B(3)=Cmat(1)*sFourier(3)+Cmat(3)*sFourier(4)
           B(4)=Cmat(2)*sFourier(3)+Cmat(4)*sFourier(4)
c          g2r=(G_mju)*sqrt(rho)
c          (11 12)  ( 1 3 )      column fortran convention C= A*B
c          (21 22)  ( 2 4 )
c          g2r(4,-maxn:maxn)    symmetric

           if(dowa)then
            hc=B(2)
            B(1)=conjg(B(1))
            B(2)=conjg(B(3))
            B(3)=conjg(hc)
            B(4)=conjg(B(4))
           end if
           i=-neg*ii
           g2r(1,i)=B(1)*SQRO(1)+B(3)*SQRO(2)
           g2r(2,i)=B(2)*SQRO(1)+B(4)*SQRO(2)
           g2r(3,i)=B(1)*SQRO(3)+B(3)*SQRO(4)
           g2r(4,i)=B(2)*SQRO(3)+B(4)*SQRO(4)

          end do  ! neg=-1,1,2
         END DO   ! ka=0,iall


 10      continue
c        -------------lmu2-------------------

c        write(6,'(a,5i6)')'nn,mu2,lay2,ll2,np2=',nn,mu2,lay2,ll2,np2

         hh=wi(lay2,mu2)
         DO ka=0,iall
          ii=ichall(ka)
          do neg=-1,1,2
 
           np=ipos2+8*ii+(neg+1)*2
           if(dowa)then
            Cmat(1)=conjg(array_fr(np+1)*hh)    
            Cmat(4)=conjg(array_fr(np+2)*hh)    
            Cmat(3)=conjg(array_fr(np+4)*hh)
            Cmat(2)=conjg(array_fr(np+3)*hh)
           else
            Cmat(1)=array_fr(np+1)*hh    
            Cmat(4)=array_fr(np+2)*hh    
            Cmat(3)=array_fr(np+3)*hh
            Cmat(2)=array_fr(np+4)*hh
           end if
           np=np2+8*ka+(neg+1)*2
           do i=1,4
            sFourier(i)=array_fr(np+i)
           end do

           B(1)=Cmat(1)*sFourier(1)+Cmat(3)*sFourier(2)
           B(2)=Cmat(2)*sFourier(1)+Cmat(4)*sFourier(2)
           B(3)=Cmat(1)*sFourier(3)+Cmat(3)*sFourier(4)
           B(4)=Cmat(2)*sFourier(3)+Cmat(4)*sFourier(4)

c          rg1=sqrt(rho)*(G_mju)+
           if(.not.dowa)then
            hc=B(2)
            B(1)=conjg(B(1))
            B(2)=conjg(B(3))
            B(3)=conjg(hc)
            B(4)=conjg(B(4))
           end if
c          C=A*B
           i=-neg*ii
           rg1(1,i)=SQRO(1)*B(1)+SQRO(3)*B(2)
           rg1(2,i)=SQRO(2)*B(1)+SQRO(4)*B(2)
           rg1(3,i)=SQRO(1)*B(3)+SQRO(3)*B(4)
           rg1(4,i)=SQRO(2)*B(3)+SQRO(4)*B(4)
 
          end do  ! neg=-1,1,2
         END DO   ! ka=0,iall

         nst=nstorTH12+1
         hsit=0.
         DO nstrob=0,nstrob_order   
          ij=nstrob*nomega/2
          
          mcht=ij+nhyperfine
          do i=0,mcht
           ichstr(i)=i
          end do        
          do i=1,nvch
           ichstr(mcht+i)=mcht+i*(i+1)/2
          end do
          icht=mcht+nvch

          pcr=real(Sexpa(nstrob))*2.0*lmu1sig
          pci=aimag(Sexpa(nstrob))*2.0*lmu1sig         
          DO ka=0,icht
           ii=ichstr(ka)
           i=ii+ij
           j=ii-ij
           hc=rg1(1,i)*g2r(1,j)+rg1(3,i)*g2r(2,j)+
     &        rg1(2,i)*g2r(3,j)+rg1(4,i)*g2r(4,j)
           h1=pcr*real(hc)-pci*aimag(hc)
           i=-ii+ij
           j=-ii-ij
           hc=rg1(1,i)*g2r(1,j)+rg1(3,i)*g2r(2,j)+
     &        rg1(2,i)*g2r(3,j)+rg1(4,i)*g2r(4,j)
           h2=pcr*real(hc)-pci*aimag(hc)
           array_fr(nst+ka)=array_fr(nst+ka)+cmplx(h1,h2)
          END DO 
          nst=nst+icht+1
         END DO    ! nstrob=0,nstrob_order
c        write(6,'(i6,6g12.3)')nn,array_fr(19132)
c--------------------------
        end do     ! nn=1,nn_ne0
        nst=nstorTH12+1
        offspec=0.
        DO nstrob=0,nstrob_order   
         ij=nstrob*nomega/2
c         write(6,'(a,2g15.5)')'  Sexpa=',Sexpa(nstrob)
         mcht=ij+nhyperfine
         do i=0,mcht
          ichstr(i)=i
         end do        
         do i=1,nvch
          ichstr(mcht+i)=mcht+i*(i+1)/2
         end do
         icht=mcht+nvch
        
         trace(0)=real(array_fr(nst))
         DO ka=1,icht
          trace(ka)=real(array_fr(nst+ka))
          trace(-ka)=aimag(array_fr(nst+ka))
         END DO 

c         if(nstrob.ge.1.and.nstrob.le.4) then
c           ncht(nstrob)=icht
c          DO ka=-icht,icht
c            forout(nstrob,ka+icht+1)=trace(ka)
c          end do
c         end if
         nst=nst+icht+1

c        loop over equidistant channels    
         hh=0.
          do i=-mcht+1,mcht-1,2
          hh=hh+trace(i)*2
         end do
         do i=-mcht+2,mcht-2,2
          hh=hh+trace(i)
         end do
         hh=(hh*2.0+trace(-mcht)+trace(mcht))/3.0
c       if(mcht.ne.iall)then          
         do i=0,nvch
          x0 =-ichstr(icht-i+2)        ! -ichstr(icht-i+2)=+ichstr(-icht+i-2)
          x1 =-ichstr(icht-i+1)
          x2 =-ichstr(icht-i)
          ap0(i)= (x1-x2)
          ap1(i)=-(x0-x2)
          ap2(i)= (x0-x1)
          bp0(i)=-(x1**2-x2**2)
          bp1(i)= (x0**2-x2**2)
          bp2(i)=-(x0**2-x1**2)
          cp0(i)= (x1-x2)*x1*x2
          cp1(i)=-(x0-x2)*x0*x2
          cp2(i)= (x0-x1)*x0*x1
        
          det=x0**2*ap0(i)+x0*bp0(i)+cp0(i)
          dx3(i)=(x2**3-x0**3)/3./det
          dx2(i)=-bp1(i)/2./det 
          dx1(i)=ap1(i)/det    
         end do              
        
         do i=2,nvch,2
          k0 =-(icht-i+2)        
          k1 =-(icht-i+1)
          k2 =-(icht-i)
          ap= trace(k0)*ap0(i)+trace(k1)*ap1(i)+trace(k2)*ap2(i)
          bp= trace(k0)*bp0(i)+trace(k1)*bp1(i)+trace(k2)*bp2(i)
          cp= trace(k0)*cp0(i)+trace(k1)*cp1(i)+trace(k2)*cp2(i)
          hh=hh+ap*dx3(i)+bp*dx2(i)+cp*dx1(i)
         end do

         do i=0,nvch-2
          x0 =ichstr(i+mcht)
          x1 =ichstr(i+mcht+1)
          x2 =ichstr(i+mcht+2)
          ap0(i)= (x1-x2)
          ap1(i)=-(x0-x2)
          ap2(i)= (x0-x1)
          bp0(i)=-(x1**2-x2**2)
          bp1(i)= (x0**2-x2**2)
          bp2(i)=-(x0**2-x1**2)
          cp0(i)= (x1-x2)*x1*x2
          cp1(i)=-(x0-x2)*x0*x2
          cp2(i)= (x0-x1)*x0*x1
        
          det=x0**2*ap0(i)+x0*bp0(i)+cp0(i)
          dx3(i)=(x2**3-x0**3)/3./det
          dx2(i)=-bp1(i)/2./det 
          dx1(i)=ap1(i)/det    
         end do              
        
         do i=0,nvch-2,2
          k0=(mcht+i) 
          k1=(mcht+i+1) 
          k2=(mcht+i+2) 
          ap= trace(k0)*ap0(i)+trace(k1)*ap1(i)+trace(k2)*ap2(i)
          bp= trace(k0)*bp0(i)+trace(k1)*bp1(i)+trace(k2)*bp2(i)
          cp= trace(k0)*cp0(i)+trace(k1)*cp1(i)+trace(k2)*cp2(i)
          hh=hh+ap*dx3(i)+bp*dx2(i)+cp*dx1(i)
         end do
         Offspec=Offspec+hh
        END DO    ! nstrob=0,nstrob_order

c         open(unit=8,file='ch8.dat'
c     &            ,status='unknown'
c     &            ,access='sequential'
c     &            ,form='formatted') 
c         open(unit=9,file='ch9.dat'
c     &            ,status='unknown'
c     &            ,access='sequential'
c     &            ,form='formatted') 
c         open(unit=10,file='ch10.dat'
c     &            ,status='unknown'
c     &            ,access='sequential'
c     &            ,form='formatted') 
c         open(unit=11,file='ch11.dat'
c     &            ,status='unknown'
c     &            ,access='sequential'
c     &            ,form='formatted') 

c         do i=1,2*ncht(2)+1
c          write(8,'(i6,8g12.4)')i-ncht(2),forout(2,i)
c          write(9,'(i6,8g12.4)')i,forout(2,i)
c          write(10,'(i6,8g12.4)')i,forout(3,i)
c          write(11,'(i6,8g12.4)')i,forout(4,i)
c         end do 
c         close(unit=8)
c         close(unit=9)
c         close(unit=10)
c         close(unit=11)
c       write(6,'(a,g15.5)')' offspec=',offspec
c       stop
       return
       end
      
c           Cmat(1)=(1.,0)
c           Cmat(4)=(1.,0)
c           Cmat(3)=(0.,0)
c           Cmat(2)=(0.,0)
case 1      2         3      4 
c  16.178 -16.178  -6.8536 +6.8536      = 0.0 (-0.23842E-6)


C    Correlation function of susceptibilities in  layers
      real function corroff(Qz,ksi)
	implicit none
	real*4 ksi,Qz,pi2
        parameter(pi2=6.283185)
	corroff=ksi**2*pi2/(sqrt(1.0+(Qz*ksi)**2))**3
      return
      end

      subroutine offspecular(b_wr,i_approx,mlay,b_sites,b_domain,MAXGRP,
     &                       GEOSTR,roughlay,vkd,lay_domain,
     &                       nstorTH1,nTH2,nstore,nn_ne0,iall,
     &                       nstrob_order,nvch,nhyperfine,nomega,
     &                       SQ,K1,Offspec)
      implicit none
      include 'comglb.for'
      include 'comthe.for'

      logical   b_sites,b_domain
      integer   i_approx,mlay,MAXGRP,GEOSTR,lay_domain,nstorTH1,nTH2,
     &          nstore,nn_ne0,iall,nstrob_order,nvch,nhyperfine,nomega
      real*8    vkd,roughlay,SQ,K1
      dimension b_sites(mlay),b_domain(mlay),
     &          vkd(mlay),roughlay(mlay),GEOSTR(0:2*mlay)
      real      Offspec

      integer   iposlayav,iposlay,ichstr,ichall,indmu,indll,indly,
     &          lmu1,lmu2,maxn4,idumscrd
      real      eta,wi,trace,dumscrd
      complex   chilay,chi_lay,rg1,g2r,
     &          SQRO,Sexpa,cmat,sFourier,
     &          Fourier,cmatav,cmat2,hc
      complex*16 Rmatrix(2,2),Kmatrix(2,2,maxfr2)

      parameter (idumscrd=maxscrd-3-5*maxn-11*maxfr2-maxfr2*maxfr2*2
     &                    -16-128*maxn-66-24-8*maxfr2-16,
     &                    maxn4=4*maxn)
      common/scrd/ichall(0:maxn*2),iposlay(maxfr2,2),ichstr(0:maxn),
     &          indmu(maxfr2),indll(maxfr2),indly(maxfr2),
     &          lmu1(maxfr2*maxfr2),lmu2(maxfr2*maxfr2),
     &          eta(maxfr2),wi(maxfr2,2),
     &          trace(-maxn:maxn),
     &          iposlayav(maxfr2),chilay(maxfr2),
     &          rg1(4,-maxn4:maxn4),g2r(4,-maxn4:maxn4),
     &          SQRO(4),Sexpa(0:32),cmat(4),sFourier(4),
     &          Fourier(2,2,maxfr2),
     &          cmatav(4),cmat2(4),dumscrd(idumscrd)

      integer i,lay,ll,ka,jj,npos,ni,neg,ico
      logical   dowa,b_wr

c      n_approx=1   i_approx=1  diwa 
c      n_approx=2   i_approx=2  dowa
c      n_approx=3   i_approx=3  Born approximation /diwa

       complex  forout(4,-maxn:maxn)
        if(b_wr) then
         open(unit=8,file='ch8.dat'
     &            ,status='unknown'
     &            ,access='sequential'
     &            ,form='formatted')
        end if

        ico=0
        dowa=.false.
        if(i_approx.eq.2) dowa=.true. 

        do ka=0,iall
         jj=ichall(ka)
         do neg=-1,1,2     
          npos=8*jj+(neg+1)*2
          do lay=1,mlay 
           if(b_domain(lay))then     
            ni=iposlayav(lay)+npos

            array_fr(ni+3)=dcmplx(0.0D0,0.0D0)
            array_fr(ni+4)=dcmplx(0.0D0,0.0D0)

            do i=1,4
             Cmatav(i)=array_fr(ni+i)
c            if(lay.eq.1)forout(i,neg*jj)=array_fr(ni+i)
            end do

            chi_lay=chilay(lay)
            if(dowa) then
             hc=Cmatav(3)
             Cmatav(1)=conjg(Cmatav(1))
             Cmatav(3)=conjg(Cmatav(4))
             Cmatav(4)=conjg(hc)
             Cmatav(2)=conjg(Cmatav(2))
             chi_lay=conjg(chilay(lay))
            end if
c           th_22index storage mode
            Kmatrix(1,1,lay)=Cmatav(1)
            Kmatrix(1,2,lay)=Cmatav(3)
            Kmatrix(2,1,lay)=Cmatav(4)
            Kmatrix(2,2,lay)=Cmatav(2)
           else
            Kmatrix(1,1,lay)=chi_lay
            Kmatrix(1,2,lay)=dcmplx(0.0D0,0.0D0)
            Kmatrix(2,1,lay)=dcmplx(0.0D0,0.0D0)
            Kmatrix(2,2,lay)=chi_lay
           end if
          end do


c          if(b_wr)write(8,'(i8,8g12.3))')Cmat

c         write(8,'(10i6)') iposlayav
c          if(b_wr) then
c           write(8,'(2i5)')ka,neg
c           do lay=1,mlay 
c           if(abs(Kmatrix(1,2,lay))+abs(Kmatrix(2,1,lay)).gt.1.e-13)
c     &      write(8,'(4g12.3)') Kmatrix(1,2,lay),Kmatrix(2,1,lay)
c     &                         Kmatrix(2,1,lay),Kmatrix(2,2,lay)
c           end do
c          end if
          if(dowa) then
           call opticN(mlay,b_sites,MAXGRP,GEOSTR,-K1,
     &                Kmatrix,roughlay,vkd,Rmatrix)
           call inv2(Rmatrix,Rmatrix)
           call g_field(mlay,b_sites,b_domain,MAXGRP,GEOSTR,
     &                           K1,SQ,Kmatrix,
     &             roughlay,vkd,Rmatrix,lay_domain,Fourier) 

          else
           call opticN(mlay,b_sites,MAXGRP,GEOSTR,SQ,
     &                Kmatrix,roughlay,vkd,Rmatrix)

           if(i_approx.eq.1)then
            call g_field(mlay,b_sites,b_domain,MAXGRP,GEOSTR,
     &                           SQ,K1,Kmatrix,
     &             roughlay,vkd,Rmatrix,lay_domain,Fourier) 

           else

            call g_phase(mlay,b_domain,MAXGRP,GEOSTR,K1-SQ,
     &                      vkd,lay_domain,Fourier)
           end if 
         end if 
   
c          forout(1,neg*jj)=Fourier(1,1,1)
c         Fourier are only calculated for the point jj and stored
c         one by one ka=0,iall in groups of 2*4 for +-ka
c          write(8,'(2i6)') ka,lay_domain
          do ll=1,lay_domain
           ni=nstorTH1+4*(2*iall+1)*(ll-1)+8*ka+(neg+1)*2
c          stored with fortran convention (later sFourier(1-4))
c        if(b_wr)write(8,'(i8,4g12.3)')ni,Fourier(1,1,ll),Fourier(2,2,ll)
           array_fr(ni+1)=Fourier(1,1,ll)
           array_fr(ni+2)=Fourier(2,1,ll)
           array_fr(ni+3)=Fourier(1,2,ll)
           array_fr(ni+4)=Fourier(2,2,ll)
          end do
         end do    ! ii=0,4,4
        end do     ! ka=iall

        call Gamma_mju(b_wr,dowa,nstorTH1,nTH2,nstore,nn_ne0,iall,
     &              nstrob_order,nvch,nhyperfine,nomega,Offspec)
   
        if(b_wr) then
         close(unit=8)
c         write(6,'(a)') ' ende'
c         read(5,'(a)')
        end if

       return
       end
