      subroutine thstr_relaxhalfintegral(l_jth,cmch,property)
      
c     hyperfine parameters of Hi,DEQ,1/2 relaxation powder 
c     for scalar index of refraction
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return
      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_relaxhalfintegral nameth_as=',nameth_as(:40)
      
       b_return=cmch.eq.'name'
      if(b_return) 
     & property='scalar ref.index(dyn)-halfint'                         !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) property=
     & 'prop=spin_half_refindex_dynamic scal,1 nc_v_a_the=5,13,t'
       if(l_jth.eq.2) property=
     & 'prop=spin_half_refindex_dynamic scal,2 nc_v_a_the=5,9,t'
       if(l_jth.eq.3) property=
     & 'prop=spin_half_refindex_dynamic scal,3 nc_v_a_the=5,14,t'
       b_return=.true.
      end if
      
c     name of this routine
      mthchild=3
      nameth(1)='Kramers doublet (nuclear 3/2->1/2 tr)'
      nameth(2)='crystal field-Kramers doublet (nuclear 3/2->1/2 tr)'
      nameth(3)='crystal field S=5/2 sextet (nuclear 3/2->1/2 tr)'
      if(b_return) return
      
      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=2     ! <=max_nth
       ntheory(1)='scalar refraction index (dynamic,sad)'
       ntheory(2)='scalar refraction index (dynamic,sad-interpol.)'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if
      
      write(nwr,'(2a)') ' **warning** this theory does not ',
     &       'depend on external parameters'
      
      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & 'list=3  seq=2 chth='//chth  
       return
      end if

      if(cmch.ne.'copa') return
      k=1
      do while(strco(k)(:5).ne.'#beg#')
       k=k+1
      end do
      j=k-1
      jc=j+1

c     common/acssptrf/ acssp,gamnat,aISYM,aNPLONG

      strco(j+1)='iset(1-3)                 1    1 '
              ! number of theta values for powder averaging
      strco(j+2)='i_sym                     2    12 '
              ! number of phi values for powder averaging
c     definition of isym (spezified by the calling routine):
c     C4 || z-axis                     C3 || z-axis
c     cubic    isym=11                 cubic     isym=21
c     D4       isym=12                 D3             22
c     D2            13                 C2             23
c     C2            14                 C1             24
c     C1            15                
c     iOM  (i-Omega) number of points, equal weights  dOM=1./iOM
c     np: number of points on 1/48 sphere,  np=2**(iset+1)
     
      j=j+2
      if(l_jth.eq.3) then 
c                 123456789012345678901234567      
       strco(j+1)='temperature              3    4.2 '
       j=j+1
       strco(j+1)='#end#  3  seq'
      else
       strco(j+1)='#end#  3  seq'
      end if
      strco(j+2)='#beg#'
     
      do k=jc,j
       ch132=strco(k)
       call stringlength(ch132,l)
       strco(k)=ch132(:l)//'/'//chth
c      write(6,'(a)') strco(k)(:80)
      end do

c##    intensity and gamnat are defined in  the structure definition routine 
c      thstr_mossbauerf0(l_jth,cmch,property)

c      common/avssptrf/ avssp,intensity,L_width,iso,h0,
c     &                 dq,eta,gml,ax,ay,az,gx,gy,gz
c        iso                   !isomer shift
c        h0                    !overall hyperfine splitting, mm/s
c        dq                    !quadrupole splitting, mm/s
c        eta                   !quadrupole assymetry
c        gml                   !relaxation rate, mm/s (*11.625 MHz)

c        ax      !A-tensor     Delta       D     ! axial splitting    Delta   
c        ay                    V_rhomb     E/D                        V_rhomb
c        az                                cube  ! cubic splitting
c        gx      !g-tensor                 F
c        gy                                alpha ! orientation of Deq 
c        gz                                beta
c                                          gamma
      
      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
c     write(6,'(a,4i4)') ' thstruct05  jm,jh,jc=',jm,jh,jc
      
      
c                    123456789012345678901234567      
      strtm(jm+1,1)='position                , 1 1'
      strtm(jm+1,2)='position of the spectrum'
      strth(jh+1,1)='is_shift           , 0.0  0.0 0.0  0.1'
      strth(jh+1,2)='is_shift                2    1  '
      
      strtm(jm+2,1)='L_broadening            ,# 1 1 '
      strtm(jm+2,2)='Lorentz broadening in units of natural wdths'
      strth(jh+2,1)='L_width              , 0.0  0.0 0.0  0.1'
      strth(jh+2,2)='L_width                 1   1'
c      common/avssptrf/ avssp,
c     &                 intensity,a_Lwidth,iso,h0,
c     &                 dq,eta,ax,ay,az,gx,gy,gz,gml
c                     123456789012345678901234567
       strtm(jm+3,1)='splitting              ,  1 1'
       strtm(jm+3,2)='splitting for 5/2*A_tensor at  crystal site'
       strth(jh+3,1)='splitting[mm/s]         , 3.0  0.0 0.0  0.1'
       strth(jh+3,2)='splitting[mm/s]          3    1 '

       strtm(jm+4,1)='EFG                     ,#  2 2'
       strtm(jm+4,2)='electric field gradient tensor at crystal site'
       strth(jh+4,1)='EFG                 , 0.0  0.0 0.0  0.1'         
       strth(jh+5,1)='eta                 , 0.0  0.0 0.0  0.1'         
       strth(jh+4,2)='EFG                      4   , 1 0'                 
       strth(jh+5,2)='eta                      5   , 0 1'                                    
       jm=jm+4
       jh=jh+5       
       strtm(jm+1,1)='relaxation_rate               , 1 1'
       strtm(jm+1,2)='relaxation rate, mm/s (*11.625 MHz)'
       strth(jh+1,1)='g_relax            ,  0.3  0.0 0.0  0.05'
       strth(jh+1,2)='g_relax                  6    1 '
       jm=jm+1
       jh=jh+1

       if(l_jth.eq.1) then
c                      123456789012345678901234567      
        strtm(jm+1,1)='A_tensor              ,  3 3'
        strtm(jm+1,2)='A_tensor components at crystal site'
        strth(jh+1,1)='ax               , 3.0  0.0 0.0  0.1'
        strth(jh+2,1)='ay               , 2.0 0.0 0.0   0.1'
        strth(jh+3,1)='az               , 1.0 0.0 0.0   0.1 '
        strth(jh+1,2)='ax                       7     1 0 0  '
        strth(jh+2,2)='ay                       8   , 0 1 0 '
        strth(jh+3,2)='az                       9   , 0 0 1 '
      
      
        strtm(jm+2,1)='g_tensor                ,  3 3'
        strtm(jm+2,2)='g_tensor components at crystal site'
        strth(jh+4,1)='gx             , 6.0  0.0 0.0  0.1'
        strth(jh+5,1)='gy             , 4.0  0.0 0.0  0.1'
        strth(jh+6,1)='gz             , 2.0  0.0 0.0  0.1'
        strth(jh+4,2)='gx                      10   1 0 0'
        strth(jh+5,2)='gy                      11   0 1 0'
        strth(jh+6,2)='gz                      12   0 0 1 '
        jm=jm+2
        jh=jh+6
        strtm(jm+1,1)='#end#    13 '
        else if(l_jth.eq.2) then
        strtm(jm+1,1)='crystal_field            ,  2 2'
        strtm(jm+1,2)='crystal_field components D,V at crystal site'
        strth(jh+1,1)='Delta                  , 3.0  0.0 0.0  0.1'
        strth(jh+2,1)='V_rhomb                , 2.0  0.0 0.0  0.1'
        strth(jh+1,2)='Delta                     7     1 0  '
        strth(jh+2,2)='V_rhomb                   8     0 1  '
        jm=jm+1 
        jh=jh+2
        strtm(jm+1,1)='#end#    9 '
       else if(l_jth.eq.3) then
        strtm(jm+1,1)='D_F_tensor            ,  4 4'
        strtm(jm+1,2)='spin Hamiltonian for s=5/2at crystal site'
        strth(jh+1,1)='D[cm-1]                 1.5  0.0 0.0  0.1'
        strth(jh+2,1)='E/D                     0.3  0.0 0.0  0.03'
        strth(jh+3,1)='cube[cm-1]              0.2  0.0 0.0  0.01'
        strth(jh+4,1)='F[cm-1]                 0.1  0.0 0.0  0.01'
        strth(jh+1,2)='D[cm-1]                  7  1 0 0 0'
        strth(jh+2,2)='E/D                      8  0 1 0 0'
        strth(jh+3,2)='cube[cm-1]               9  0 0 1 0'
        strth(jh+4,2)='F[cm-1]                  10 0 0 0 1'

c                      123456789012345678901234567      
        strtm(jm+2,1)='Q_orientation                ,#  3 3'
        strtm(jm+2,2)='orientation of DEq tensor at crystal site'
        strth(jh+5,1)='Q_alpha             , 0.0  0.0 0.0  0.1'
        strth(jh+6,1)='Q_beta              , 0.0  0.0 0.0  0.1'
        strth(jh+7,1)='Q_gamma             , 0.0  0.0 0.0  0.1'
        strth(jh+5,2)='Q_alpha                  11   1 0 0'
        strth(jh+6,2)='Q_beta                   12   0 1 0'
        strth(jh+7,2)='Q_gamma                  13   0 0 1 '
        jm=jm+2
        jh=jh+7
           
       strtm(jm+1,1)='#end#    14 ' 
       end if
       strtm(jm+2,1)='#beg#'

      
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      return
      end

      subroutine thstr_relaxtwostate(l_jth,cmch,property)
      
c     hyperfine parameters of Hi,DEQ,1/2 relaxation powder 
c     for scalar index of refraction
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return
      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_relaxtwostae nameth_as=',nameth_as(:40)
      
       b_return=cmch.eq.'name'
      if(b_return) 
     & property='scalar ref.index(dyn)-twostate'                         !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) property=
     & 'prop=two_state_refindex_dynamic_pert scal,1 nc_v_a_the=10,8,t'
       if(l_jth.eq.2) property=
     & 'prop=two_state_refindex_dynamic_pert scal,2 nc_v_a_the=11,8,t'
       b_return=.true.
      end if
      
c     name of this routine
      mthchild=2
      nameth(1)='two state +H/-H perturbation'
      nameth(2)='two state +H/-H perturbation-B/T'
      if(b_return) return
      
      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=2     ! <=max_nth
       ntheory(1)='scalar refraction index (dynamic,sad)'
       ntheory(2)='scalar refraction index (dynamic,sad-interpol.)'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if
      
      write(nwr,'(2a)') ' **warning** this theory does not ',
     &       'depend on external parameters'
      
      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & 'list=3,5  seq=2 chth='//chth      ! 2+8 constants
       return
      end if

      if(cmch.ne.'copa') return
       k=1
       do while(strco(k)(:5).ne.'#beg#')
        k=k+1
       end do
       j=k-1
       jc=j+1

       if(l_jth.eq.2) then 
c                 123456789012345678901234567      
        strco(j+1)='Treference               1    100.0 '
              ! reference temperature for claculation of magnetization
        j=j+1
       end if
       strco(j+1)='#end#  1   seq1'
       strco(j+2)='#beg#'
      
       do k=jc,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
c       write(6,'(a)') strco(k)(:80)
       end do

c      common/avssptrf/ avssp,intensity,iso,hz1,hz2,
c     &                 dq,t_rate,gam
c        iso                   ! isomer shift
c        hz1                   ! 1/2(hz1+hz2) kG
c        dhz                   ! hz1-hz       kG
c        dq                    ! quadrupole shift, mm/s
c        t_rate                ! relaxation rate, mm/s (*11.625 MHz)
c        pop_ratio             ! population of state 1/population state 2
c        forM(T)               ! for calculation of magnetization(T)
c        ai0                   ! m=0 intensity ratio 1=random
      
      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
c     write(6,'(a,4i4)') ' thstruct05  jm,jh,jc=',jm,jh,jc
      
      
c                    123456789012345678901234567      
      strtm(jm+1,1)='position                , 1 1'
      strtm(jm+1,2)='position of the spectrum'
      strth(jh+1,1)='is_shift           , 0.0  0.0 0.0  0.1'
      strth(jh+1,2)='is_shift                1    1  '
      
c                     123456789012345678901234567
       strtm(jm+2,1)='Hz-field              ,  2 2'
       strtm(jm+2,2)='Hz1 are the fields of the two states '
       strth(jh+2,1)='Hz1[kG]               , 330.0  0.0 0.0  1.0'
       strth(jh+3,1)='Hz2[kG]              , -330.0   0.0 0.0  0.5'
       strth(jh+2,2)='Hz1[kG]                  2    1 0'
       strth(jh+3,2)='Hz2[kG]                  3    0 1'

       strtm(jm+3,1)='quadrupole-shift         ,# 1 1'
       strtm(jm+3,2)='line shift by electric field gradient tensor'
       strth(jh+4,1)='qu[mm/s]               , 0.0  0.0 0.0  0.1'         
       strth(jh+4,2)='qu[mm/s]                 4    1'                  
       jm=jm+3
       jh=jh+4 
       if(l_jth.eq.1)then      
        strtm(jm+1,1)='relaxation_rate          , 2 2'
        strtm(jm+1,2)='relaxation rate, mms (*11.625 MHz)'
        strth(jh+1,1)='rate[mm/s]            0.3  0.0 0.0  0.05'
        strth(jh+2,1)='popratio              1.0  1.0 100.  0.1'
        strth(jh+1,2)='raterelax                5  1  0 '
        strth(jh+2,2)='popratio                 6  0  1 '
        jm=jm+1
        jh=jh+2 
       else
        strtm(jm+1,1)='relaxation_rate          , 1 1'
        strtm(jm+1,2)='relaxation rate, mms (*11.625 MHz)'
        strth(jh+1,1)='rate[mm/s]            0.3  0.0 0.0  0.05'
        strth(jh+1,2)='raterelax                5  1   '

        strtm(jm+2,1)='magnetization          , 2 2'
        strtm(jm+2,2)='magnetic moment and M(T) parameter'
        strth(jh+2,1)='forM(T)               -0.05  0.0 0.0  0.05'
        strth(jh+3,1)='Moment                 2.24  1.0 100.  0.1'
        strth(jh+2,2)='forMofT                  7  1  0 '
        strth(jh+3,2)='Moment                   6  0  1 '
        jm=jm+2
        jh=jh+3 

c       0.0467 *B[kG]cm**-1 ; 0.695*T cm**-1 ; 2.24^=10**4 mu-Bohr*1kG/300K
       end if

       strtm(jm+1,1)='intratio_m0              , 1 1'
       strtm(jm+1,2)='factor intensity delta m=0 (1=random)'
       strth(jh+1,1)='intratio-m0             , 1.0  0.0 0.0  0.1'         
       strth(jh+1,2)='intratio-m0              8    1'                  
       jm=jm+1
       jh=jh+1

       strtm(jm+1,1)='#end#    8 ' 
       strtm(jm+2,1)='#beg#'

      
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      return
      end
      

        subroutine thstr_lines126(l_jth,cmch,property)
c      before theory03      
c     hyperfine parameters of singlet, doublet, and sextet
c     for scalar n(E) refraction index (static)
c     level 3 theory
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(4:4).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_lines  nameth_as=',nameth_as(:40)
 
      b_return=cmch.eq.'name'
      if(b_return)  
     & property='scalar ref.index(stat)-l1 l2 l6'                        !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property='prop=singlet_doublet_sextet scal,1 nc_v_a_the=0,9,t'
       else if(l_jth.eq.2) then
        property='prop=singlet_doublet_sextet scal,2 nc_v_a_the=0,28,t'
       else if(l_jth.eq.3) then
        property='prop=singlet_doublet_sextet scal,3 nc_v_a_the=0,35,t'
       end if
       b_return=.true.
      end if
      
c     names of the theory
      mthchild=3
      nameth(1)='singlet: width, position and intensity'
      nameth(2)='doublet: width, position and intensity'
      nameth(3)='sextet : width, position and intensity'
      if(b_return) return
      
      
      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=2     ! <=max_nth
       ntheory(1)='scalar refraction index (static,sad)'
       ntheory(2)='scalar refraction index (static)'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if
      
      
      if(cmch.ne.'copa') return      

      write(nwr,'(2a)') ' **warning** this theory does not ',
     &       'depend on external parameters'
      k=1
      do while(strco(k)(:5).ne.'#beg#')
       k=k+1
      end do
      jc=k-1
      strco(jc+1)='#end#  0 seq '
      strco(jc+2)='#beg#'
      
c      common/avssptrf/ avssp,
c     &                 intensity,shift,
c     &                 avss(19),fr_int(8),pos(8)     ! 34
      
      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=jm+1
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
c      write(6,'(a,4i4)') ' thstruct03  jm,jh=',jm,jh
      
      if(l_jth.eq.1) then
      
c                     123456789012345678901234567      
       strtm(jm+1,1)='broadening              ,# 2 2 '
       strtm(jm+1,2)='broadening of the lines of the spectrum'
       strth(jh+1,1)='G_width          , 0.0  0.0 0.0  0.1'
       strth(jh+2,1)='L_width          , 0.0  0.0 0.0  0.1'
       strth(jh+1,2)='G_width                 1   1. 0.0  '
       strth(jh+2,2)='L_width                 9   0.0 1.  '
       jm=jm+1
     
       strtm(jm+1,1)='#end#  9 '
       strtm(jm+2,1)='#beg#'
      end if
      
      if(l_jth.eq.2) then
       strtm(jm+1,1)='splitting                ,  2 1'
       strtm(jm+1,2)='splitting of the doublet lines'
       strth(jh+1,1)='splitting        , 0.0  0.0 0.0  0.1'
c      strth(jh+2,1)='dummy           , 0.0  0.0 0.0  0.1'
       strth(jh+1,2)='pos_1                   25    -0.5 '
       strth(jh+2,2)='pos_2                   26     0.5 '
       jm=jm+1
       jh2=jh+2
       jh=jh+1
c                      123456789012345678901234567      
       strtm(jm +1,1)='broadening              ,# 4 4 '
       strtm(jm +1,2)='broadening of the lines of the spectrum'
       strth(jh +1,1)='G_width_1        , 0.0  0.0 0.0  0.1'
       strth(jh +2,1)='L_width_1        , 0.0  0.0 0.0  0.1'
       strth(jh +3,1)='G_width_2        , 0.0  0.0 0.0  0.1'
       strth(jh +4,1)='L_width_2        , 0.0  0.0 0.0  0.1'
       strth(jh2+1,2)='G_width_1               1   1 0 0 0 '
       strth(jh2+2,2)='L_width_1               9   0 1 0 0 '
       strth(jh2+3,2)='G_width_2               2   0 0 1 0 '
       strth(jh2+4,2)='L_width_2               10  0 0 0 1 '
      
       strtm(jm +2,1)='Intensity_frc                ,  2 2'
       strtm(jm +2,2)='intensities fraction of the doublet lines'
       strth(jh +5,1)='fr_int_1         , 0.5  0.0 1.0  0.01'
       strth(jh +6,1)='fr_int_2         , 0.5  0.0 1.0  0.01'
       strth(jh2+5,2)='fr_int_1                17   1 0 '
       strth(jh2+6,2)='fr_int_2                18   0 1 '
       jm=jm+2

       strtm(jm+1,1)='#end#  28 '
       strtm(jm+2,1)='#beg#'
      end if
      
      if(l_jth.eq.3) then
c                     123456789012345678901234567      
       strtm(jm+1,1)='position                ,  6 6'
       strtm(jm+1,2)='position of the lines of the sextet'
       strth(jh+1,1)='rel_pos_1        , 0.0  0.0 0.0  0.1'
       strth(jh+2,1)='rel_pos_2        , 0.0  0.0 0.0  0.1'
       strth(jh+3,1)='rel_pos_3        , 0.0  0.0 0.0  0.1'
       strth(jh+4,1)='rel_pos_4        , 0.0  0.0 0.0  0.1'
       strth(jh+5,1)='rel_pos_5        , 0.0  0.0 0.0  0.1'
       strth(jh+6,1)='rel_pos_6        , 0.0  0.0 0.0  0.1'
       strth(jh+1,2)='rel_pos_1               25   1 0 0 0 0 0 '
       strth(jh+2,2)='rel_pos_2               26   0 1 0 0 0 0 '
       strth(jh+3,2)='rel_pos_3               27   0 0 1 0 0 0 '
       strth(jh+4,2)='rel_pos_4               28   0 0 0 1 0 0 '
       strth(jh+5,2)='rel_pos_5               29   0 0 0 0 1 0 '
       strth(jh+6,2)='rel_pos_6               30   0 0 0 0 0 1 '
       jh=jh+6
       jm=jm+1
      
       strtm(jm+1,1)='G_broadening            ,# 6 6 '
       strtm(jm+1,2)='Gauss broadening of the lines of the spectrum'
       strth(jh+1,1)='G_width_1         , 0.0  0.0 0.0  0.1'
       strth(jh+2,1)='G_width_2         , 0.0  0.0 0.0  0.1'
       strth(jh+3,1)='G_width_3         , 0.0  0.0 0.0  0.1'
       strth(jh+4,1)='G_width_4         , 0.0  0.0 0.0  0.1'
       strth(jh+5,1)='G_width_5         , 0.0  0.0 0.0  0.1'
       strth(jh+6,1)='G_width_6         , 0.0  0.0 0.0  0.1'
       strth(jh+1,2)='G_width_1               1   1 0 0 0 0 0 '
       strth(jh+2,2)='G_width_2               2   0 1 0 0 0 0 '
       strth(jh+3,2)='G_width_3               3   0 0 1 0 0 0 '
       strth(jh+4,2)='G_width_4               4   0 0 0 1 0 0 '
       strth(jh+5,2)='G_width_5               5   0 0 0 0 1 0 '
       strth(jh+6,2)='G_width_6               6   0 0 0 0 0 1 '
       jh=jh+6
       jm=jm+1
 
       strtm(jm+1,1)='L_broadening            ,# 6 6 '
       strtm(jm+1,2)='Lorentz broadening of the lines of the spectrum'
       strth(jh+1,1)='L_width_1        , 0.0  0.0 0.0  0.1'
       strth(jh+2,1)='L_width_2        , 0.0  0.0 0.0  0.1'
       strth(jh+3,1)='L_width_3        , 0.0  0.0 0.0  0.1'
       strth(jh+4,1)='L_width_4        , 0.0  0.0 0.0  0.1'
       strth(jh+5,1)='L_width_5        , 0.0  0.0 0.0  0.1'
       strth(jh+6,1)='L_width_6        , 0.0  0.0 0.0  0.1'
       strth(jh+1,2)='L_width_1               9    1 0 0 0 0 0 '
       strth(jh+2,2)='L_width_2               10   0 1 0 0 0 0 '
       strth(jh+3,2)='L_width_3               11   0 0 1 0 0 0 '
       strth(jh+4,2)='L_width_4               12   0 0 0 1 0 0 '
       strth(jh+5,2)='L_width_5               13   0 0 0 0 1 0 '
       strth(jh+6,2)='L_width_6               14   0 0 0 0 0 1 '
       jh=jh+6
       jm=jm+1      
       strtm(jm+1,1)='Intensity                ,  6 6'
       strtm(jm+1,2)='intensities  of the  sextet'
       strth(jh+1,1)='fr_int_1         , 0.2499  0.0 1.0  0.01'
       strth(jh+2,1)='fr_int_2         , 0.1666  0.0 1.0  0.01'
       strth(jh+3,1)='fr_int_3         , 0.0833  0.0 1.0  0.01'
       strth(jh+4,1)='fr_int_4         , 0.0833  0.0 1.0  0.01'
       strth(jh+5,1)='fr_int_5         , 0.1666  0.0 1.0  0.01'
       strth(jh+6,1)='fr_int_6         , 0.2499  0.0 1.0  0.01'
       strth(jh+1,2)='fr_int_1                17   1 0 0 0 0 0 '
       strth(jh+2,2)='fr_int_2                18   0 1 0 0 0 0 '
       strth(jh+3,2)='fr_int_3                19   0 0 1 0 0 0 '
       strth(jh+4,2)='fr_int_4                20   0 0 0 1 0 0 '
       strth(jh+5,2)='fr_int_5                21   0 0 0 0 1 0 '
       strth(jh+6,2)='fr_int_6                22   0 0 0 0 0 1 '
       jm=jm+1

       strtm(jm+1,1)='#end# 30  '
       strtm(jm+2,1)='#beg#'
      end if
      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do
      return
      end
      
    
      
      
      subroutine thstr_hdeqmiscil(l_jth,cmch,property)
      
c     hyperfine parameters of Hi,DEQ,powder average <rik(j)>
c                             Hi,DEQ, width(1-8)
c                             Hi,DEQ, intensity(1-8),width(1-8)
c     for scalar index of refraction
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character ch132*132,property*132,chth*8,cmch*4,ch16*16
      logical b_return
 
      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_hdeqmiscil  nameth_as=',nameth_as(:40)
      

       b_return=cmch.eq.'name'
      if(b_return) 
     & property='scalar ref.index(stat)-Hi,DEQ'                         !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) property=
     & 'prop=Hi_DEQ_miscellaneous  scal,1 nc_v_a_the=9,29,t'
       if(l_jth.eq.2) property=
     & 'prop=Hi_DEQ_miscellaneous  scal,2 nc_v_a_the=9,29,t'
       if(l_jth.eq.3) property=
     & 'prop=Hi_DEQ_miscellaneous  scal,3 nc_v_a_the=9,29,t'
       b_return=.true.
      end if
      
c     name of this routine
      mthchild=3
      nameth(1)='Hi,DEQ,powder average <rik(j)>'
      nameth(2)='Hi,DEQ, width(1-8) '
      nameth(3)='Hi,DEQ, intensity(1-8),width(1-8) '
c      nameth(4)=' '
      if(b_return) return
      
      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='scalar refraction index (static,sad)'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if
      
      write(nwr,'(2a)') ' **warning** this theory does not ',
     &       'depend on external parameters'

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & ' list=5 seq=2  chth='//chth                  ! 8 constants
       return
      end if

      if(cmch.ne.'copa') return      
      i0=ichar('0')
      chth='th050'//char(l_jth+i0)//'  '
      
      
c      common/avssptrf/ avssp,
c     &                 intensity,shift,                        2
c     &                 w_Gaus(8),w_Lorentz(8),
c     &                 fr_int(8),aH,thetaH,phiH,DEq,eta        29
      
      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
      
c                     123456789012345678901234567
       strtm(jm+1,1)='H_internal              ,# 1 1'
       strtm(jm+1,2)='internal magnetic field at crystal site'
       strth(jh+1,1)='Hi               , 333.0  0.0 0.0  1.0'
       strth(jh+1,2)='Hi                       25   , 1   '
      
       strtm(jm+2,1)='H_direction             ,# 2 2'
       strtm(jm+2,2)='direction of internal magnetic field in the EFG'
       strth(jh+2,1)='thetaH           , 0.0 0.0 0.0   1.0'
       strth(jh+3,1)='phiH             , 0.0 0.0 0.0   1.0 '
       strth(jh+2,2)='thetaH                   26   , 1 0 '
       strth(jh+3,2)='phiH                     27   , 0 1 '
       jm=jm+2
       jh=jh+3
       strtm(jm+1,1)='EFG                     ,# 2 2'
       strtm(jm+1,2)='electric field gradient tensor at crystal site'
       strth(jh+1,1)='EFG              , 0.0  0.0 0.0  0.1'
       strth(jh+2,1)='eta              , 0.0  0.0 0.0  0.1'
       strth(jh+1,2)='EFG                     28   , 1 0'
       strth(jh+2,2)='eta                     29   , 0 1 '
       jm=jm+1
       jh=jh+2
      
      if(l_jth.eq.1) then
       strtm(jm+1,1)='broadening              ,# 2 2'
       strtm(jm+1,2)='broadening of the lines of the spectrum'
       strth(jh+1,1)='L_width         , 0.0  0.0 0.0  0.1'
       strth(jh+2,1)='G_width         , 0.0  0.0 0.0  0.1'
       strth(jh+1,2)='L_width                  9   1 0 '
       strth(jh+2,2)='G_width                  1   0 1 '
       jm=jm+1
       jh=jh+2
       strtm(jm+1,1)='#end#    29 '
       strtm(jm+2,1)='#beg#'
      
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
       return
      end if

      k=1
      do while(strco(k)(:5).ne.'#beg#')
       k=k+1
      end do
      jc=k-1
      strco(jc+1)='offset_line             1 #    0'
               ! offset counter if more than 8 energies 
      strco(jc+2)='#end#     1  seq'
      strco(jc+3)='#beg#'
      do k=jc+1,jc+1
        ch16=strco(k)
        ch132=strco(k)(17:)
        call stringlength(ch132,l)
        strco(k)=ch16//'         '//ch132(:l)//'/'//chth
      end do


      
c                    123456789012345678901234567      
      strtm(jm+1,1)='G_broadening            ,# 8 8 '
      strtm(jm+1,2)='Gauss broadening(8) of lines of the spectrum'
      strth(jh+1,1)='G_width_1        , 0.0  0.0 0.0  0.1'
      strth(jh+2,1)='G_width_2        , 0.0  0.0 0.0  0.1'
      strth(jh+3,1)='G_width_3        , 0.0  0.0 0.0  0.1'
      strth(jh+4,1)='G_width_4        , 0.0  0.0 0.0  0.1'
      strth(jh+5,1)='G_width_5        , 0.0  0.0 0.0  0.1'
      strth(jh+6,1)='G_width_6        , 0.0  0.0 0.0  0.1'
      strth(jh+7,1)='G_width_7        , 0.0  0.0 0.0  0.1'
      strth(jh+8,1)='G_width_8        , 0.0  0.0 0.0  0.1'
      strth(jh+1,2)='G_width_1                1   1 0 0 0 0 0 0 0'
      strth(jh+2,2)='G_width_2                2   0 1 0 0 0 0 0 0'
      strth(jh+3,2)='G_width_3                3   0 0 1 0 0 0 0 0'
      strth(jh+4,2)='G_width_4                4   0 0 0 1 0 0 0 0'
      strth(jh+5,2)='G_width_5                5   0 0 0 0 1 0 0 0'
      strth(jh+6,2)='G_width_6                6   0 0 0 0 0 1 0 0'
      strth(jh+7,2)='G_width_7                7   0 0 0 0 0 0 1 0'
      strth(jh+8,2)='G_width_8                8   0 0 0 0 0 0 0 1 '
      jm=jm+1
      jh=jh+8
      strtm(jm+1,1)='L_broadening            ,# 8 8 '
      strtm(jm+1,2)='Lorentz broadening(8) of lines of the spectrum'
      strth(jh+1,1)='L_width_1        , 0.0  0.0 0.0  0.1'
      strth(jh+2,1)='L_width_2        , 0.0  0.0 0.0  0.1'
      strth(jh+3,1)='L_width_3        , 0.0  0.0 0.0  0.1'
      strth(jh+4,1)='L_width_4        , 0.0  0.0 0.0  0.1'
      strth(jh+5,1)='L_width_5        , 0.0  0.0 0.0  0.1'
      strth(jh+6,1)='L_width_6        , 0.0  0.0 0.0  0.1'
      strth(jh+7,1)='L_width_7        , 0.0  0.0 0.0  0.1'
      strth(jh+8,1)='L_width_8        , 0.0  0.0 0.0  0.1'
      strth(jh+1,2)='L_width_1                9   1 0 0 0 0 0 0 0'
      strth(jh+2,2)='L_width_2                10   0 1 0 0 0 0 0 0'
      strth(jh+3,2)='L_width_3                11   0 0 1 0 0 0 0 0'
      strth(jh+4,2)='L_width_4                12   0 0 0 1 0 0 0 0'
      strth(jh+5,2)='L_width_5                13   0 0 0 0 1 0 0 0'
      strth(jh+6,2)='L_width_6                14   0 0 0 0 0 1 0 0'
      strth(jh+7,2)='L_width_7                15   0 0 0 0 0 0 1 0'
      strth(jh+8,2)='L_width_8                16   0 0 0 0 0 0 0 1 '
      jm=jm+1
      jh=jh+8
                      
c                     123456789012345678901234567      
      if(l_jth.eq.3) then
       strtm(jm+1,1)='Intensity                ,  8 8'
       strtm(jm+1,2)='intensities(8)  of the lines'
       strth(jh+1,1)='fr_int_1         , 0.0277  0.0 1.0  0.01'
       strth(jh+2,1)='fr_int_2         , 0.0555  0.0 1.0  0.01'
       strth(jh+3,1)='fr_int_3         , 0.0833  0.0 1.0  0.01'
       strth(jh+4,1)='fr_int_4         , 0.1111  0.0 1.0  0.01'
       strth(jh+5,1)='fr_int_5         , 0.1388  0.0 1.0  0.01'
       strth(jh+6,1)='fr_int_6         , 0.1666  0.0 1.0  0.01'
       strth(jh+7,1)='fr_int_7         , 0.1944  0.0 1.0  0.01'
       strth(jh+8,1)='fr_int_8         , 0.2222  0.0 1.0  0.01'
       strth(jh+1,2)='fr_int_1                 17    1 0 0 0 0 0 0 0'
       strth(jh+2,2)='fr_int_2                 18    0 1 0 0 0 0 0 0'
       strth(jh+3,2)='fr_int_3                 19    0 0 1 0 0 0 0 0'
       strth(jh+4,2)='fr_int_4                 20    0 0 0 1 0 0 0 0'
       strth(jh+5,2)='fr_int_5                 21    0 0 0 0 1 0 0 0'
       strth(jh+6,2)='fr_int_6                 22    0 0 0 0 0 1 0 0'
       strth(jh+7,2)='fr_int_7                 23    0 0 0 0 0 0 1 0'
       strth(jh+8,2)='fr_int_8                 24    0 0 0 0 0 0 0 1 '
       jm=jm+1
       jh=jh+8
      end if
      strtm(jm+1,1)='#end#  29 '
      strtm(jm+2,1)='#beg#'
      
      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do
      
      return
      end
