       subroutine thstr_mossbauer(l_jth,cmch,property)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission and   Mossbauer resonance reflection theories
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character ch132*132,property*132,chth*8,cmch*4,ch16*16
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y')write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_frmossbauer  nameth_as=',nameth_as(:40)
      
       b_return=cmch.eq.'name'
      if(b_return) 
     & property='Mossbauer radioactive source (distribute)'          
      if(cmch.eq.'prop') then
       property='prop=nocall       nono,0   nc_v_a_the=0,0,0'
       b_return=.true.
      end if
      
c     names of this routine, sequence l_frtheo=1,2,3,...
      mthchild=6    ! <=(max_nth
      nameth(1)  ='Mossbauer transmission_vA'
      nameth(2)  ='Mossbauer transmission_vB'
      nameth(5)  ='Mossbauer reemission_vA'
      nameth(6)  ='Mossbauer reemission_vB'
      nameth(3)  ='Mossbauer transmission_vC'
      nameth(4)  ='Mossbauer transmission_vD'
c     nameth(7)  ='Mossbauer resonance reflection'
      if(b_return) return
      
      
      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='Mossbauer radioactive source'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if


      if(cmch.ne.'copa') return
c   common/acstrf/acsp,uthick_w,dum,flag_misfit,unit_chi,channels,vm_SC,convol,
c  &              th_dum,drive_mode,channels_vmax,flag_basis,
c  &              om_samp,Dsource,Dabsorber,
c  &              sc2absorber,sc2aperture,dumcs(icstrf-17)
c  from  handbook=nucleus.hdb:  uthick_w
c-------------------------------------------------------
c          include constant, no ask
c     #    include constant ask [n]
c     # y  include constant ask [y]
c     ##   from data file, ask [n]
c     ## y from data file, ask [y]
c     ##n  from data file, no ask
c--------------------------------------------------------
      
      k=1
      do while(strco(k)(:5).ne.'#beg#')
c       write(6,'(i2,2x,a)')k,strco(k)(:60)
       k=k+1
      end do
      j=k-1
      jb=j+1

      strco(j+1)='vm_SC                   5     0.0'
c               ! value of source splitting'
c                 >0  gt absorber splitting
c                 =0  single line source
c                 <0  lt absorber splitting
      
      strco(j+2)='i_convol                6     128 '
                  ! limits of convolution integrals +/- 128
      
      strco(j+3)='nu_channels             4    ##n 1024 '
                ! channel number of the spectrum
      strco(j+4)='channels_vmax           9    ## y  256  '
                ! period of the drive unit
      strco(j+5)='drive_mode              8    ## y 1 '
                ! determines function for channel to velocity scale
      strco(j+6)='flag_misfit             2        0 '
                ! determines function for channel to velocity scale
      j=j+6
      if(l_nfrtheo.eq.5) then
c                 1                  012345
       strco(j+1)='unit_chi                3     1.0e-6 '
                ! susceptibility multiplied by
       strco(j+2)='flag_basis              10     1 '
                ! 1/0 : circular/linear basis 
       j=j+2
      end if
            
      strco(j+1)='#end#  10    seq1'
      strco(j+2)='#beg#'

      do k=jb,j
        ch16=strco(k)
        ch132=strco(k)(17:)
        call stringlength(ch132,l)
        strco(k)=ch16//'         '//ch132(:l)//'/'//chth
c       write(6,'(a)') strco(k)(:80)
      end do
      
      
c------------------------------------------------------------------------
c     variables of frame theory: source,absorber and detector orientation
c      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,
c     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
c     &        Daperture,d_absorber,d_source
      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
      
      strtm(jm+1,1)='baseline                   1 1'
      strtm(jm+1,2)='(1) parameter base line '
      strth(1,1)='base            , 100000.0  0.0 0.0 10.0'     ! baseline
      strth(1,2)='base                    2    , 1 '
c                 1        0         012345
      strtm(jm+2,1)='source                  , ##  1 1'
      strtm(jm+2,2)='(1) parameter f_factor of the source'
      strth(2,1)='f_source        , 0.70  0.0  1.0  0.02'        !
      strth(2,2)='f_source                1    , 1  '        !
      
      strtm(jm+3,1)='background              , ## n 1 1'
      strtm(jm+3,2)='(1) parameter back ground fraction of the source'
      strth(3,1)='bg_fraction     , 0.2  0.0  1.0  0.01'
      strth(3,2)='bg_fraction             3    , 1 '
      jh=jh+3
      jm=jm+3

      strtm(jm+1,1)='geometry                , ## 1 1'
      strtm(jm+1,2)='(1) parameter geo=v_max**2/2bF'
      strth(jh+1,1)='geo              ,  0.000e-4   0.0 0.0 0.1'    
      strth(jh+1,2)='geo              ,      10     , 1 '  
      jm=jm+1
      jh=jh+1

      strtm(jm+1,1)='calibration                ,## n 2 2'
      strtm(jm+1,2)='(2) parameters for calibration v_max,channel_v0'
      strth(jh+1,1)='v_max             ,  8.0   0.0 0.0 0.05 '  !
      strth(jh+2,1)='channel_v0        , 256.0  0.0 0.0 0.1 '   ! channel_v0
      strth(jh+1,2)='v_max                   4     , 1 0'
      strth(jh+2,2)='channel_v0              5     , 0 1 '
      jh=jh+2
      strtm(jm+2,1)='non_linearity                ,## y 4 4'
      strtm(jm+2,2)='(4) non linearity parameters for calibration'
      strth(jh+1,1)='vmax2            , 0.0   0.0 0.0 0.05 '   !
      strth(jh+2,1)='vphase2          , 256.0  0.0 0.0 0.1 '   ! phase shift2
      strth(jh+3,1)='vmax3            , 0.0   0.0 0.0 0.05 '  !
      strth(jh+4,1)='vphase3          , 256.0  0.0 0.0 0.1 '   ! phase shift3
      strth(jh+1,2)='vmax2                   6     1 0 0 0 '
      strth(jh+2,2)='vphase2                 7     0 1 0 0 '
      strth(jh+3,2)='vmax3                   8     0 0 1 0 '
      strth(jh+4,2)='vphase3                 9     0 0 0 1 '
      jm=jm+2
      strtm(jm+1,1)='#end#  10 '
      strtm(jm+2,1)='#beg#'
      
      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

            
      return
      end


      subroutine thstr_aperture(l_jth,cmch,property)

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
 
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_aperture nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return) 
     & property='Mossbauer geometry'                         !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property='prop=nocall       nono,0  nc_v_a_the=5,3,t'
       else if(l_jth.eq.2) then
        property='prop=nocall       nono,0  nc_v_a_the=5,3,t'
       else if(l_jth.ge.3)then
        property='prop=nocall       nono,0   nc_v_a_the=5,3,t'
       end if
       b_return=.true.
      end if

c     names of this routine
      mthchild=4    ! <=max_nth 
      nameth(1)='source-absorber distance=large'
      nameth(2)='cos smearing & aperture effect'
      nameth(3)='extended source'
      nameth(4)='missalignment: point source-absorber-detector'
c      nameth(5)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=6    ! <=max_nth
       ntheory(1)='Mossbauer transmission_vA_0'
       ntheory(2)='Mossbauer transmission_vB_0'
       ntheory(3)='Mossbauer reemission_vA_0'
       ntheory(4)='Mossbauer reemission_vB_0'
       ntheory(5)='Mossbauer transmission_vC_0'
       ntheory(6)='Mossbauer transmission_vD_0'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if


      if(cmch.ne.'copa') return
c      common/acstrf/acsp,uthick_w,dum(2),unit_chi,channels,vm_SC,convol,
c     &              th_dum,drive_mode,channels_vmax,flag_basis,
c     &              om_samp,dsource,dabsorber,
c     &              sc2absorber,sc2aperture

      j=1
      do while(strco(j)(:5).ne.'#beg#')
       j=j+1
      end do
      j=j-1
      jc=j+1
      if(l_jth.eq.1) then
       strco(j+1)='N_om_samp               1    #n  0 '
       j=j+1
      end if
      if(l_jth.gt.1) then
       strco(j+1)='N_om_samp               1   ## n  0 '
                ! determines function for channel to velocity scale
       strco(j+2)='sc-aperture             5   ## n  10.0'
                ! distance source to aperture/detector
       strco(j+3)='Dabsorber               3   ## n  2.0'
                ! diameter of the absorber
       strco(j+4)='sc-absorber             4   ## n  5.0'
                ! distance source to absorber
        j=j+4
      end if

      if(l_jth.eq.3)then
       strco(j+1)='Dsource                 2   ## y  0.0'
                ! diameter of the source (point source 0.0)
       j=j+1
      end if
   
      strco(j+1)='#end#  5  seq1'
      strco(j+2)='#beg#'

      do k=jc,j
       ch132=strco(k)
       call stringlength(ch132,l)
       strco(k)=ch132(:l)//'/'//chth
c       write(6,'(a)') strco(k)(:80)
      end do

      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1

c     variables of frame theory: source,absorber and detector orientation
c      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,
c     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
c     &        Daperture,d_absorber,d_source

c                    1                  012345
      if(l_jth.gt.1) then 
       strtm(jm+1,1)='Daperture               ,## n   1 1'
       strtm(jm+1,2)='(1) diameter Daperture of the detector'
       strth(jh+1,1)='Daperture        ,  2.00        0.0 0.0 0.1'  
       strth(jh+1,2)='Daperture        ,       1     , 1' 
       jh=jh+1
       jm=jm+1
      end if
      if(l_jth.eq.5) then 
       strtm(jm+1,1)='misalign               , ## n 2 2'
       strtm(jm+1,2)='(2) misalignmernt of absorber/source'
       strth(jh+1,1)='d_absorber          0.00        0.0 0.0 0.1'
       strth(jh+2,1)='d_source            0.00        0.0 0.0 0.1'
       strth(jh+1,2)='d_absorber               2     , 1 0'
       strth(jh+2,2)='d_source                 3     , 0 1'
       jh=jh+2
       jm=jm+1 
      end if

      strtm(jm+1,1)='#end#    3  seq'
      strtm(jm+2,1)='#beg#'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

      property=nameth(l_jth)
      return
      end

