      subroutine thstr_synsource(l_jth,cmch,property)

c     case time domain spectrum,
c          time integral - rocking curve
c          prompt - rocking curve
c     for  Synchrotron reflection

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for' 

      character property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_synsource  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='Synchrotron source (distribute)'       
      if(cmch.eq.'prop') then
       property='prop=nocall       nono,0   nc_v_a_the=0,0,0'
      end if

c     name of this routine
      mthchild=3
      nameth(1)='Nuclear forward scattering'
      nameth(2)='X-ray specular reflection'      
      nameth(3)='X-ray offspecular reflection'
      nameth(4)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=(max_nth
       ntheory(1)='Synchrotron source'
       do k= 1,mthparent
         if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      return
      end

      subroutine thstr_syntransmission(l_jth,cmch,property)
c     time domain spectrum for synchrotron transmission
c     level 0 theory

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_syntransmission  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='Nuclear forward scattering (distribute)' 
      if(cmch.eq.'prop') then
       property='prop=nocall       nono,0   nc_v_a_the=14,1,0 '
       b_return=.true.
      end if

c     name of this routine
      mthchild=1
      nameth(1)='time differential transmission spectrum'
      nameth(2)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='Nuclear forward scattering'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb '//
     &        'list=1  seq=2 chth='//chth
       return
      end if

      if(cmch.eq.'copa') then
       j=1
       do while(strco(j)(:5).ne.'#beg#')
        j=j+1
       end do
       j=j-1
       jc=j+1
      
c      common/acstrf/ acsp,wavelength,uthick,            
c     &               unit_chi,                                        1
c     &               aiT_max,v_max,ak_extension,                      4
c     &               T_bunch,scale,                                   6
c     &               channels,ch_angle,graz_beg,graz_end,            10
c     &               t0_norm,flag_basis                              12

       strco(j+1)='i_T_max                 2     0 '
                ! Time window for display
       strco(j+2)='v_max [mm/s]            3     8 '
                ! v_max of the nuclear energies
       strco(j+3)='k_extension 2**k        4     0 '
                ! times v_max
       j=j+3
       strco(j+1)='T0_NormInt              11    10'
                 ! integration for normalizing from t0
       strco(j+2)='T_bunch                 5    ## y 160'
                 ! bunch distance in ns
       strco(j+3)='nu_channels             7    ##n 256'
                ! number of channels for for angles
       strco(j+4)='scale                   6    ## y 1'
                ! determines function for channel to time conversion
       strco(j+5)='flag_basis              12     1 '
                 ! switch for circular-linear basis 
       j=j+5
       strco(j+1)='#end#  12  seq1'
       strco(j+2) ='#beg#'

       do k=jc,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
c        write(6,'(a)') strco(k)(:80)
       end do

       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
        k=k+1
       end do
       jm=k-1
       jmb=k
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
        
c      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta,
c                      t_shif
        
        strtm(jm+1,1)='calibration               ,## y 1 1'
        strtm(jm+1,2)='frame parameter t_shift'
        strth(jh+1,1)='t_shift           , 0.0 0.0 0.0 0.1'
        strth(jh+1,2)='t_shift                 1     1  '
        
        strtm(jm+2,1)='#end#    1 '
        strtm(jm+3,1)='#beg#'
        jm=jm+3
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if
      return
      end

      subroutine thstr_synreflection(l_jth,cmch,property)

c     case time domain spectrum,
c          time integral - rocking curve
c          prompt - rocking curve
c     for  Synchrotron reflection

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      integer l_jth
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_synreflection  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='X-ray specular reflection (distribute)'   
      if(cmch.eq.'prop') then

       if(l_jth.lt.5)then 
        property='prop=nocall       nono,0   nc_v_a_the=16,4,0'
       else  
        property='prop=nocall       nono,0   nc_v_a_the=16,5,0'
       end if

       b_return=.true.
      end if

c     name of this routine
      mthchild=5
      nameth(1)='time differential reflection spectrum'
      nameth(2)='time integral - rocking curve-Fourier'
      nameth(3)='time integral - rocking curve'
      nameth(4)='time integral - rocking curve_fi'
      nameth(5)='prompt - rocking curve'
      nameth(6)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=(max_nth
       ntheory(1)='X-ray specular reflection'
       do k= 1,mthparent
         if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb '//
     &        'list=2  seq=2 chth='//chth    ! list=2 constant uthick
       if(l_jth.eq.5)nstruct=' '             ! no handbook constant
       return
      end if 

      if(cmch.ne.'copa') return
      j=1
      do while(strco(j)(:5).ne.'#beg#')
       j=j+1
      end do
      j=j-1
      jc=j+1

c      common/acstrf/acsp,wavelength,uthick,                ! from hdb
c     &              unit_chi,aiT_max,v_max,                           ! 3
c     &              ak_extension,T_bunch,scale,channels,              ! 7
c     &              ch_angle,graz_beg,graz_end,t0_norm,flag_basis,    ! 12
c     &              th_channels,th_sampling,                          ! 14
c     &              strob_order,omega,dumcsp(icstrf-19)

c      synmos
c      common/acstrf/acsp,wavelength,uthick,unit_chi,dumcsp(icstrf-4)
c      synrock
c      common/acstrf/acsp,wavelength,uthick_A,
c     &              unitchi,dum6(6),ch_angle,graz_beg,graz_end,
c     &              dumcsp(icstrf-8)

c                  1                  012345
      if(l_jth.eq.4) then
       strco(j+1)='vmax_hypf[mm/s]          3     8 '
                ! v_max of the nuclear energies
       strco(j+2)='nch_hypf                 13       64'
                ! v_max/nch_hypf =schrw    stepwidth
       strco(j+3)='nch_TH                   4       1024'
                ! +-channels to be calculated for index of refraction
       strco(j+4)='T_bunch                  5  ## y 24'
                 ! bunch distance in ns
       j=j+4
      end if

      if(l_jth.eq.3) then
       strco(j+1)='v_max [mm/s]            3    25 '
                ! v_max of the nuclear energies
       strco(j+2)='th_channels            13    126'
                ! 2**th_sampling <=8 ; 1 means maximal accuracy 
       strco(j+3)='th_sampling            14     3 '
                ! 2**th_sampling <=8 ; 1 means maximal accuracy 
       strco(j+4)='T_bunch                 5  ## y 176'
                 ! bunch distance in ns
       j=j+4
      end if

      if(l_jth.le.2) then
       strco(j+1)='i_T_max                 2     0 '
                ! Time window for calculation
       strco(j+2)='v_max [mm/s]            3     8 '
                ! v_max of the nuclear energies
       strco(j+3)='k_extension 2**k        4     0 '
                ! times v_max
       j=j+3
      end if

      if(l_jth.eq.1) then
       strco(j+1)='T0_NormInt              11    10'
                 ! integration for normalizing from t0
       strco(j+2)='T_bunch                 5    ## y 160'
                 ! bunch distance in ns
       strco(j+3)='nu_channels             7    ##n 256'
                ! number of channels for for angles
       j=j+3
      end if

      if(l_jth.eq.2.or.l_jth.eq.3.or.l_jth.eq.4) then
       strco(j+1)='nu_angle                 8       128 '
       strco(j+2)='graz_begin               9    ## 3  '
       strco(j+3)='graz_end                10    ## 20 '
       strco(j+4)='nu_channels              7    ##n 128 '
                ! number of channels for  angles
       j=j+4
      end if
      if(l_jth.eq.2) then
       strco(j+1)='T0_Integral             11    10'
                 ! integration probability of delayed events from t0
       strco(j+2)='T_bunch                 5  ## y 176'
                 ! bunch distance in ns
       j=j+2
      end if
      if(l_jth.le.4) then
       strco(j+1)='flag_basis              12     1 '
                 ! switch for circular-linear basis 
       j=j+1
      end if
      

      if(l_jth.eq.5) then
c      one handbook constant less -> position number higher by 1
       strco(j+1)='nu_angle                 9       128 '
       strco(j+2)='graz_begin              10    ## 3  '
       strco(j+3)='graz_end                11    ## 20 '
       strco(j+4)='nu_channels              8    ##n 128 '
                ! number of channels for  angles
       strco(j+5)='scale                    7    ## y 1'
                ! determines function for channel to time conversion
       strco(j+6)='unit_chi                 2     1.0e-6 '
                ! susceptibility multiplied by
       j=j+6
      else

       strco(j+1)='scale                   6    ## y 1'
                ! determines function for channel to time conversion
       strco(j+2)='unit_chi                1     1.0e-6 '
                ! susceptibility multiplied by
       j=j+2
      end if

      strco(j+1)='#end#  14  seq1'
      strco(j+2)='#beg#'

      do k=jc,j
       ch132=strco(k)
       call stringlength(ch132,l)
       strco(k)=ch132(:l)//'/'//chth
c       write(6,'(a)') strco(k)(:80)
      end do


      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1

c      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta,
c                      ang_shift(t_shift),graz_angle(graz_min),phi_z,
c                      detekt_eff,counts_bunch

c                    1                  012345
      if(l_jth.eq.1) then
       strtm(jm+1,1)='calibration               ,## y 1 1'
       strtm(jm+1,2)='frame parameter t_shift'
       strth(jh+1,1)='t_shift           , 0.0 0.0 0.0 0.1'
       strth(jh+1,2)='t_shift                  1     1  '

       strtm(jm+2,1)='orientation                ## y 2 2'
       strtm(jm+2,2)='(2) grazing angle of the scatterer'
       strth(jh+2,1)='graz_angle        , 5.0 0.0 0.0   1.0'
       strth(jh+3,1)='phi_z             , 0.0  0.0 0.0  1.0'
       strth(jh+2,2)='graz_angle                2    1 0 '
       strth(jh+3,2)='phi_z                     3    0 1 '
       jm=jm+2
       jh=jh+3
      end if

      if(l_jth.gt.1) then
       strtm(jm+1,1)='calibration               ,## y 1 1'
       strtm(jm+1,2)='frame parameter angle shift'
       strth(jh+1,1)='ang_shift           0.0 0.0 0.0 0.1'
       strth(jh+1,2)='ang_shift               1     1  '

       strtm(jm+2,1)='orientation                ##  y 2 2'
       strtm(jm+2,2)='phi_z, graz_min of the scatterer plane'
       strth(jh+2,1)='graz_min            1.0  0.0 0.0  0.01'
       strth(jh+3,1)='phi_z               0.0  0.0 0.0  1.0'
       strth(jh+2,2)='graz_min                  2    1 0'
       strth(jh+3,2)='phi_z                     3    0 1'
       jm=jm+2
       jh=jh+3
      end if
      strtm(jm+1,1)='#end#    3  seq'

      if(l_jth.eq.5) then
       strtm(jm+1,1)='deadtime                 ,## y 2 2'
       strtm(jm+1,2)='frame parameter detekt_eff,counts_bunch'
       strth(jh+1,1)='detekt_eff             , 0.9 0.0 0.0 0.1'
       strth(jh+2,1)='counts_bunch           , 1.0 0.0 0.0 0.1'
       strth(jh+1,2)='detekt_eff                4     1 0 '
       strth(jh+2,2)='counts_bunch              5     0 1 '
       jm=jm+1
       strtm(jm+1,1)='#end#    5  seq'
      end if
      strtm(jm+2,1)='#beg#'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

      property=nameth(l_jth)
      return
      end


      subroutine thstr_synoffspec(l_jth,cmch,property)


      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_synreflection  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='X-ray offspecular reflection (distribute)'   
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) 
     & property='prop=nocall       nono,0   nc_v_a_the=17,1,0'
       b_return=.true.
      end if

c     name of this routine
      mthchild=1
      nameth(1)='time integral - offspecular'
      nameth(2)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=(max_nth
       ntheory(1)='X-ray offspecular reflection'
       do k= 1,mthparent
         if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb '//
     &        'list=2  seq=1 chth='//chth
       return
      end if 


      if(cmch.ne.'copa') return
      j=1
      do while(strco(j)(:5).ne.'#beg#')
       j=j+1
      end do
      j=j-1
      jc=j+1

c      common/acstrf/acsp,wavelength,uthick,              2  from nucleus.hdb
c     &              unit_chi,aiT_max,v_max,                               3
c     &              nch_TH,T_bunch,scale,channels,columns,                8
c     &              strob_order,t1_window,t2_window,flag_basis,           12
c     &              th_channels,DWBA                                      14

c                  1                  012345
       strco(j+1)='vmax_hypf[mm/s]          3     8 '
                ! v_max of the nuclear energies
       strco(j+2)='nch_hypf                 13       64'
                ! v_max/nch_hypf =schrw    stepwidth
       strco(j+3)='nch_TH                   4       1024'
                ! +-channels to be calculated for index of refraction
       strco(j+4)='nu_channels              7    ##n 1024 '
                ! number of angular pairs
       j=j+4
       strco(j+1)='n_strob_order            9         9'
       strco(j+2)='t1_window                10    ##  1.97 '
       strco(j+3)='t2_window                11    ##  21.63'
       j=j+3
       strco(j+1)='show_angles              14    ##   0 '
       strco(j+2)='Approximation            15    ##   0 '
       strco(j+3)='flag_basis               12    ##   0 '
       j=j+3
       strco(j+1)='T_bunch                  5     ## y 23.6'
                 ! bunch distance in ns
       strco(j+2)='unit_chi                 1     1.0e-6 '
                ! susceptibility multiplied by
      j=j+2

      strco(j+1)='#end#  15  seq1'
      strco(j+2)='#beg#'

      do k=jc,j
       ch132=strco(k)
       call stringlength(ch132,l)
       strco(k)=ch132(:l)//'/'//chth
c       write(6,'(a)') strco(k)(:80)
      end do



      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1

c      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta,
c                      ang_shift(t_shift)

c                    1                  012345
       strtm(jm+1,1)='calibration               ,## y 1 1'
       strtm(jm+1,2)='frame parameter angle shift'
       strth(jh+1,1)='ang_shift           0.0 0.0 0.0 0.1'
       strth(jh+1,2)='ang_shift               1     1  '

       jm=jm+1
       jh=jh+1
      strtm(jm+1,1)='#end#    1  seq'
      strtm(jm+2,1)='#beg#'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

      property=nameth(l_jth)
      return
      end



      subroutine thstr_offspeccorrelation(l_jth,cmch,property)

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
 
      character property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_offspeccorrelation  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return) 
     & property='offspecular correlation matrix'                               !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     &  'prop=offspecular_correlation_matrix  nono,1   nc_v_a_the=0,1,t'
       else if(l_jth.eq.2)then
        property=
     &  'prop=offspecular_correlation_matrix  nono,2   nc_v_a_the=0,1,t'
       end if
       b_return=.true.
      end if

c     names of this routine
      mthchild=2    ! <=max_nth
      nameth(1)='crosscorrelation'
      nameth(2)='autocorrelation'
      nameth(3)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1    ! <=max_nth
       ntheory(1)='time integral - offspecular_1'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if
 
      if(cmch.ne.'copa') return
  
      property=nameth(l_jth) 
      return
      end

      subroutine thstr_offspeccorrelfunc(l_jth,cmch,property)

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
 
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_offspeccorrelfunc nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return) 
     & property='offspecular correlation function'               !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     & 'prop=offspecular_correlation_function nono,1 nc_v_a_the=1,1,t'
       else if(l_jth.eq.2)then
        property=
     & 'prop=offspecular_correlation_function nono,2  nc_v_a_the=1,1,t'
       end if
       b_return=.true.
      end if

c     names of this routine
      mthchild=2    ! <=max_nth
      nameth(1)='exponential'
      nameth(2)='Lorentzian'
      nameth(3)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=2    ! <=max_nth
       ntheory(1)='crosscorrelation'
       ntheory(2)='autocorrelation'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if


      if(cmch.ne.'copa') return
      j=1
      do while(strco(j)(:5).ne.'#beg#')
       j=j+1
      end do
      j=j-1
      jc=j+1
c     common/acfr1trf/acsp,wavelength,uthick_A
      strco(j+1)='um/Angstroem              1     1.0e4' 
      j=j+1 
      strco(j+1)='#end#  1  seq1'
      strco(j+2)='#beg#'

      do k=jc,j
       ch132=strco(k)
       call stringlength(ch132,l)
       strco(k)=ch132(:l)//'/'//chth
c       write(6,'(a)') strco(k)(:80)
      end do

      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1

c     common/avfr1trf/avfr1,pvfr1,HextA,thetaHeA,phiHeA,
c     &                phiA,thetaA,psiA,

c                    1                  012345
       strtm(jm+1,1)='Lcorrelation           ,    1 1'
       strtm(jm+1,2)='correlation length inside layer'
       strth(jh+1,1)='cor_length[um]        4.8 0.0 0.0 0.1'
       strth(jh+1,2)='cor_length                1     1  '

       jm=jm+1
       jh=jh+1
      strtm(jm+1,1)='#end#    1  seq'
      strtm(jm+2,1)='#beg#'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

      property=nameth(l_jth)
      return
      end

      subroutine thstr_scanmode(l_jth,cmch,property)

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
 
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_scanmode  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return) 
     & property='offspecular scanmodes'                               !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property='prop=offspecular_scanmode  nono,1  nc_v_a_the=6,0,t'
        else if(l_jth.eq.2)then
        property='prop=offspecular_scanmode  nono,2  nc_v_a_the=6,0,t'
        else if(l_jth.eq.3)then
        property='prop=offspecular_scanmode  nono,3  nc_v_a_the=6,0,t'
        else if(l_jth.eq.4)then
        property='prop=offspecular_scanmode  nono,4  nc_v_a_the=6,0,t'
        else if(l_jth.eq.5)then
        property='prop=offspecular_scanmode  nono,5  nc_v_a_the=6,0,t'
       end if
       b_return=.true.
      end if

c     names of this routine
      mthchild=5    ! <=max_nth
      nameth(1)='detector scan'
      nameth(2)='omega scan'
      nameth(3)='omega scan-3d'
      nameth(4)='theta1-theta2 scan-3d'
      nameth(5)='parallel to specular'
      nameth(6)=''

      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='time integral - offspecular_0'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if


      if(cmch.ne.'copa') return
      i0=ichar('0')
      chth='th170'//char(l_jth+i0)//'  '
c      common/acstrf/acsp,wavelength,uthick,
c     &              unit_chi,aiT_max,v_max,
c     &              ak_extension,T_bunch,scale,channels,
c     &              strob_order,t1_window,t2_window,DWBA,flag_basis,
c     &              th_channels,th_sampling, 
c      for different set appearing in acmaps of  subroutine  th_scanmode
c     &              omega,n_theta,theta_begin,theta_end,
c     &              an_omega,omega_begin,omega_end,
c     &              omega,n_theta,theta_begin,n2theta,theta2_begin,theta2_end
c     &              n_theta,theta_begin,theta_end,

      k=1
      do while(strco(k)(:5).ne.'#beg#')
       k=k+1
      end do
      jb=k
      jc=k-1
     
      if(l_jth.eq.1) then
c                   standard time window
       strco(jc+1)='n_omega                 1      10'
       strco(jc+2)='omega_begin             2      0.1'
       strco(jc+3)='omega_end               3      15.0'
       strco(jc+4)='n_theta                 4  ##n   5'
       strco(jc+5)='theta_begin             5  ##n   10.0'
       strco(jc+6)='delta_theta             6  ##n   1.0'
       strco(jc+7)='#end#     6  seq'
       strco(jc+8)='#beg#'
       je=jc+6 
      end if
      if(l_jth.eq.2) then
c             omega scan
       strco(jc+1)='n_omega                 1      10'
       strco(jc+2)='omega_begin             2      0.1'
       strco(jc+3)='n2theta                 4  ##n   2'
       strco(jc+4)='2theta_begin            5  ##n   13.75'
       strco(jc+5)='delta_theta             6  ##n   1.0'
       strco(jc+6)='#end#     6  seq'
       strco(jc+7)='#beg#'
       je=jc+5
      end if
      if(l_jth.eq.3) then
c             omega scan
       strco(jc+1)='n_omega                 1      10'
       strco(jc+2)='omega_begin             2      0.1'
       strco(jc+3)='n2theta                 4     2'
       strco(jc+4)='2theta_begin            5     13.75'
       strco(jc+5)='delta_theta             6     1.0'
       strco(jc+6)='#end#     6  seq'
       strco(jc+7)='#beg#'
       je=jc+5
      end if
      if(l_jth.eq.4) then
c             theta1-2 scan
       strco(jc+1)='ntheta1                 1     5'
       strco(jc+2)='theta1_begin            2     10.666'
       strco(jc+3)='theta1_end              3     17.109'
       strco(jc+4)='ntheta2                 4     6'
       strco(jc+5)='theta2_begin            5     12.046'
       strco(jc+6)='theta2_end              6     19.374'
       strco(jc+7)='#end#     6  seq'
       strco(jc+8)='#beg#'
       je=jc+6 
      end if
      if(l_jth.eq.5) then
c        parallel to specular scan
       strco(jc+1)='n_omega                 1      10'
       strco(jc+2)='omega_begin             2      0.1'
       strco(jc+3)='omega_end               3      13.0'
       strco(jc+4)='ntheta                  4  ##n   3'
       strco(jc+5)='#end#     6  seq'
       strco(jc+6)='#beg#'
       je=jc+4
      end if

      do k=jb,je
       ch132=strco(k)
       call stringlength(ch132,l)
       strco(k)=ch132(:l)//'/'//chth
      end do

      return
      end

      subroutine thstr_omega(l_jth,cmch,property)

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
 
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_omega  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return) 
     & property='offspecular omegascan'                               !name
      if(cmch.eq.'prop') then
        property='prop=offspecular_omega     nono,1  nc_v_a_the=1,0,t'
       b_return=.true.
      end if

c     names of this routine
      mthchild=1    ! <=max_nth
      nameth(1)='for omega'
      nameth(2)=' '

      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='omega scan'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if


      if(cmch.ne.'copa') return
      i0=ichar('0')
      chth='th170'//char(l_jth+i0)//'  '
c      common/acstrf/acsp,wavelength,uthick,
c     &              unit_chi,aiT_max,v_max,
c     &              ak_extension,T_bunch,scale,channels,
c     &              strob_order,t1_window,t2_window,DWBA,flag_basis,
c     &              th_channels,th_sampling, 
c      for different set appearing in acmaps of  subroutine  th_scanmode
c     &              omega,n_theta,theta_begin,theta_end,
c     &              an_omega,omega_begin,omega_end,
c     &              omega,n_theta,theta_begin,n2theta,theta2_begin,theta2_end
c     &              n_theta,theta_begin,theta_end,

      k=1
      do while(strco(k)(:5).ne.'#beg#')
       k=k+1
      end do
      jb=k
      jc=k-1
     
       strco(jc+1)='c_forome                 1      10'
       strco(jc+2)='#end#     6  seq'
       strco(jc+3)='#beg#'
       je=jc+1 

      do k=jb,je
       ch132=strco(k)
       call stringlength(ch132,l)
       strco(k)=ch132(:l)//'/'//chth
      end do

      return
      end

